/*
 * @(#)Build.java	0.002 1999/11/15
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu;

import java.util.*;
import java.awt.*;
import yuzu.table.*;


class Build  extends Components {
	Build() {
		frame.setIconImage(Icon.getImage());

		setLocale(Locale.getDefault());

		setLabels();

		menu_file_getmail.setIcon(mailgetIcon);
		menu_file_sendmail.setIcon(mailsendIcon);
		menu_file_quit.setIcon(quitIcon);
		menu_edit_copy.setIcon(copyIcon);
		menu_edit_paste.setIcon(pasteIcon);
		menu_edit_allcopy.setIcon(allcopyIcon);
		menu_edit_cut.setIcon(cutIcon);
		menu_set_lang.setIcon(langIcon);
		menu_info_version.setIcon(verIcon);

		menu_file.add(menu_file_getmail);
		menu_file.add(menu_file_sendmail);
		menu_file.addSeparator();
		menu_file.add(menu_file_quit);

		menu_edit.add(menu_edit_copy);
		menu_edit.add(menu_edit_paste);
		menu_edit.add(menu_edit_allcopy);
		menu_edit.addSeparator();
		menu_edit.add(menu_edit_cut);

		groupe_langmenu.add(menu_set_lang_ja);
		groupe_langmenu.add(menu_set_lang_en);
		if (getLocale().equals(Locale.JAPAN)) menu_set_lang_ja.setSelected(true);
		else menu_set_lang_en.setSelected(true);
		menu_set_lang.add(menu_set_lang_ja);
		menu_set_lang.add(menu_set_lang_en);
		menu_set.add(menu_set_lang);

		menu_info.add(menu_info_version);

	    menubar.add(menu_file);
		menubar.add(menu_set );
		menubar.add(menu_edit);
		menubar.add(menu_info);

		frame.setJMenuBar(menubar);

		tree.setContainer(container);
		table.setContainer(container);
		disp.setContainer(container);
		disp.setJFrame(frame);
		disp.setTable(table);
		disp.setTree(tree);
		tree.setJFrame(frame);
		tree.setTable(table);
		tree.setDisp(disp);
		address.setJFrame(frame);
		address.setTable(table);
		address.setDisp(disp);
		table.setJFrame(frame);
		table.setDTree(tree);
		table.setDisp(disp);
		mailgetdialog.setDTree(tree);
		mailgetdialog.setTable(table);
		mailsenddialog.setDTree(tree);
		mailsenddialog.setTable(table);

  		treepane.add(tree, BorderLayout.CENTER);
		tablepane.add(table, BorderLayout.CENTER);
		textpane.add(disp, BorderLayout.CENTER);
		addresspane.add(address, BorderLayout.CENTER);
		splitLeftVer.setTopComponent(treepane);
		splitLeftVer.setBottomComponent(addresspane);
  		splitRightVer.setTopComponent(tablepane);
  		splitRightVer.setBottomComponent(textpane);
  		splitHor.setLeftComponent(splitLeftVer);
  		splitHor.setRightComponent(splitRightVer);
 		pane.add(splitHor, BorderLayout.CENTER);
  	    container.add(pane, BorderLayout.CENTER);
	}

	protected void setLabels() {
		frame.setTitle(getString("Name"));
		menu_file.setLabel(getString("menu_file"));
		menu_file_getmail.setLabel(getString("menu_file_getmail"));
		menu_file_sendmail.setLabel(getString("menu_file_sendmail"));
		menu_file_quit.setLabel(getString("menu_file_quit"));
		menu_edit.setLabel(getString("menu_edit"));
		menu_edit_copy.setLabel(getString("menu_edit_copy"));
		menu_edit_paste.setLabel(getString("menu_edit_paste"));
		menu_edit_allcopy.setLabel(getString("menu_edit_allcopy"));
		menu_edit_cut.setLabel(getString("menu_edit_cut"));
		menu_set.setLabel(getString("menu_set"));
		menu_set_lang.setLabel(getString("menu_set_lang"));
		menu_set_lang_ja.setLabel(getString("menu_set_lang_ja"));
		menu_set_lang_en.setLabel(getString("menu_set_lang_en"));
		menu_info.setLabel(getString("menu_info"));
		menu_info_version.setLabel(getString("menu_info_version"));
	}
}
