/*
 * @(#)Listeners.java	0.002 1999/11/15
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Listeners  extends Build {
	Listeners() {
		menu_edit_paste.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				disp.customPaste();
			}
		});

		menu_edit_copy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				disp.customCopy();
			}
		});

		menu_edit_allcopy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				disp.customAllcopy();
			}
		});

		menu_edit_cut.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				disp.customCut();
			}
		});

		menu_file_getmail.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				if (mailgetdialog.isClosed()) {
					mailgetthread = new Thread(new MailDownload());
					mailgetthread.start();
				}
			}
		});

		menu_file_sendmail.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				if (mailsenddialog.isClosed()) {
					mailsendthread = new Thread(new MailSend());
					mailsendthread.start();
				}
			}
		});

		menu_file_quit.addActionListener(new Closing());

		menu_set_lang_ja.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setLocale(Locale.JAPAN);
				setLabels();
				tree.setLabels();
				table.addFields(tree.getCurrentDir());
				table.setLabels();
				disp.setLabels();
				mailgetdialog.setLabels();
				address.setLabels();
				refresh();
			}
		});

		menu_set_lang_en.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setLocale(Locale.US);
				setLabels();
				tree.setLabels();
				table.addFields(tree.getCurrentDir());
				table.setLabels();
				disp.setLabels();
				mailgetdialog.setLabels();
				address.setLabels();
				refresh();
			}
		});

		menu_info_version.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				Object[] label = new Object[] {
				    "      ",
					"      " + getString("Name"),
					"      " + getString("Version"),
					"      " + getString("Producer"),
					"      ",
					"      " + getString("Copyright")
				};
				JOptionPane.showMessageDialog(container, 
				     label, getString("versionDialog"),
					 JOptionPane.PLAIN_MESSAGE, yuzumark);
			}
		});
	}

	private class MailDownload implements Runnable {
		MailDownload() {}
		
		public void run() {
			mailgetdialog.startDownload();
			mailgetthread.stop();
		}
	}

	private class MailSend implements Runnable {
		MailSend() {}
		
		public void run() {
			mailsenddialog.startSend();
			mailsendthread.stop();
		}
	}
}
