/*
 * @(#)Build.java	0.001 1999/12/27
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.addressbook;

import java.io.*;
import java.awt.*;
import java.util.*;
import javax.swing.tree.*;


class Build extends Components {
	Build() {
 		root.setUserObject( new NodeObject(rootdir,  getString("RootName")));

  		setLabels();

		adddialog.setAddressTree(tree);
		editdialog.setAddressTree(tree);
		infodialog.setAddressTree(tree);

		addNodes(root);
		int limit = root.getChildCount();
		for (int count=0; count<limit; count++) {
			addNodes((DefaultMutableTreeNode)(root.getChildAt(count)));
		}

		menu_file_add.setIcon(addIcon);
		menu_file_info.setIcon(infoIcon);
		menu_file_delete.setIcon(deleteIcon);
		menu_file_rename.setIcon(renameIcon);
		menu_file_move.setIcon(moveIcon);

		menu_file.add(menu_file_add);
		menu_file.addSeparator();
		menu_file.add(menu_file_info);
		menu_file.addSeparator();
		menu_file.add(menu_file_move);
		menu_file.add(menu_file_rename);
		menu_file.addSeparator();
		menu_file.add(menu_file_delete);
		menubar.add(menu_file);
		pane.add(menubar, BorderLayout.NORTH);

		treeRenderer.setLeafIcon(nodeIcon);
		treeRenderer.setClosedIcon(hasNodeIcon);
		treeRenderer.setOpenIcon(openedNodeIcon);
		tree.setCellEditor(treeEditor);
		tree.setEditable(false);
		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		tree.setCellRenderer(treeRenderer);
		tree.putClientProperty("JTree.lineStyle", "Angled");
		tree.setRootVisible(true);
		tree.setShowsRootHandles(false);

		scroll.setViewportView(tree);
		this.add(scroll, BorderLayout.CENTER);
	}

	public void setLabels() {
		menu_file_add.setLabel(getString("menu_file_add"));
		menu_file_info.setLabel(getString("menu_file_info"));
		menu_file_delete.setLabel(getString("menu_file_delete"));
		menu_file_rename.setLabel(getString("menu_file_rename"));
		menu_file_move.setLabel(getString("menu_file_move"));
		menu_file.setLabel(getString("menu_file"));

		((NodeObject)( root.getUserObject())).setName(getString("RootName"));

		adddialog.setLabels();
		editdialog.setLabels();
	}

	protected static void addNodes(DefaultMutableTreeNode node) {
		node.removeAllChildren();
		try {
			File targetDir = ((NodeObject)node.getUserObject()).getFile();
			Vector Data = util.getDirsFilesAsVector(targetDir);
			int limit = Data.size();
			for (int count=limit-1; count>=0; count--) {
				treemodel.insertNodeInto(new DefaultMutableTreeNode
							   (new NodeObject((File)(Data.elementAt(count)))), node, 0);
			}
		}
		catch(Exception exception) {
			exception.printStackTrace();
		}
	}

	protected static void addDummyNodes(DefaultMutableTreeNode node) {
		if (node.getChildCount() == 0) {
			try {
				treemodel.insertNodeInto(new DefaultMutableTreeNode
										 (new NodeObject(new File("/DummuyFile"))), node, 0);		
			}
			catch(Exception exception) {}
		}
	}
}
