/*
 * @(#)Components.java	0.002 1999/12/27
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.addressbook;

import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;

import yuzu.util.*;
import yuzu.table.*;
import yuzu.disp.*;
import yuzu.addressbook.add.*;
import yuzu.addressbook.edit.*;
import yuzu.addressbook.info.*;


public class Components extends JPanel {

	protected static Container container = null;
	protected static JFrame frame = null;
	protected static Utilities util = new Utilities();

	protected static File rootdir = util.getAddressbookDir();
	protected static File currentDir = util.getAddressbookDir();

 	protected static DefaultMutableTreeNode root = new DefaultMutableTreeNode();
 	protected static DefaultTreeModel treemodel = new DefaultTreeModel(root);
	protected static JTree tree = new JTree(treemodel);
	protected static JScrollPane scroll = new JScrollPane();
    protected static JPanel pane = null;
	protected static DTable table = null;

	protected static final String sp = System.getProperty("file.separator");
	protected static DefaultTreeCellRenderer treeRenderer = new DefaultTreeCellRenderer();
	protected static ImageIcon nodeIcon       = new ImageIcon("addressbook"+sp+"images"+sp+"NodeIcon.jpeg");
	protected static ImageIcon hasNodeIcon    = new ImageIcon("addressbook"+sp+"images"+sp+"HasNodeIcon.jpeg");
	protected static ImageIcon openedNodeIcon = new ImageIcon("addressbook"+sp+"images"+sp+"OpenedNodeIcon.jpeg");

	protected static TreeEditor treeEditor = new TreeEditor(tree, treeRenderer);
	private static ResourceBundle resource = 
		ResourceBundle.getBundle("addressbook"+sp+"lib"+sp+"resource", Locale.getDefault());

	protected static JMenuBar menubar = new JMenuBar();
	protected static JMenu menu_file            = new JMenu();
	protected static JMenuItem menu_file_add    = new JMenuItem();
	protected static JMenuItem menu_file_info   = new JMenuItem();
	protected static JMenuItem menu_file_delete = new JMenuItem();
	protected static JMenuItem menu_file_rename = new JMenuItem();
	protected static JMenuItem menu_file_move   = new JMenuItem();
	protected static ImageIcon addIcon    = new ImageIcon("addressbook"+sp+"images"+sp+"add.gif");
	protected static ImageIcon infoIcon   = new ImageIcon("addressbook"+sp+"images"+sp+"info.gif");
	protected static ImageIcon deleteIcon = new ImageIcon("addressbook"+sp+"images"+sp+"delete.gif");
	protected static ImageIcon renameIcon = new ImageIcon("addressbook"+sp+"images"+sp+"rename.gif");
	protected static ImageIcon moveIcon   = new ImageIcon("addressbook"+sp+"images"+sp+"move.gif");

	protected static JOptionPane dialog = new JOptionPane();
	protected static JFileChooser chooser = new JFileChooser();

	protected static Disp disp = null;

	protected static AddressObject addressdata = null;

	protected static AddressAddDialog adddialog = new AddressAddDialog();
	protected static AddressEditDialog editdialog = new AddressEditDialog();
	protected static AddressViewDialog infodialog = new AddressViewDialog();
	

	public Components() {
		pane = this;
		pane.setLayout(new BorderLayout());
	}

	public void setContainer(Container cnt) {
		container = cnt;
	}

	public void setJFrame(JFrame jfr) {
		frame = jfr;
	}

	public void setTable(DTable tbl) {
		table = tbl;
	}

	public void setDisp(Disp dsp) {
		disp = dsp;
	}

	protected void refresh() {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				frame.setVisible(false);
				frame.setVisible(true);
			}
		});
	}

	public File getCurrentDir() {
		return (currentDir);
	}

	public void setCurrentDir(File dir) {
		currentDir = dir;
	}

	public void print(String string) {
		System.out.println(string);
	}

	public void trace(Exception exception) {
		exception.printStackTrace();
	}
	
	public void setLocale(Locale locale) {
		adddialog.setLocale(locale);
		editdialog.setLocale(locale);
		resource = ResourceBundle.getBundle("addressbook"+sp+"lib"+sp+"resource", locale);
		super.setLocale(locale);
	}
	
	protected String getString(String key) {
		return (resource.getString(key));
	}
}
