/*
 * @(#)Listeners.java	0.001 1999/12/27
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.addressbook;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

import yuzu.util.*;


class Listeners extends Build {

	private static String margine = "    ";
	
	private static String name = "";
	private static Object[] label = null;


	Listeners() {
		menu_file_add.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				addNode();
			}
		});

		menu_file_info.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				dispAddressInfo();
			}
		});

		menu_file_move.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				moveNode();
			}
		});

		menu_file_delete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				deleteNode();
			}
		});

		menu_file_rename.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				renameNode();
			}
		});

		tree.addTreeExpansionListener(new TreeExpansionListener() {
			public void treeExpanded(TreeExpansionEvent event) {
				TreePath path = event.getPath();
				DefaultMutableTreeNode Node = 
					(DefaultMutableTreeNode)path.getLastPathComponent();
				Build.addNodes(Node);
				Enumeration children = Node.children();
				DefaultMutableTreeNode childnode = null;
				while (children.hasMoreElements()) {
					childnode = (DefaultMutableTreeNode)children.nextElement();
					if (util.hasAnyFileorDirectory(((NodeObject)(childnode.getUserObject())).getFile())) {
						Build.addDummyNodes(childnode);
					}
				}
				treemodel.nodeStructureChanged(Node);
			}
			public void treeCollapsed(TreeExpansionEvent event) {
			}
		});

		tree.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent event) {
				if (root.getChildCount() == 0) {
					especsialyRebuildRootNode();
				} else {
					TreePath path = event.getPath();
					if (path.getPathCount() > 1) {
						DefaultMutableTreeNode Node 
							= (DefaultMutableTreeNode)path.getLastPathComponent();
						File target = ((NodeObject)(Node.getUserObject())).getFile();
						if (target.isFile()) {
							if (disp.getwrite()) {
								addressdata = util.getAddressData(target);
								disp.customPaste(addressdata.getMailaddress());
							}
						} else {
							setCurrentDir(target);
						}
					}
				}
			}
		});
	}

	public void addNode() {
		try {
			TreePath Path = tree.getSelectionPath();
			DefaultMutableTreeNode Node 
				= (DefaultMutableTreeNode)(Path.getLastPathComponent());
			if (!Node.isLeaf()) {
				adddialog.showDialog(Node);
			} else {
				if (Path.getPathCount() == 1) {
					adddialog.showDialog(Node);
				} else {
					editdialog.showDialog(Node);
				}
			}
		}
		catch (NullPointerException exception) {
			dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
									 getString("DialogNotselectedTitle"),
									 dialog.WARNING_MESSAGE);
		}
	}

	public void moveNode() {
		try {
			TreePath Path = tree.getSelectionPath();
			if (Path.getPathCount() > 1) {
				DefaultMutableTreeNode Node
					= (DefaultMutableTreeNode)(Path.getLastPathComponent());
				NodeObject obj = (NodeObject)(Node.getUserObject());

				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				chooser.setDialogTitle(getString("MoveDialogTitle"));
				chooser.setApproveButtonText(getString("MoveDialogButton"));
				chooser.setCurrentDirectory(util.getAddressbookDir());
				int returnVal = chooser.showOpenDialog(container);
				if(returnVal == JFileChooser.APPROVE_OPTION) {
					File fromDir   = obj.getFile();
					File targetDir = chooser.getSelectedFile();
					File FROMDIR   = util.getAddressbookDir();
					try{
						fromDir   = new File(fromDir.getCanonicalPath());
						targetDir = new File(targetDir.getCanonicalPath());
						FROMDIR   = new File(FROMDIR.getCanonicalPath());
					} catch (Exception exception){}
					if (!fromDir.getPath().equals(targetDir.getPath())) {
						if (targetDir.getPath().startsWith(FROMDIR.getPath())) {
							String targetSplit = "";
							if (FROMDIR.getPath().length() + 1 <= targetDir.getPath().length()) {
								targetSplit = targetDir.getPath().substring(
													   FROMDIR.getPath().length() + 1, 
													   targetDir.getPath().length());
							}
							StringTokenizer analy = new StringTokenizer(targetSplit, 
														  System.getProperty("file.separator"));
							DefaultMutableTreeNode targetNode = root;
							while(analy.hasMoreTokens()) {
								targetNode = getChildNode(targetNode, analy.nextToken());
							}
							File newDir = new File(targetDir, fromDir.getName());
							if (fromDir.renameTo(newDir)) {
								obj.setFile(newDir);
								Node.setUserObject(obj);
								treemodel.removeNodeFromParent(Node);
								addNodes(targetNode);
								treemodel.nodeStructureChanged(targetNode);
							} else {
								dialog.showMessageDialog(container, getString("DialogMoveFailMessage"),
									 getString("DialogMoveFailTitle"),
									 dialog.WARNING_MESSAGE);
							}
						} else {
							dialog.showMessageDialog(container, getString("DialogMoveMisstargetMessage"),
									 getString("DialogMoveMisstargetTitle"),
									 dialog.WARNING_MESSAGE);
						}
					}
				}
			} else {
				dialog.showMessageDialog(container, getString("DialogNomoveMessage"),
					  getString("DialogNomoveTitle"),
					  dialog.WARNING_MESSAGE);
			}
		}
		catch (NullPointerException exception) {
			dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
				getString("DialogNotselectedTitle"),
				dialog.WARNING_MESSAGE);
		}
	}

	public void deleteNode() {
		try {
			TreePath Path = tree.getSelectionPath();
			DefaultMutableTreeNode Node 
				= (DefaultMutableTreeNode)(Path.getLastPathComponent());
			boolean yesorno = false;
			if (Path.getPathCount() > 1) {
				if (Node.isLeaf()) {
					label = new Object[] {
						margine + getString("DialogDeleteMessage1"),
						margine,
						margine + getString("DialogDeleteMessage2")
					};
					int ans = dialog.showConfirmDialog(container, label,
							  getString("DialogDeleteTitle"),
							  dialog.OK_CANCEL_OPTION);
					yesorno = false;
					if (ans == 0) yesorno = true;
				} else {
					label = new Object[] {
						margine + getString("DialogAlldeleteMessage1"),
						margine + getString("DialogAlldeleteMessage2"),
						margine,
						margine + getString("DialogAlldeleteMessage3")
					};
					int ans = dialog.showConfirmDialog(container, label,
						         getString("DialogAlldeleteTitle"),
					   	         dialog.OK_CANCEL_OPTION);
					yesorno = false;
					if (ans == 0) yesorno = true;
				}
				if (yesorno == true) {
					if (util.deleteAll(((NodeObject)(Node.getUserObject())).getFile())) {
						treemodel.removeNodeFromParent(Node);
					} else {
						label = new Object[] {
							margine + getString("DialogDeletefailMessage1"),
							margine + getString("DialogDeletefailMessage1")
						};
						dialog.showMessageDialog(container, label,
							 getString("DialogDeletefailTiele"),
							 dialog.WARNING_MESSAGE);
					}
				}
			} else {
				dialog.showMessageDialog(container, getString("DialogNodeleteMessage"),
					  getString("DialogNodeleteTitle"),
					  dialog.WARNING_MESSAGE);
			}
		}
		catch (NullPointerException exception) {
			dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
				getString("DialogNotselectedTitle"),
				dialog.WARNING_MESSAGE);
		}
	}

	public void renameNode() {
		try {
			TreePath Path = tree.getSelectionPath();
			if (Path.getPathCount() > 1) {
				DefaultMutableTreeNode Node
					= (DefaultMutableTreeNode)(Path.getLastPathComponent());
				DefaultMutableTreeNode parenteNode = (DefaultMutableTreeNode)
					((tree.getSelectionPath().getParentPath()).getLastPathComponent());
				String name = ((NodeObject)Node.getUserObject()).getName();
				name = "";
				while (name.equals("")) {
					name = dialog.showInputDialog(container, getString("DialogRenameMessage"),
							   getString("DialogRenameTitle"),
							   dialog.WARNING_MESSAGE);
					try {
						if (name.trim().equals("")) name = "";
					} catch(NullPointerException exception) {
						break;
					}
				}
				int thesame = getTheSameList(parenteNode.children(), name);
				while (thesame != 0) {
					name = "";
					while (name.equals("")) {
						name = dialog.showInputDialog(container, getString("DialogRerenameMessage"),
								   getString("DialogRerenameTitle"),
								   dialog.WARNING_MESSAGE);
						try {
							if (name.trim().equals("")) name = "";
						} catch(NullPointerException exception) {
							break;
						}
					}
					if (name == null) {
						thesame = 0;
					} else {
						thesame = getTheSameList(parenteNode.children(), name);
					}
				}
				if (name != null) {
					File oldfile = ((NodeObject)(Node.getUserObject())).getFile();
					File file = new File(((NodeObject)
								 (parenteNode.getUserObject())).getFile(), name);
					if (oldfile.renameTo(file)) {
						Node.setUserObject(new NodeObject(file, name));
						treemodel.nodeStructureChanged(Node);
					} else {
						label = new Object[] {
							margine + getString("DialogRenamefailMessage1"),
							margine + getString("DialogRenamefailMessage2")
						};
						dialog.showMessageDialog(container, label,
							 getString("DialogRenamefailTitle"),
							 dialog.WARNING_MESSAGE);
					}
				}
			} else {
				dialog.showMessageDialog(container, getString("DialogNorenameMessage"),
					  getString("DialogNorenameTitle"),
					  dialog.WARNING_MESSAGE);
			}
		}
		catch (NullPointerException exception) {
			dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
				getString("DialogNotselectedTitle"),
				dialog.WARNING_MESSAGE);
		}
	}
	
	public void dispAddressInfo() {
		try {
			TreePath Path = tree.getSelectionPath();
			DefaultMutableTreeNode Node 
				= (DefaultMutableTreeNode)(Path.getLastPathComponent());
			if (Node.isLeaf()) {
				infodialog.showDialog(Node);
			} else {
			}
		}
		catch (NullPointerException exception) {
			dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
									 getString("DialogNotselectedTitle"),
									 dialog.WARNING_MESSAGE);
		}
	}

	public int getTheSameList(Enumeration emume, String name) {
		int count=0;
		while (emume.hasMoreElements()) {
			if (((DefaultMutableTreeNode)
				 emume.nextElement()).getUserObject().toString().equals(name)) {
				++count;
			}
		}
		return(count);
	}

	public DefaultMutableTreeNode getChildNode(DefaultMutableTreeNode node, String name) {
		Enumeration list = node.children();
		int count = 0;
		while (list.hasMoreElements()) {
			if (((DefaultMutableTreeNode)
				 list.nextElement()).getUserObject().toString().equals(name)) {
				break;
			}
			++count;
		}
		try {
			return ((DefaultMutableTreeNode)(node.getChildAt(count)));
		} catch(Exception exception) {}
		return (null);
	}

	public void especsialyRebuildRootNode() {
		Build.addNodes(root);
		Enumeration children = root.children();
		DefaultMutableTreeNode childnode = null;
		while (children.hasMoreElements()) {
			childnode = (DefaultMutableTreeNode)children.nextElement();
			if (util.hasAnyFileorDirectory(((NodeObject)(childnode.getUserObject())).getFile())) {
				Build.addDummyNodes(childnode);
			}
		}
	}
}
