/*
 * @(#)Components.java	0.001 2000/01/19 (JST)
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.addressbook.edit;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;

import yuzu.util.*;
import yuzu.addressbook.*;


public class Components extends JFrame {

	protected static Container container = null;
	protected static JFrame frame = null;

	protected static final String sp = System.getProperty("file.separator");
	private static ResourceBundle resource = 
		ResourceBundle.getBundle("addressbook"+sp+"edit"+sp+"lib"+sp+"resource", Locale.getDefault());

	protected static Utilities util = new Utilities();

	protected static JPanel pane = new JPanel(new BorderLayout());
	protected static JPanel verpane = new JPanel();

	protected static JMenuBar menubar = new JMenuBar();
	protected static JMenu menu_edit = new JMenu();
	protected static JMenuItem menu_edit_copy  = new JMenuItem();
	protected static JMenuItem menu_edit_paste = new JMenuItem();

	protected static ImageIcon copyIcon = new ImageIcon("addressbook"+sp+"edit"+sp+"images"+sp+"copy.gif");
	protected static ImageIcon pasteIcon = new ImageIcon("addressbook"+sp+"edit"+sp+"images"+sp+"paste.gif");
	protected static ImageIcon Icon = new ImageIcon("addressbook"+sp+"edit"+sp+"images"+sp+"icon.gif");

	protected static JPanel namepane = new JPanel(new BorderLayout());
	protected static JPanel mailaddresspane = new JPanel(new BorderLayout());
	protected static JPanel zippane = new JPanel(new BorderLayout());
	protected static JPanel addresspane = new JPanel(new BorderLayout());
	protected static JPanel telpane = new JPanel(new BorderLayout());
	protected static JPanel urlpane = new JPanel(new BorderLayout());
	protected static JPanel memopane = new JPanel(new BorderLayout());

	protected static JTextField nametext = new JTextField(30);
	protected static JTextField mailaddresstext = new JTextField(30);
	protected static JTextField ziptext = new JTextField(30);
	protected static JTextField addresstext = new JTextField(30);
	protected static JTextField teltext = new JTextField(30);
	protected static JTextField urltext = new JTextField(30);
	protected static JTextField memotext = new JTextField(30);

	protected static JPanel addpane = new JPanel(new BorderLayout());
	protected static JButton addbutton  = new JButton();

	protected DefaultMutableTreeNode targetNode = null;

	protected static JTree addressTree = null;
	protected static TreePath selectedPath = null;

	protected static AddressObject addressObject = null;


	public Components() {
		this.addWindowListener(new Closing());
		try {
			UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);
		}
		catch(UnsupportedLookAndFeelException even) {}
		catch(ClassNotFoundException even) {}
		catch(InstantiationException even) {}
		catch(IllegalAccessException even) {}
		container = super.getContentPane();
		container.setLayout(new BorderLayout());
		frame = this;
	}

	protected class Closing extends WindowAdapter implements ActionListener {
		public void windowClosing(WindowEvent even) {
			Terminator();
		}
		public void actionPerformed(ActionEvent even) {
			Terminator();
		}
	}

	protected void Terminator() {
	}

	public void print(String string) {
		System.out.println(string);
	}

	public void trace(Exception exception) {
		exception.printStackTrace();
	}
	
	public void setAddressTree(JTree arg) {
		addressTree = arg;
	}

	public void setLocale(Locale locale) {
		resource = ResourceBundle.getBundle("addressbook"+sp+"edit"+sp+"lib"+sp+"resource", locale);
		super.setLocale(locale);
	}
	
	protected String getString(String key) {
		return (resource.getString(key));
	}
}
