/*
 * @(#)Listeners.java	0.001 2000/01/19 (JST)
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.addressbook.edit;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;

import yuzu.util.*;
import yuzu.addressbook.*;


public class Listeners extends Build {
	public Listeners() {
		menu_edit_copy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				try {
					if (nametext.hasFocus()) {
						nametext.copy();
					} else if (mailaddresstext.hasFocus()) {
						mailaddresstext.copy();
					} else if (ziptext.hasFocus()) {
						ziptext.copy();
					} else if (addresstext.hasFocus()) {
						addresstext.copy();
					} else if (teltext.hasFocus()) {
						teltext.copy();
					} else if (urltext.hasFocus()) {
						urltext.copy();
					} else if (memotext.hasFocus()) {
						memotext.copy();
					}
				} catch (Exception exception) {}
			}
		});
			
		menu_edit_paste.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				try {
					if (nametext.hasFocus()) {
						nametext.paste();
					} else if (mailaddresstext.hasFocus()) {
						mailaddresstext.paste();
					} else if (ziptext.hasFocus()) {
						ziptext.paste();
					} else if (addresstext.hasFocus()) {
						addresstext.paste();
					} else if (teltext.hasFocus()) {
						teltext.paste();
					} else if (urltext.hasFocus()) {
						urltext.paste();
					} else if (memotext.hasFocus()) {
						memotext.paste();
					}
				} catch (Exception exception) {}
			}
		});

		addbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
 				String name = nametext.getText();
 				String mailaddress = mailaddresstext.getText();
 				String zip = ziptext.getText();
 				String address = addresstext.getText();
 				String tel = teltext.getText();
 				String url = urltext.getText();
 				String memo = memotext.getText();
				File targetFile = ((NodeObject)(targetNode.getUserObject())).getFile();
 				File targetDir = new File(targetFile.getParent());
 				if (!name.trim().equals("")) {
					targetFile.delete();
					targetFile = new File(targetDir, name);
					BufferedWriter output = null;
					targetFile.renameTo(new File(targetDir, name));
					try {
						output = new BufferedWriter(new FileWriter(targetFile));
						output.write("name: " + name); 
						output.newLine();
						output.write("mailaddress: " + mailaddress); 
						output.newLine();
						output.write("zip: " + zip); 
						output.newLine();
						output.write("address: " + address); 
						output.newLine();
						output.write("tel: " + tel); 
						output.newLine();
						output.write("url: " + url); 
						output.newLine();
						output.write("memo: " + memo); 
						output.newLine();
						output.flush();
						output.close();
					} catch (Exception exception) {
						trace(exception);
					} 
				}
				Terminator();
 			}
		});
	}

	public void showDialog(DefaultMutableTreeNode Node) {
		frame.pack();
		selectedPath = addressTree.getSelectionPath();
		targetNode = Node;
		addressObject = util.getAddressData(((NodeObject)(targetNode.getUserObject())).getFile());
		nametext.setText(addressObject.getName());
		mailaddresstext.setText(addressObject.getMailaddress());
		ziptext.setText(addressObject.getZip());
		addresstext.setText(addressObject.getAddress());
		teltext.setText(addressObject.getTel());
		urltext.setText(addressObject.getURL());
		memotext.setText(addressObject.getMemo());
		frame.setVisible(true);
	}

	public void hideDialog() {
		frame.setVisible(false);
		frame.removeNotify();
	}

	protected void Terminator() {
		nametext.setText("");
		mailaddresstext.setText("");
		ziptext.setText("");
		addresstext.setText("");
		teltext.setText("");
		urltext.setText("");
		memotext.setText("");
		addressTree.collapsePath(selectedPath.getParentPath());
		addressTree.expandPath(selectedPath.getParentPath());
		hideDialog();
	}
}
