/*
 * @(#)Build.java	0.001 1999/11/30
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.disp;

import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.border.*;
import javax.swing.table.*;


public class Build extends Components {
	public Build() {
		setLabels();

		menu_edit_copy.setIcon(copyIcon);
		menu_edit_paste.setIcon(pasteIcon);
		menu_edit_allcopy.setIcon(allcopyIcon);
		menu_edit_cut.setIcon(cutIcon);

		menu_edit.add(menu_edit_copy);
		menu_edit.add(menu_edit_paste);
		menu_edit.add(menu_edit_allcopy);
		menu_edit.addSeparator();
		menu_edit.add(menu_edit_cut);
		menubar.add(menu_edit);
		//pane.add(menubar, BorderLayout.NORTH);

		buildMessageRead();
		buildHTMLRead();
		buildImageRead();
		buildStringRead();
		buildAttachRead();
		buildMultipartRead();
		buildWrite();
		removeAll();
		pane.setBackground(Color.white);
	}

	public void buildMessageRead() {
		readlistpane.setLayout(new BoxLayout(readlistpane, BoxLayout.Y_AXIS));

		//readsubjecttext.setFont(new Font("strong", Font.BOLD, 18));
		readsubjecttext.setFont(new Font("sansserif", Font.BOLD, 18));
		readsubjecttext.setForeground(Color.black);

		readfromlabel.setFont(new Font("serif", Font.PLAIN, 12));
		readfromlabel.setForeground(Color.blue);
		readfromtext.setFont(new Font("serif", Font.ITALIC, 12));
		readfromtext.setForeground(Color.black);

		readtolabel.setFont(new Font("serif", Font.PLAIN, 12));
		readtolabel.setForeground(Color.blue);
		readtotext.setFont(new Font("serif", Font.ITALIC, 12));
		readtotext.setForeground(Color.black);

		readcclabel.setFont(new Font("serif", Font.PLAIN, 12));
		readcclabel.setForeground(Color.blue);
		readcctext.setFont(new Font("serif", Font.ITALIC, 12));
		readcctext.setForeground(Color.black);

		readdatelabel.setFont(new Font("serif", Font.PLAIN, 12));
		readdatelabel.setForeground(Color.blue);
		readdatetext.setFont(new Font("serif", Font.ITALIC, 12));
		readdatetext.setForeground(Color.black);

		readsubjectpane.add(readsubjecttext);
		readfrompane.add(readfromlabel);
		readfrompane.add(readfromtext);
		readtopane.add(readtolabel);
		readtopane.add(readtotext);
		readccpane.add(readcclabel);
		readccpane.add(readcctext);
		readdatepane.add(readdatelabel);
		readdatepane.add(readdatetext);

		readlistpane.add(readsubjectpane);

		StyleConstants.setItalic(readstyle1, true);
		StyleConstants.setFontSize(readstyle1, 14);
		StyleConstants.setForeground(readstyle1, Color.blue);
		StyleConstants.setFontSize(readstyle2, 14);
		StyleConstants.setForeground(readstyle2, Color.blue);
		StyleConstants.setFontSize(readstyle3, 14);
		StyleConstants.setForeground(readstyle4, Color.red);
		StyleConstants.setFontSize(readstyle4, 14);

		readtext.setEditable(false);
		readheadpane.add(readlistpane);
		readimagepane.add(readlabel, BorderLayout.CENTER);
		readtitlepane.add(readheadpane,  BorderLayout.CENTER);
		readtitlepane.add(readimagepane, BorderLayout.WEST);
		readtextpane.add(readlmarg, BorderLayout.WEST);
		readtextpane.add(readtext, BorderLayout.CENTER);
		readbasepane.add(readtextpane,  BorderLayout.CENTER);
		readbasepane.add(readtitlepane, BorderLayout.NORTH);

		readsubjectpane.setBackground(Color.white);
		readfrompane.setBackground(Color.white);
		readtopane.setBackground(Color.white);
		readccpane.setBackground(Color.white);
		readdatepane.setBackground(Color.white);
		readlistpane.setBackground(Color.white);
		readimagepane.setBackground(Color.white);
		readheadpane.setBackground(Color.white);
		readtextpane.setBackground(Color.white);
	}

	public void buildMessageReadHeader() {
		try {
			readlistpane.remove(readfrompane);
			readlistpane.remove(readtopane);
			readlistpane.remove(readccpane);
			readlistpane.remove(readdatepane);
		} catch(Exception exception) {}
		if (getread_frombool()) readlistpane.add(readfrompane);
		if (getread_tobool()) readlistpane.add(readtopane);
		if (getread_ccbool()) readlistpane.add(readccpane);
		if (getread_datebool()) readlistpane.add(readdatepane);
	}

	public void buildHTMLRead() {
		htmllistpane.setLayout(new BoxLayout(htmllistpane, BoxLayout.Y_AXIS));
		htmllistpane.add(htmlsubjectpane);

		htmlsubjecttext.setFont(new Font("sansserif", Font.BOLD, 18));
		htmlsubjecttext.setForeground(Color.black);

		htmltext.setEditable(false);
		htmltext.setEditorKit(new HTMLEditorKit());
		htmltext.setContentType("text/html");
		htmlsubjectpane.add(htmlsubjecttext);
		htmlheadpane.add(htmllistpane);
		htmlimagepane.add(htmllabel, BorderLayout.CENTER);
		htmltitlepane.add(htmlheadpane,  BorderLayout.CENTER);
		htmltitlepane.add(htmlimagepane, BorderLayout.WEST);
		htmltextpane.add(htmllmarg, BorderLayout.WEST);
		htmltextpane.add(htmltext, BorderLayout.CENTER);
		htmlbasepane.add(htmltextpane,  BorderLayout.CENTER);
		htmlbasepane.add(htmltitlepane, BorderLayout.NORTH);

		htmlsubjectpane.setBackground(Color.white);
		htmllistpane.setBackground(Color.white);
		htmlimagepane.setBackground(Color.white);
		htmlheadpane.setBackground(Color.white);
		htmltextpane.setBackground(Color.white);
	}

	public void buildImageRead() {
		imagelistpane.setLayout(new BoxLayout(imagelistpane, BoxLayout.Y_AXIS));

		imagesubjecttext.setFont(new Font("sansserif", Font.BOLD, 18));
		imagesubjecttext.setForeground(Color.black);

		imagenamelabel.setFont(new Font("serif", Font.PLAIN, 12));
		imagenamelabel.setForeground(Color.blue);
		imagenametext.setFont(new Font("serif", Font.ITALIC, 12));
		imagenametext.setForeground(Color.black);

		imagetypelabel.setFont(new Font("serif", Font.PLAIN, 12));
		imagetypelabel.setForeground(Color.blue);
		imagetypetext.setFont(new Font("serif", Font.ITALIC, 12));
		imagetypetext.setForeground(Color.black);

		imagesubjectpane.add(imagesubjecttext);
		imagenamepane.add(imagenamelabel);
		imagenamepane.add(imagenametext);
		imagetypepane.add(imagetypelabel);
		imagetypepane.add(imagetypetext);
		imagelistpane.add(imagesubjectpane);
		imagelistpane.add(imagenamepane);
		imagelistpane.add(imagetypepane);
		imageheadpane.add(imagelistpane);
		imageimagepane.add(imagelabel, BorderLayout.CENTER);
		imagetitlepane.add(imageheadpane,  BorderLayout.CENTER);
		imagetitlepane.add(imageimagepane, BorderLayout.WEST);
		imagetextpane.add(imagelmarg, BorderLayout.WEST);
		imagetextpane.add(attachimage, BorderLayout.CENTER);
		imagebasepane.add(imagetextpane,  BorderLayout.CENTER);
		imagebasepane.add(imagetitlepane, BorderLayout.NORTH);

		imagesubjectpane.setBackground(Color.white);
		imagenamepane.setBackground(Color.white);
		imagetypepane.setBackground(Color.white);
		imagelistpane.setBackground(Color.white);
		imageimagepane.setBackground(Color.white);
		imageheadpane.setBackground(Color.white);
		imagetextpane.setBackground(Color.white);
	}

	public void buildStringRead() {
		stringlistpane.setLayout(new BoxLayout(stringlistpane, BoxLayout.Y_AXIS));

		stringsubjecttext.setFont(new Font("sansserif", Font.BOLD, 18));
		stringsubjecttext.setForeground(Color.black);

		stringnamelabel.setFont(new Font("serif", Font.PLAIN, 12));
		stringnamelabel.setForeground(Color.blue);
		stringnametext.setFont(new Font("serif", Font.ITALIC, 12));
		stringnametext.setForeground(Color.black);

		stringtypelabel.setFont(new Font("serif", Font.PLAIN, 12));
		stringtypelabel.setForeground(Color.blue);
		stringtypetext.setFont(new Font("serif", Font.ITALIC, 12));
		stringtypetext.setForeground(Color.black);

		stringarea.setEditable(false);
		stringsubjectpane.add(stringsubjecttext);
		stringnamepane.add(stringnamelabel);
		stringnamepane.add(stringnametext);
		stringtypepane.add(stringtypelabel);
		stringtypepane.add(stringtypetext);
		stringlistpane.add(stringsubjectpane);
		stringlistpane.add(stringnamepane);
		stringlistpane.add(stringtypepane);
		stringheadpane.add(stringlistpane);
		stringimagepane.add(stringlabel, BorderLayout.CENTER);
		stringtitlepane.add(stringheadpane,  BorderLayout.CENTER);
		stringtitlepane.add(stringimagepane, BorderLayout.WEST);
		stringtextpane.add(stringlmarg, BorderLayout.WEST);
		stringtextpane.add(stringarea, BorderLayout.CENTER);
		stringbasepane.add(stringtextpane,  BorderLayout.CENTER);
		stringbasepane.add(stringtitlepane, BorderLayout.NORTH);

		stringsubjectpane.setBackground(Color.white);
		stringnamepane.setBackground(Color.white);
		stringtypepane.setBackground(Color.white);
		stringlistpane.setBackground(Color.white);
		stringimagepane.setBackground(Color.white);
		stringheadpane.setBackground(Color.white);
		stringtextpane.setBackground(Color.white);
	}
	
	public void buildAttachRead() {
		attachlistpane.setLayout(new BoxLayout(attachlistpane, BoxLayout.Y_AXIS));

		attachsubjecttext.setFont(new Font("sansserif", Font.BOLD, 18));
		attachsubjecttext.setForeground(Color.black);

		attachnamelabel.setFont(new Font("serif", Font.PLAIN, 12));
		attachnamelabel.setForeground(Color.blue);
		attachnametext.setFont(new Font("serif", Font.ITALIC, 12));
		attachnametext.setForeground(Color.black);

		attachtypelabel.setFont(new Font("serif", Font.PLAIN, 12));
		attachtypelabel.setForeground(Color.blue);
		attachtypetext.setFont(new Font("serif", Font.ITALIC, 12));
		attachtypetext.setForeground(Color.black);

		attachsubjectpane.add(attachsubjecttext);
		attachnamepane.add(attachnamelabel);
		attachnamepane.add(attachnametext);
		attachtypepane.add(attachtypelabel);
		attachtypepane.add(attachtypetext);
		attachlistpane.add(attachsubjectpane);
		attachlistpane.add(attachnamepane);
		attachlistpane.add(attachtypepane);
		attachheadpane.add(attachlistpane);
		attachimagepane.add(attachlabel, BorderLayout.CENTER);
		attachtitlepane.add(attachheadpane,  BorderLayout.CENTER);
		attachtitlepane.add(attachimagepane, BorderLayout.WEST);
		attachtextpane.add(attachlmarg, BorderLayout.WEST);
		attachbasepane.add(attachtextpane,  BorderLayout.CENTER);
		attachbasepane.add(attachtitlepane, BorderLayout.NORTH);

		attachsubjectpane.setBackground(Color.white);
		attachnamepane.setBackground(Color.white);
		attachtypepane.setBackground(Color.white);
		attachlistpane.setBackground(Color.white);
		attachimagepane.setBackground(Color.white);
		attachheadpane.setBackground(Color.white);
		attachtextpane.setBackground(Color.white);
	}

	public void buildMultipartRead() {
		multipartlistpane.setLayout(new BoxLayout(multipartlistpane, BoxLayout.Y_AXIS));

		multipartsubjecttext.setFont(new Font("sansserif", Font.BOLD, 18));
		multipartsubjecttext.setForeground(Color.black);

		multipartsubjectpane.add(multipartsubjecttext);
		multipartlistpane.add(multipartsubjectpane);
		multipartheadpane.add(multipartlistpane);
		multipartimagepane.add(multipartlabel, BorderLayout.CENTER);
		multiparttitlepane.add(multipartheadpane,  BorderLayout.CENTER);
		multiparttitlepane.add(multipartimagepane, BorderLayout.WEST);
		multiparttextpane.add(multipartlmarg, BorderLayout.WEST);
		multipartbasepane.add(multiparttextpane,  BorderLayout.CENTER);
		multipartbasepane.add(multiparttitlepane, BorderLayout.NORTH);

		multipartsubjectpane.setBackground(Color.white);
		multipartlistpane.setBackground(Color.white);
		multipartimagepane.setBackground(Color.white);
		multipartheadpane.setBackground(Color.white);
		multiparttextpane.setBackground(Color.white);
	}

	public void buildWrite() {
		writeheaderspane.setLayout(new BoxLayout(writeheaderspane, BoxLayout.Y_AXIS));
		writesubjecttext.setBorder(writesubjecttext_border);
		writetotext.setBorder(writetotext_border);
		writecctext.setBorder(writecctext_border);
		writebcctext.setBorder(writebcctext_border);
		writereplytotext.setBorder(writereplytotext_border);
		
		writem_file_newmail.setIcon(newmailIcon);
		writem_file_fullclear.setIcon(fullclearIcon);
		writem_file_insertsig.setIcon(insertsigIcon);
		writem_file_insertfile.setIcon(insertfileIcon);
		writem_file_attach.setIcon(attachIcon);
		writem_file_finish.setIcon(finishIcon);
		writem_file.add(writem_file_newmail);
		writem_file.add(writem_file_fullclear);
		writem_file.addSeparator();
		writem_file.add(writem_file_attach);
		writem_file.addSeparator();
		writem_file.add(writem_file_insertsig);
		writem_file.add(writem_file_insertfile);
		writem_file.addSeparator();
		writem_file.add(writem_file_finish);
		writemenubar.add(writem_file);

		writem_edit_copy.setIcon(copyIcon);
		writem_edit_paste.setIcon(pasteIcon);
		writem_edit_allcopy.setIcon(allcopyIcon);
		writem_edit_cut.setIcon(cutIcon);
		writem_disp_header.setIcon(headersIcon);

		writem_edit.add(writem_edit_copy);
		writem_edit.add(writem_edit_paste);
		writem_edit.add(writem_edit_allcopy);
		writem_edit.addSeparator();
		writem_edit.add(writem_edit_cut);
		writemenubar.add(writem_edit);

		writem_disp_header.add(writem_disp_header_subject);
		writem_disp_header.add(writem_disp_header_to);
		writem_disp_header.add(writem_disp_header_cc);
		writem_disp_header.add(writem_disp_header_bcc);
		writem_disp_header.add(writem_disp_header_replyto);
		writem_disp.add(writem_disp_header);
		writem_disp.addSeparator();
		writem_disp.add(writem_disp_button);
		writemenubar.add(writem_disp);

		writetextarea.setFont(writetextfont);
		writetextpane.add(writetextareascroll, BorderLayout.CENTER);
		
		writesubjectpane.add(writesubjecttext);
		writetopane.add(writetotext);
		writeccpane.add(writecctext);
		writebccpane.add(writebcctext);
		writereplytopane.add(writereplytotext);

		writeheaderdummypane.add(writemenubar, BorderLayout.NORTH);

		setwirte_subjectShowable(true);
		setwirte_toShowable(true);
		setwirte_ccShowable(false);
		setwirte_bccShowable(false);
		setwirte_replytoShowable(false);
		writem_disp_header_subject.setSelected(SubjectisShowed());
		writem_disp_header_to.setSelected(ToisShowed());
		writem_disp_header_cc.setSelected(CcisShowed());
		writem_disp_header_bcc.setSelected(BccisShowed());
		writem_disp_header_replyto.setSelected(ReplyToisShowed());

		setwrite_finishbuttonbool(true);
		writem_disp_button.setSelected(FinishButtonisShowed());

		writeheaderspane.add(writeheaderdummypane);
		buildWriteHeader();
		
		writeheaderpane.add(writeheaderspane);

		writetoppane.add(writepartlabel, BorderLayout.WEST);
		writetoppane.add(writeheaderpane, BorderLayout.CENTER);

		writefinishfollowpane.add(writefinishbutton, BorderLayout.EAST);
		writefinishpane.add(writefinishfollowpane, BorderLayout.CENTER);
		writefinishpane.add(writepartblmarg, BorderLayout.WEST);
		writefinishpane.add(writepartbrmarg, BorderLayout.EAST);
		writefinishpane.add(writefinishdummylabel, BorderLayout.SOUTH);
		writefinishbutton.setPreferredSize(new Dimension(200, 25));

		attach_file_attach.setIcon(attachIcon);
		attach_file_remove.setIcon(deleteIcon);
		attach_file.add(attach_file_attach);
		attach_file.addSeparator();
		attach_file.add(attach_file_remove);
		attachmenubar.add(attach_file);
		writeattachpane.add(attachmenubar, BorderLayout.NORTH);

		attachtable.setModel(model);
		model.addColumn(getString("AttachTableFile"));
		model.addColumn(getString("AttachTableType"));
		attachtable.setShowVerticalLines(false);
		attachtable.setShowHorizontalLines(true);

		writebottompane.add(writefinishpane, BorderLayout.SOUTH);

		writepane.add(writetoppane, BorderLayout.NORTH);
		writepane.add(writetextpane, BorderLayout.CENTER);
		writepane.add(writebottompane, BorderLayout.SOUTH);
		writepane.add(writepartlmarg, BorderLayout.WEST);
		writepane.add(writepartrmarg, BorderLayout.EAST);

		writepane.setBackground(Color.white);
		writetoppane.setBackground(Color.white);
		writetextpane.setBackground(Color.white);
		writebottompane.setBackground(Color.white);
		writeattachpane.setBackground(Color.white);
		writeheaderpane.setBackground(Color.white);
		writeheaderspane.setBackground(Color.white);
		writesubjectpane.setBackground(Color.white);
		writetopane.setBackground(Color.white);
		writeccpane.setBackground(Color.white);
		writebccpane.setBackground(Color.white);
		writereplytopane.setBackground(Color.white);
		writefinishpane.setBackground(Color.white);
		writefinishfollowpane.setBackground(Color.white);
		writeheaderdummypane.setBackground(Color.white);
		writetextpane.setBackground(Color.white);
		writemenubar.setBackground(Color.white);
		writem_file.setBackground(Color.white);
		writem_edit.setBackground(Color.white);
		writem_disp.setBackground(Color.white);
		writetextareascroll.setBackground(Color.white);
		attachmenubar.setBackground(Color.white);
		attach_file.setBackground(Color.white);
	}

	public void buildWriteHeader() {
		try {
			writeheaderspane.remove(writesubjectpane);
			writeheaderspane.remove(writetopane);
			writeheaderspane.remove(writeccpane);
			writeheaderspane.remove(writebccpane);
			writeheaderspane.remove(writereplytopane);
		} catch(Exception exception) {}
		if (SubjectisShowed()) writeheaderspane.add(writesubjectpane);
		if (ToisShowed()) writeheaderspane.add(writetopane);
		if (CcisShowed()) writeheaderspane.add(writeccpane);
		if (BccisShowed()) writeheaderspane.add(writebccpane);
		if (ReplyToisShowed()) writeheaderspane.add(writereplytopane);
	}

	public void buildWriteAttach() {
		writeattachpane.add(attachtablescroll, BorderLayout.CENTER);

		writebottompane.add(writeattachpane, BorderLayout.CENTER);
		writebottompane.add(attachpartlmarg, BorderLayout.WEST);
		writebottompane.add(attachpartrmarg, BorderLayout.EAST);

		writebottompane.setPreferredSize(new Dimension(writebottompane.getWidth(), 120));
		writebottompane.setVisible(false);
		writebottompane.setVisible(true);
	}

	public void removeWriteAttach() {
		int height= writeattachpane.getHeight();
		int buttonheight = writefinishpane.getHeight();
		int width = writebottompane.getWidth();

		writeattachpane.remove(attachtablescroll);
		writebottompane.remove(writeattachpane);
		writebottompane.remove(attachpartlmarg);
		writebottompane.remove(attachpartrmarg);

		writebottompane.setPreferredSize(new Dimension(width, buttonheight));

		writebottompane.setVisible(false);
		writebottompane.setVisible(true);
	}

	public void removeAll() {
		if (getreadMessage()) {
			pane.remove(readscroll);
			setreadMessage(false);
		} else if (getreadHTML()) {
			pane.remove(htmlscroll);
			setreadHTML(false);
		} else if (getreadImage()) {
			pane.remove(imagescroll);
			setreadImage(false);
		} else if (getreadString()) {
			pane.remove(stringscroll);
			setreadString(false);
		} else if (getreadAttach()) {
			pane.remove(attachscroll);
			setreadAttach(false);
		} else if (getreadMultipart()) {
			pane.remove(multipartscroll);
			setreadMultipart(false);
		} else if (getwrite()) {
			pane.remove(writepane);
			setwrite(false);
		} 
	}

	public void setMessageView() {
		pane.add(readscroll, BorderLayout.CENTER);
		setreadMessage(true);
		setreadHTML(false);
		setreadImage(false);
		setreadString(false);
		setreadAttach(false);
		setreadMultipart(false);
		setwrite(false);
	}
	
	public void setHTMLView() {
		pane.add(htmlscroll, BorderLayout.CENTER);
		setreadMessage(false);
		setreadHTML(true);
		setreadImage(false);
		setreadString(false);
		setreadAttach(false);
		setreadMultipart(false);
		setwrite(false);
	}

	public void setImageView() {
		pane.add(imagescroll, BorderLayout.CENTER);
		setreadMessage(false);
		setreadHTML(false);
		setreadImage(true);
		setreadString(false);
		setreadAttach(false);
		setreadMultipart(false);
		setwrite(false);
	}

	public void setStringView() {
		pane.add(stringscroll, BorderLayout.CENTER);
		setreadMessage(false);
		setreadHTML(false);
		setreadImage(false);
		setreadString(true);
		setreadAttach(false);
		setreadMultipart(false);
		setwrite(false);
	}

	public void setAttachView() {
		pane.add(attachscroll, BorderLayout.CENTER);
		setreadMessage(false);
		setreadHTML(false);
		setreadImage(false);
		setreadString(false);
		setreadAttach(true);
		setreadMultipart(false);
		setwrite(false);
	}

	public void setMultipartView() {
		pane.add(multipartscroll, BorderLayout.CENTER);
		setreadMessage(false);
		setreadHTML(false);
		setreadImage(false);
		setreadString(false);
		setreadAttach(false);
		setreadMultipart(true);
		setwrite(false);
	}

	public void setWriteView() {
		pane.add(writepane, BorderLayout.CENTER);
		setreadMessage(false);
		setreadHTML(false);
		setreadImage(false);
		setreadString(false);
		setreadAttach(false);
		setreadMultipart(false);
		setwrite(true);
	}

	public void setLabels() {
		menu_edit.setLabel(getString("menu_edit"));
		menu_edit_copy.setLabel(getString("menu_edit_copy"));
		menu_edit_paste.setLabel(getString("menu_edit_paste"));
		menu_edit_allcopy.setLabel(getString("menu_edit_allcopy"));
		menu_edit_cut.setLabel(getString("menu_edit_cut"));

 		readfromlabel.setText(space + getString("FromLabel") + tinspace);
 		readtolabel.setText(  space + getString("ToLabel")   + tinspace);
		readcclabel.setText(  space + getString("CcLabel")   + tinspace);
 		readdatelabel.setText(space + getString("DateLabel") + tinspace);
		imagenamelabel.setText(space + getString("NameLabel")   + tinspace);
		imagetypelabel.setText(space + getString("TypeLabel")   + tinspace);
		stringnamelabel.setText(space + getString("NameLabel")   + tinspace);
		stringtypelabel.setText(space + getString("TypeLabel")   + tinspace);
		attachnamelabel.setText(space + getString("NameLabel")   + tinspace);
		attachtypelabel.setText(space + getString("TypeLabel")   + tinspace);

		writem_file.setText(getString("writem_file"));
		writem_file_newmail.setText(getString("writem_file_newmail"));
		writem_file_fullclear.setText(getString("writem_file_fullclear"));
		writem_file_insertsig.setText(getString("writem_file_insertsig"));
		writem_file_insertfile.setText(getString("writem_file_insertfile"));
		writem_file_attach.setText(getString("writem_file_attach"));
		writem_file_finish.setText(getString("writem_file_finish"));

		writem_edit.setText(getString("writem_edit"));
		writem_edit_copy.setText(getString("writem_edit_copy"));
		writem_edit_paste.setText(getString("writem_edit_paste"));
		writem_edit_allcopy.setText(getString("writem_edit_allcopy"));
		writem_edit_cut.setText(getString("writem_edit_cut"));

		writefinishbutton.setText(getString("BuildFinishButton"));
		writesubjecttext_border.setTitle(getString("SubjectBorder"));
		writetotext_border.setTitle(getString("ToBorder"));
		writecctext_border.setTitle(getString("CcBorder"));
		writebcctext_border.setTitle(getString("BccBorder"));
		writereplytotext_border.setTitle(getString("ReplyToBorder"));

		attach_file.setText(getString("attach_file"));
		attach_file_attach.setText(getString("attach_file_attach"));
		attach_file_remove.setText(getString("attach_file_remove"));

		writem_disp.setLabel(getString("writem_disp"));
		writem_disp_header.setLabel(getString("writem_disp_header"));
		writem_disp_header_subject.setLabel(getString("writem_disp_header_subject"));
		writem_disp_header_to.setLabel(getString("writem_disp_header_to"));
		writem_disp_header_cc.setLabel(getString("writem_disp_header_cc"));
		writem_disp_header_bcc.setLabel(getString("writem_disp_header_bcc"));
		writem_disp_header_replyto.setLabel(getString("writem_disp_header_replyto"));
		writem_disp_button.setLabel(getString("writem_disp_button"));
		
		setLabels_table();
	}
	
	protected void setLabels_table() {
		if (getwriteAttach()) {
			if (attach_left_is_file) {
				((TableColumn)(((DefaultTableColumnModel)
								(attachtable.getColumnModel())).getColumn(0)
							   )).setHeaderValue(getString("AttachTableFile"));
				((TableColumn)(((DefaultTableColumnModel)
								(attachtable.getColumnModel())).getColumn(1)
							   )).setHeaderValue(getString("AttachTableType"));
			} else {
				((TableColumn)(((DefaultTableColumnModel)
								(attachtable.getColumnModel())).getColumn(1)
							   )).setHeaderValue(getString("AttachTableFile"));
				((TableColumn)(((DefaultTableColumnModel)
								(attachtable.getColumnModel())).getColumn(0)
							   )).setHeaderValue(getString("AttachTableType"));
			}
		}
	}
}
