/*
 * @(#)Disp.java	0.001 1999/11/30
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.disp;

import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.table.*;

import yuzu.util.*;
import yuzu.mail.*;
import yuzu.table.*;
import yuzu.tree.*;

public class Components extends JPanel {

	protected static Container container = null;
	protected static JFrame frame = null;
	protected static DTable table = null;
	protected static DTree tree = null;
	protected static yuzu.util.Utilities util = new yuzu.util.Utilities();
	protected static String separator = System.getProperty("line.separator");
	protected static final String sp = System.getProperty("file.separator");

	private static ResourceBundle resource = 
		ResourceBundle.getBundle("disp"+sp+"lib"+sp+"resource", Locale.getDefault());
	private static Locale currentLocale = null;

    protected static JPanel pane = null;

	protected static String space        = new String("         ");
	protected static String tinspace     = new String("   ");

	protected static ImageIcon icon = new ImageIcon("disp"+sp+"images"+sp+"logo.gif");
	protected static JLabel readlabel      = new JLabel(icon);
	protected static JLabel htmllabel      = new JLabel(icon);
	protected static JLabel imagelabel     = new JLabel(icon);
	protected static JLabel stringlabel    = new JLabel(icon);
	protected static JLabel attachlabel    = new JLabel(icon);
	protected static JLabel multipartlabel = new JLabel(icon);
	protected static JLabel writepartlabel = new JLabel(icon);

	protected static ImageIcon margin = new ImageIcon("disp"+sp+"images"+sp+"leftmargin.gif");
	protected static ImageIcon undermagin = new ImageIcon("disp"+sp+"images"+sp+"undermargin.gif");
	protected static JLabel readlmarg      = new JLabel(margin);
	protected static JLabel htmllmarg      = new JLabel(margin);
	protected static JLabel imagelmarg     = new JLabel(margin);
	protected static JLabel stringlmarg    = new JLabel(margin);
	protected static JLabel attachlmarg    = new JLabel(margin);
	protected static JLabel multipartlmarg = new JLabel(margin);
	protected static JLabel writepartlmarg = new JLabel(margin);
	protected static JLabel writepartrmarg = new JLabel(margin);
	protected static JLabel writepartblmarg = new JLabel(margin);
	protected static JLabel writepartbrmarg = new JLabel(margin);
	protected static JLabel attachpartlmarg = new JLabel(margin);
	protected static JLabel attachpartrmarg = new JLabel(margin);

	protected static JPanel readbasepane  = new JPanel(new BorderLayout());
	protected static JPanel readtitlepane = new JPanel(new BorderLayout());
	protected static JPanel readtextpane  = new JPanel(new BorderLayout());
	protected static StyleContext 
		readcontext = new StyleContext();
	protected static Style readstyle1     = readcontext.addStyle(null, null);
	protected static Style readstyle2     = readcontext.addStyle(null, null);
	protected static Style readstyle3     = readcontext.addStyle(null, null);
	protected static Style readstyle4     = readcontext.addStyle(null, null);
	protected static DefaultStyledDocument 
		readdocument = new DefaultStyledDocument(readcontext);
	protected static JTextPane readtext   = new JTextPane(readdocument);
	protected static JPanel readimagepane = new JPanel(new BorderLayout());
	protected static JPanel readheadpane  = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel readlistpane  = new JPanel();
	protected static JScrollPane readscroll = new JScrollPane(readbasepane);
	protected static JScrollBar readverbar = readscroll.getVerticalScrollBar();
	protected static JPanel readsubjectpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel readfrompane    = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel readtopane      = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel readccpane      = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel readdatepane    = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JLabel readsubjectlabel = new JLabel();
	protected static JLabel readfromlabel    = new JLabel();
	protected static JLabel readtolabel      = new JLabel();
	protected static JLabel readcclabel      = new JLabel();
	protected static JLabel readdatelabel    = new JLabel();
	protected static JLabel readsubjecttext  = new JLabel();
	protected static JLabel readfromtext     = new JLabel();
	protected static JLabel readtotext       = new JLabel();
	protected static JLabel readcctext       = new JLabel();
	protected static JLabel readdatetext     = new JLabel();
	protected static Timer readTimer = null;

	protected static boolean read_frombool = false;
	protected static boolean read_tobool = false;
	protected static boolean read_ccbool = false;
	protected static boolean read_datebool = false;

	protected static JPanel htmlbasepane  = new JPanel(new BorderLayout());
	protected static JPanel htmltitlepane = new JPanel(new BorderLayout());
	protected static JPanel htmltextpane  = new JPanel(new BorderLayout());
	protected static JEditorPane htmltext   = new JEditorPane();
	protected static JPanel htmlimagepane = new JPanel(new BorderLayout());
	protected static JPanel htmlheadpane  = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel htmllistpane  = new JPanel();
	protected static JScrollPane htmlscroll = new JScrollPane(htmlbasepane);
	protected static JPanel htmlsubjectpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JLabel htmlsubjectlabel = new JLabel();
	protected static JLabel htmlsubjecttext  = new JLabel();

	protected static JPanel imagebasepane  = new JPanel(new BorderLayout());
	protected static JPanel imagetitlepane = new JPanel(new BorderLayout());
	protected static JPanel imagetextpane  = new JPanel(new BorderLayout());
	protected static JLabel attachimage   = new JLabel();
	protected static JPanel imageimagepane = new JPanel(new BorderLayout());
	protected static JPanel imageheadpane  = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel imagelistpane  = new JPanel();
	protected static JScrollPane imagescroll = new JScrollPane(imagebasepane);
	protected static JPanel imagesubjectpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel imagenamepane    = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel imagetypepane      = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JLabel imagesubjectlabel = new JLabel();
	protected static JLabel imagenamelabel    = new JLabel();
	protected static JLabel imagetypelabel      = new JLabel();
	protected static JLabel imagesubjecttext  = new JLabel();
	protected static JLabel imagenametext     = new JLabel();
	protected static JLabel imagetypetext       = new JLabel();

	protected static JPanel stringbasepane  = new JPanel(new BorderLayout());
	protected static JPanel stringtitlepane = new JPanel(new BorderLayout());
	protected static JPanel stringtextpane  = new JPanel(new BorderLayout());
	protected static JTextArea stringarea   = new JTextArea();
	protected static JPanel stringimagepane = new JPanel(new BorderLayout());
	protected static JPanel stringheadpane  = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel stringlistpane  = new JPanel();
	protected static JScrollPane stringscroll = new JScrollPane(stringbasepane);
	protected static JScrollBar stringverbar = stringscroll.getVerticalScrollBar();
	protected static JPanel stringsubjectpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel stringnamepane    = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel stringtypepane      = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JLabel stringsubjectlabel = new JLabel();
	protected static JLabel stringnamelabel    = new JLabel();
	protected static JLabel stringtypelabel      = new JLabel();
	protected static JLabel stringsubjecttext  = new JLabel();
	protected static JLabel stringnametext     = new JLabel();
	protected static JLabel stringtypetext       = new JLabel();
	protected static Timer stringTimer = null;

	protected static JPanel attachbasepane  = new JPanel(new BorderLayout());
	protected static JPanel attachtitlepane = new JPanel(new BorderLayout());
	protected static JPanel attachtextpane  = new JPanel(new BorderLayout());
	protected static JPanel attachimagepane = new JPanel(new BorderLayout());
	protected static JPanel attachheadpane  = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel attachlistpane  = new JPanel();
	protected static JScrollPane attachscroll = new JScrollPane(attachbasepane);
	protected static JPanel attachsubjectpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel attachnamepane    = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel attachtypepane      = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JLabel attachsubjectlabel = new JLabel();
	protected static JLabel attachnamelabel    = new JLabel();
	protected static JLabel attachtypelabel      = new JLabel();
	protected static JLabel attachsubjecttext  = new JLabel();
	protected static JLabel attachnametext     = new JLabel();
	protected static JLabel attachtypetext       = new JLabel();

	protected static JPanel multipartbasepane  = new JPanel(new BorderLayout());
	protected static JPanel multiparttitlepane = new JPanel(new BorderLayout());
	protected static JPanel multiparttextpane  = new JPanel(new BorderLayout());
	protected static JPanel multipartimagepane = new JPanel(new BorderLayout());
	protected static JPanel multipartheadpane  = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel multipartlistpane  = new JPanel();
	protected static JScrollPane multipartscroll = new JScrollPane(multipartbasepane);
	protected static JPanel multipartsubjectpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JLabel multipartsubjectlabel = new JLabel();
	protected static JLabel multipartsubjecttext  = new JLabel();

	protected static JPanel writepane = new JPanel(new BorderLayout());
	protected static JPanel writetoppane = new JPanel(new BorderLayout());
	protected static JPanel writebottompane = new JPanel(new BorderLayout());
	protected static JPanel writeheaderpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel writeheaderspane = new JPanel();
	protected static JPanel writeheaderdummypane = new JPanel(new BorderLayout());
	protected static JPanel writeattachpane = new JPanel(new BorderLayout());
	protected static JMenuBar attachmenubar = new JMenuBar();
	protected static JMenu attach_file = new JMenu();
	protected static JMenuItem attach_file_attach = new JMenuItem();
	protected static JMenuItem attach_file_remove = new JMenuItem();
	protected CustomTableModel model = new CustomTableModel();
	protected static CustomTable attachtable = new CustomTable();
	protected static JScrollPane attachtablescroll = new JScrollPane(attachtable);
	protected static JPanel writetextpane = new JPanel(new BorderLayout());
	protected static JTextArea writetextarea = new JTextArea();
	protected static Font writetextfont = new Font("serif", Font.PLAIN, 14);
	protected static JScrollPane writetextareascroll = new JScrollPane(writetextarea);
	protected static JMenuBar writemenubar = new JMenuBar();
	protected static JMenu writem_file = new JMenu();
	protected static JMenuItem writem_file_newmail = new JMenuItem();
	protected static JMenuItem writem_file_fullclear = new JMenuItem();
	protected static JMenuItem writem_file_insertsig = new JMenuItem();
	protected static JMenuItem writem_file_insertfile = new JMenuItem();
	protected static JMenuItem writem_file_attach = new JMenuItem();
	protected static JMenuItem writem_file_finish = new JMenuItem();
	protected static JMenu writem_edit = new JMenu();
	protected static JMenuItem writem_edit_copy     = new JMenuItem();
	protected static JMenuItem writem_edit_paste    = new JMenuItem();
	protected static JMenuItem writem_edit_allcopy  = new JMenuItem();
	protected static JMenuItem writem_edit_cut      = new JMenuItem();
	protected static JMenu writem_disp = new JMenu();
	protected static JMenu writem_disp_header = new JMenu();
	protected static JCheckBoxMenuItem writem_disp_header_subject = new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem writem_disp_header_to = new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem writem_disp_header_cc = new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem writem_disp_header_bcc = new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem writem_disp_header_replyto = new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem writem_disp_button = new JCheckBoxMenuItem();

	protected static JPanel writefinishpane = new JPanel(new BorderLayout());
	protected static JPanel writefinishfollowpane = new JPanel(new BorderLayout());
	protected static JButton writefinishbutton = new JButton();
	protected static JLabel writefinishdummylabel = new JLabel(undermagin);
	protected static JPanel writesubjectpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel writetopane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel writeccpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel writebccpane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel writereplytopane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JTextField writesubjecttext = new JTextField(30);
	protected static JTextField writetotext = new JTextField(30);
	protected static JTextField writecctext = new JTextField(30);
	protected static JTextField writebcctext = new JTextField(30);
	protected static JTextField writereplytotext = new JTextField(30);
	protected static TitledBorder writesubjecttext_border = new TitledBorder("");
	protected static TitledBorder writetotext_border = new TitledBorder("");
	protected static TitledBorder writecctext_border = new TitledBorder("");
	protected static TitledBorder writebcctext_border = new TitledBorder("");
	protected static TitledBorder writereplytotext_border = new TitledBorder("");
	protected static JFileChooser filechooser = new JFileChooser();

	protected static ImageIcon headersIcon = new ImageIcon("disp"+sp+"images"+sp+"headers.gif");

	protected static boolean write_subjectbool = false;
	protected static boolean write_tobool = false;
	protected static boolean write_ccbool = false;
	protected static boolean write_bccbool = false;
	protected static boolean write_replytobool = false;
	protected static boolean write_textareabool = false;

	protected static boolean write_subjectshowbool = false;
	protected static boolean write_toshowbool = false;
	protected static boolean write_ccshowbool = false;
	protected static boolean write_bccshowbool = false;
	protected static boolean write_replytoshowbool = false;

	protected static boolean write_finishbuttonbool = false;

	private static boolean readMessagebool = false;
	private static boolean readHTMLbool = false;
	private static boolean readImagebool = false;
	private static boolean readStringbool = false;
	private static boolean readAttachbool = false;
	private static boolean readMultipartbool = false;
	private static boolean writebool = false;
	private static boolean write_attach_bool = false;

	protected static boolean attach_left_is_file = true;

	public static DMail mail = null;

	private static int DateStyle = DateFormat.SHORT;

	protected static File tempFile = null;
	protected static BufferedWriter out = null;

	protected static JMenuBar menubar = new JMenuBar();
	protected static JMenu menu_edit  = new JMenu();
	protected static JMenuItem menu_edit_copy     = new JMenuItem();
	protected static JMenuItem menu_edit_paste    = new JMenuItem();
	protected static JMenuItem menu_edit_allcopy  = new JMenuItem();
	protected static JMenuItem menu_edit_cut      = new JMenuItem();

	protected static ImageIcon copyIcon     = new ImageIcon("disp"+sp+"images"+sp+"copy.gif");
	protected static ImageIcon allcopyIcon  = new ImageIcon("disp"+sp+"images"+sp+"allcopy.gif");
	protected static ImageIcon pasteIcon    = new ImageIcon("disp"+sp+"images"+sp+"paste.gif");
	protected static ImageIcon cutIcon      = new ImageIcon("disp"+sp+"images"+sp+"cut.gif");
	protected static ImageIcon attachIcon   = new ImageIcon("disp"+sp+"images"+sp+"attach.gif");
	protected static ImageIcon deleteIcon   = new ImageIcon("disp"+sp+"images"+sp+"delete.gif");
	protected static ImageIcon newmailIcon    = new ImageIcon("disp"+sp+"images"+sp+"newmail.gif");
	protected static ImageIcon fullclearIcon  = new ImageIcon("disp"+sp+"images"+sp+"fullclear.gif");
	protected static ImageIcon insertfileIcon = new ImageIcon("disp"+sp+"images"+sp+"insertfile.gif");
	protected static ImageIcon insertsigIcon  = new ImageIcon("disp"+sp+"images"+sp+"insertsig.gif");
	protected static ImageIcon finishIcon  = new ImageIcon("disp"+sp+"images"+sp+"finish.gif");

	protected static Vector FileStore = new Vector();
	protected static Timer  FilezapTimer = null;

	public Components() {
		pane = this;
		pane.setLayout(new BorderLayout());
	}

	public void setContainer(Container cnt) {
		container = cnt;
	}

	public void setJFrame(JFrame jfr) {
		frame = jfr;
	}

	public void setMail(DMail dm) {
		mail = dm;
	}

	public void setTable(DTable tbl) {
		table = tbl;
	}

	public void setTree(DTree dtr) {
		tree = dtr;
	}

    public void setDateStyle(int sty) {
		DateStyle = sty;
	}

    public int getDateStyle() {
		return (DateStyle);
	}

	public void setread_tobool(boolean bool) {read_tobool = bool;}
	public void setread_ccbool(boolean bool) {read_ccbool = bool;}
	public void setread_frombool(boolean bool) {read_frombool = bool;}
	public void setread_datebool(boolean bool) {read_datebool = bool;}

	public boolean getread_tobool() {return (read_tobool);}
	public boolean getread_ccbool() {return (read_ccbool);}
	public boolean getread_frombool() {return (read_frombool);}
	public boolean getread_datebool() {return (read_datebool);}

	public void setSubject(String sub) {readsubjecttext.setText(sub);}
	public void setFrom(String frm)    {readfromtext.setText(frm);}
	public void setTo(String to)       {readtotext.setText(to);}
	public void setCc(String cc)       {readtotext.setText(cc);}
	public void setDate(String dat)    {readdatetext.setText(dat);}

	public void setreadMessage(boolean bool)    {readMessagebool = bool;}
	public void setreadHTML(boolean bool)       {readHTMLbool = bool;}
	public void setreadImage(boolean bool)      {readImagebool = bool;}
	public void setreadString(boolean bool)     {readStringbool = bool;}
	public void setreadAttach(boolean bool)     {readAttachbool = bool;}
	public void setreadMultipart(boolean bool)  {readMultipartbool = bool;}
	public void setwrite(boolean bool)          {writebool = bool;}
	public void setwriteAttach(boolean bool)    {write_attach_bool = bool;}

	public boolean getreadMessage()   {return (readMessagebool);}
	public boolean getreadHTML()      {return (readHTMLbool);}
	public boolean getreadImage()     {return (readImagebool);}
	public boolean getreadString()    {return (readStringbool);}
	public boolean getreadAttach()    {return (readAttachbool);}
	public boolean getreadMultipart() {return (readMultipartbool);}  
	public boolean getwrite()         {return (writebool);}
	public boolean getwriteAttach()   {return (write_attach_bool);}

	public void setwrite_subjectbool(boolean bool) {write_subjectbool = bool;}
	public void setwrite_tobool(boolean bool) {write_tobool = bool;}
	public void setwirte_ccbool(boolean bool) {write_ccbool = bool;}
	public void setwirte_bccbool(boolean bool) {write_bccbool = bool;}
	public void setwirte_replytobool(boolean bool) {write_replytobool = bool;}
	public void setwrite_textareabool(boolean bool) {write_textareabool = bool;}

	public boolean SubjectisFocused() {return (write_subjectbool);}
	public boolean ToisFocused() {return (write_tobool);}
	public boolean CcisFocused() {return (write_ccbool);}
	public boolean BccisFocused() {return (write_bccbool);}
	public boolean ReplyToisFocused() {return (write_replytobool);}
	public boolean TextareaisFocused() {return (write_textareabool);}

	public void setwirte_subjectShowable(boolean bool) {write_subjectshowbool = bool;}
	public void setwirte_toShowable(boolean bool) {write_toshowbool = bool;}
	public void setwirte_ccShowable(boolean bool) {write_ccshowbool = bool;}
	public void setwirte_bccShowable(boolean bool) {write_bccshowbool = bool;}
	public void setwirte_replytoShowable(boolean bool) {write_replytoshowbool = bool;}

	public boolean SubjectisShowed() {return(write_subjectshowbool);}
	public boolean ToisShowed() {return(write_toshowbool);}
	public boolean CcisShowed() {return(write_ccshowbool);}
	public boolean BccisShowed() {return(write_bccshowbool);}
	public boolean ReplyToisShowed() {return(write_replytoshowbool);}

	public void setwrite_finishbuttonbool(boolean bool) {write_finishbuttonbool = bool;}
	public void setwrite_finishbuttonShowable(boolean bool) {write_finishbuttonbool = bool;}
	public boolean FinishButtonisShowed() {return (write_finishbuttonbool);}

	protected void refresh() {
		SwingUtilities.invokeLater(new Runnable() {
		  public void run() {
			  pane.setVisible(false);
			  pane.setVisible(true);
			  pane.show();
		  }
		});
	}

	public void Terminator() {
		FilezapTimer.stop();
		int limit = FileStore.size();
		for (int count=0; count<limit; count++) {
			((File)(FileStore.elementAt(0))).delete();
			FileStore.removeElementAt(0);
		}
	}

	public void print(String string)   {
		System.out.println(string);
	}

	public void trace(Exception exception) {
		exception.printStackTrace();
	}
	
	public void setLocale(Locale locale) {
		if (getwriteAttach()) { 
			if (((String)(((TableColumn)(((DefaultTableColumnModel)
										  (attachtable.getColumnModel())).getColumn(0)
										 )).getHeaderValue())).equals(getString("AttachTableFile"))) {
				attach_left_is_file = true;
			} else {
				attach_left_is_file = false;
			}
		}
		currentLocale = locale;
		resource = ResourceBundle.getBundle("disp"+sp+"lib"+sp+"resource", locale);
		super.setLocale(locale);
	}

	public static Locale getCurrentLocale() {
		return (currentLocale);
	}

	protected String getString(String key) {
		return (resource.getString(key));
	}
}
