/*
 * @(#)Listeners.java	0.001 1999/11/30
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.disp;

import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;

import yuzu.util.*;
import yuzu.mail.*;


public class Listeners extends Build {

	private static int pre_read_y_scroll = -1;
	private static int     read_y_scroll = -1;
	private static int same_count = 0;
	private static int pre_string_y_scroll = -1;
	private static int    string_y_scroll = -1;
	private static String MailMessageID = "";

	public Listeners() {
		readTimer    = new Timer(100, new readTick());
		stringTimer  = new Timer(200, new stringTick());	
		FilezapTimer = new Timer(60000, new filezapTick());
		FilezapTimer.start();

		writem_disp_header_subject.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				writem_disp_header_subject.setSelected(!SubjectisShowed());
				setwirte_subjectShowable(!SubjectisShowed());
				buildWriteHeader();
				refresh();
			}
		});

		writem_disp_header_to.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				writem_disp_header_to.setSelected(!ToisShowed());
				setwirte_toShowable(!ToisShowed());
				buildWriteHeader();
				refresh();
			}
		});

		writem_disp_header_cc.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				writem_disp_header_cc.setSelected(!CcisShowed());
				setwirte_ccShowable(!CcisShowed());
				buildWriteHeader();
				refresh();
			}
		});

		writem_disp_header_bcc.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				writem_disp_header_bcc.setSelected(!BccisShowed());
				setwirte_bccShowable(!BccisShowed());
				buildWriteHeader();
				refresh();
			}
		});

		writem_disp_header_replyto.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				writem_disp_header_replyto.setSelected(!ReplyToisShowed());
				setwirte_replytoShowable(!ReplyToisShowed());
				buildWriteHeader();
				refresh();
			}
		});

		writem_disp_button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				writem_disp_button.setSelected(!FinishButtonisShowed());
				setwrite_finishbuttonShowable(!FinishButtonisShowed());
				writefinishpane.remove(writefinishfollowpane);
				if (FinishButtonisShowed()) {
					writefinishpane.add(writefinishfollowpane, BorderLayout.CENTER);
				}
				refresh();
			}
		});

		writesubjecttext.addCaretListener(new CaretListener() {
			public void caretUpdate(CaretEvent event) {
				setwrite_subjectbool(true);
				setwrite_tobool(false);
				setwirte_ccbool(false);
				setwirte_bccbool(false);
				setwirte_replytobool(false);
				setwrite_textareabool(false);
			}
		});

		writetotext.addCaretListener(new CaretListener() {
			public void caretUpdate(CaretEvent event) {
				setwrite_subjectbool(false);
				setwrite_tobool(true);
				setwirte_ccbool(false);
				setwirte_bccbool(false);
				setwirte_replytobool(false);
				setwrite_textareabool(false);
			}
		});

		writecctext.addCaretListener(new CaretListener() {
			public void caretUpdate(CaretEvent event) {
				setwrite_subjectbool(false);
				setwrite_tobool(false);
				setwirte_ccbool(true);
				setwirte_bccbool(false);
				setwirte_replytobool(false);
				setwrite_textareabool(false);
			}
		});

		writebcctext.addCaretListener(new CaretListener() {
			public void caretUpdate(CaretEvent event) {
				setwrite_subjectbool(false);
				setwrite_tobool(false);
				setwirte_ccbool(false);
				setwirte_bccbool(true);
				setwirte_replytobool(false);
				setwrite_textareabool(false);
			}
		});

		writereplytotext.addCaretListener(new CaretListener() {
			public void caretUpdate(CaretEvent event) {
				setwrite_subjectbool(false);
				setwrite_tobool(false);
				setwirte_ccbool(false);
				setwirte_bccbool(false);
				setwirte_replytobool(true);
				setwrite_textareabool(false);
			}
		});

		writetextarea.addCaretListener(new CaretListener() {
			public void caretUpdate(CaretEvent event) {
				setwrite_subjectbool(false);
				setwrite_tobool(false);
				setwirte_ccbool(false);
				setwirte_bccbool(false);
				setwirte_replytobool(false);
				setwrite_textareabool(true);
			}
		});

		writefinishbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				mailFinish();
			}
		});

		writem_file_attach.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				fileAttach();
			}
		});

		writem_file_newmail.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				newMail();
			}
		});

		writem_file_fullclear.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				fullClear();
			}
		});

		writem_file_insertsig.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				signatureInsert();
			}
		});

		writem_file_insertfile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				fileInsert();
			}
		});

		writem_file_finish.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				mailFinish();
			}
		});

		attach_file_attach.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				fileAttach();
			}
		});

		attach_file_remove.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				removeAttach();
			}
		});

		menu_edit_paste.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				customPaste();
			}
		});

		menu_edit_copy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				customCopy();
			}
		});

		menu_edit_allcopy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				customAllcopy();
			}
		});

		menu_edit_cut.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				customCut();
			}
		});

		writem_edit_copy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event)  {
				customCopy();
			}
		});

		writem_edit_paste.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event)  {
				customPaste();
			}
		});

		writem_edit_allcopy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event)  {
				customAllcopy();
			}
		});

		writem_edit_cut.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event)  {
				customCut();
			}
		});

		writeheaderpane.addComponentListener(new ComponentListener() {
			public void componentResized(ComponentEvent event)  {
				int width = writeheaderpane.getWidth();
				int column = 0;
				column = (int)((double)width/12) - 2;
				if (column < 5) column = 5;
				writesubjecttext.setColumns(column);
				writetotext.setColumns(column);
				writecctext.setColumns(column);	
				writebcctext.setColumns(column);
				writereplytotext.setColumns(column);
				writeheaderspane.setVisible(false);
				writeheaderspane.setVisible(true);
			}

			public void componentMoved(ComponentEvent event) {}
			public void componentHidden(ComponentEvent event) {}
			public void componentShown(ComponentEvent event) {}
		});
	}

	protected void fileAttach() {
		filechooser.setDialogTitle(getString("AttachDialogTitle"));
		filechooser.setApproveButtonText(getString("AttachDialogButton"));
		int returnVal = filechooser.showOpenDialog(container);
		File targetFile = filechooser.getSelectedFile();
		if(returnVal == JFileChooser.APPROVE_OPTION) {
			if (!getwriteAttach()) {
				buildWriteAttach();
				setLabels_table();
				setwriteAttach(true);
			}
			CellObject obj = new CellObject(targetFile.getName(), targetFile);
			String ContentType = util.getOptContentType(targetFile.getName());
			Vector rowdata = new Vector();
			rowdata.addElement(obj);
			rowdata.addElement(ContentType);
			model.addRow(rowdata);
		}
	}

	protected void removeAttach() {
		int[] selected = attachtable.getSelectedRows();
		int limit = selected.length;
		for (int count=limit-1; count>=0; count--) {
			model.removeRow(selected[count]);
		}
		limit = model.getRowCount();
		if (limit == 0) {
			removeWriteAttach();
			setwriteAttach(false);
		}
	}

	protected void removeAllAttach() {
		int limit = attachtable.getRowCount();
		for (int count=0; count<limit; count++) {
			model.removeRow(0);
		}
		removeWriteAttach();
		setwriteAttach(false);
	}

	protected void newMail() {
		fullClear();
		setwirte_subjectShowable(true);
		writem_disp_header_subject.setSelected(true);
		setwirte_toShowable(true);
		writem_disp_header_to.setSelected(true);
		setwirte_ccShowable(false);
		writem_disp_header_cc.setSelected(false);
		setwirte_bccShowable(false);
		writem_disp_header_bcc.setSelected(false);
		setwirte_replytoShowable(false);
		writem_disp_header_replyto.setSelected(false);
		buildWriteHeader();
		refresh();
		signatureInsert();
	}

	protected void fullClear() {
		writesubjecttext.setText("");
		writetotext.setText("");
		writecctext.setText("");
		writebcctext.setText("");
		writereplytotext.setText("");
		writetextarea.setText("");
		MailMessageID = "";
		removeAllAttach();
	}

	protected void signatureInsert() {
		int position = writetextarea.getCaretPosition();
		StringBuffer buffer = new StringBuffer();
		SignatureObject signatrure = util.getSignatureData();
		buffer.append(signatrure.getDefaultHeader());
		buffer.append(separator);
		buffer.append(signatrure.getDefaultFooter());
		writetextarea.insert(buffer.toString(), position);
		writetextarea.setCaretPosition(position + signatrure.getDefaultHeader().length());
	}

	protected void fileInsert() {
		int position = writetextarea.getCaretPosition();
		StringBuffer buffer = new StringBuffer();
		int returnVal = filechooser.showOpenDialog(container);
		File targetFile = filechooser.getSelectedFile();
		if(returnVal == JFileChooser.APPROVE_OPTION) {
			try {
				BufferedReader input  = new BufferedReader(new FileReader(targetFile));
				String line = input.readLine();
				while (line != null) {
					buffer.append(line + separator);
					line = input.readLine();
				}
				writetextarea.insert(buffer.toString(), position);
				refresh();
				writetextarea.setCaretPosition(position);
			} catch (Exception exception) {
				trace(exception);
			}
		}
	}

	public void customCopy() {
		if (getreadMessage()) {
			readtext.copy();
		} else if (getreadHTML()) {
			htmltext.copy();
		} else if (getreadString()) {
			stringarea.copy();
		} else if (getwrite()) {
			if (writesubjecttext.hasFocus()) {
				if (SubjectisShowed()) writesubjecttext.copy();
			} else if (writetotext.hasFocus()) {
				if (ToisShowed()) writetotext.copy();
			} else if (writecctext.hasFocus()) {
				if (CcisShowed()) writecctext.copy();
			} else if (writebcctext.hasFocus()) {
				if (BccisShowed()) writebcctext.copy();
			} else if (writereplytotext.hasFocus()) {
				if (ReplyToisShowed()) writereplytotext.copy();
			} else if (writetextarea.hasFocus()) {
				writetextarea.copy();
			}
		}
	}

	public void customCut() {
		if (getwrite()) {
			if (writesubjecttext.hasFocus()) {
				if (SubjectisShowed()) {
					writesubjecttext.copy();
					writesubjecttext.cut();
				}
			} else if (writetotext.hasFocus()) {
				if (ToisShowed()) {
					writetotext.copy();
					writetotext.cut();
				}
			} else if (writecctext.hasFocus()) {
				if (CcisShowed()) {
					writecctext.copy();
					writecctext.cut();
				}
			} else if (writebcctext.hasFocus()) {
				if (BccisShowed()) {
					writebcctext.copy();
					writebcctext.cut();
				}
			} else if (writereplytotext.hasFocus()) {
				if (ReplyToisShowed()) {
					writereplytotext.copy();
					writereplytotext.cut();
				}
			} else if (writetextarea.hasFocus()) {
				writetextarea.copy();
				writetextarea.cut();
			} 
		}
	}

	public void customAllcopy() {
		if (getreadMessage()) {
			readtext.select(0, readtext.getText().length());
			readtext.copy();
		} else if (getreadHTML()) {
			htmltext.select(0, htmltext.getText().length());
			htmltext.copy();
		} else if (getreadString()) {
			stringarea.select(0, stringarea.getText().length());
			stringarea.copy();
		} else if (getwrite()) {
			if (writesubjecttext.hasFocus()) {
				if (SubjectisShowed()) {
					writesubjecttext.select(0, writesubjecttext.getText().length());
					writesubjecttext.copy();
				}
			} else if (writetotext.hasFocus()) {
				if (ToisShowed()) {
					writetotext.select(0, writetotext.getText().length());
					writetotext.copy();
				}
			} else if (writecctext.hasFocus()) {
				if (CcisShowed()) {
					writecctext.select(0, writecctext.getText().length());
					writecctext.copy();
				}
			} else if (writebcctext.hasFocus()) {
				if (BccisShowed()) {
					writebcctext.select(0, writebcctext.getText().length());
					writebcctext.copy();
				}
			} else if (writereplytotext.hasFocus()) {
				if (ReplyToisShowed()) {
					writereplytotext.select(0, writereplytotext.getText().length());
					writereplytotext.copy();
				}
			} else if (writetextarea.hasFocus()) {
				writetextarea.select(0, writetextarea.getText().length());
				writetextarea.copy();
			}
		}
	}

	public void customPaste() {
		try {
			if (getwrite()) {
				if (writesubjecttext.hasFocus()) {
					if (SubjectisShowed()) writesubjecttext.paste();
				} else if (writetotext.hasFocus()) {
					if (ToisShowed()) writetotext.paste();
				} else if (writecctext.hasFocus()) {
					if (CcisShowed()) writecctext.paste();
				} else if (writebcctext.hasFocus()) {
					if (BccisShowed()) writebcctext.paste();
				} else if (writereplytotext.hasFocus()) {
					if (ReplyToisShowed()) writereplytotext.paste();
				} else if (writetextarea.hasFocus()) {
					writetextarea.paste();
				}
			}
		} catch (Exception exception) {}
	}

	public void customPaste(String buffer) {
		String org  = "";
		String pre  = "";
		String post = "";
		if (getwrite()) {
			if (SubjectisFocused()) {
				if (SubjectisShowed()) {
					org  = writesubjecttext.getText();
					pre  = org.substring(0, writesubjecttext.getCaretPosition());
					if (writesubjecttext.getCaretPosition() < org.length()) {
						post = org.substring(writesubjecttext.getCaretPosition() + 1, org.length());
					} else {
						if (!pre.trim().endsWith(",") && !pre.trim().equals("")) {
							pre += ", ";
						}
					}
					writesubjecttext.setText(pre + buffer + post);
				}
			} else if (ToisFocused()) {
				if (ToisShowed()) {
					org  = writetotext.getText();
					pre  = org.substring(0, writetotext.getCaretPosition());
					if (writetotext.getCaretPosition() < org.length()) {
						post = org.substring(writetotext.getCaretPosition() + 1, org.length());
					} else {
						if (!pre.trim().endsWith(",") && !pre.trim().equals("")) {
							pre += ", ";
						}
					}
					writetotext.setText(pre + buffer + post);
				}
			} else if (CcisFocused()) {
				if (CcisShowed()) {
					org  = writecctext.getText();
					pre  = org.substring(0, writecctext.getCaretPosition());
					if (writecctext.getCaretPosition() < org.length()) {
						post = org.substring(writecctext.getCaretPosition() + 1, org.length());
					} else {
						if (!pre.trim().endsWith(",") && !pre.trim().equals("")) {
							pre += ", ";
						}
					}
					writecctext.setText(pre + buffer + post);
				}
			} else if (BccisFocused()) {
				if (BccisShowed()) {
					org  = writebcctext.getText();
					pre  = org.substring(0, writebcctext.getCaretPosition());
					if (writebcctext.getCaretPosition() < org.length()) {
						post = org.substring(writebcctext.getCaretPosition() + 1, org.length());
					} else {
						if (!pre.trim().endsWith(",") && !pre.trim().equals("")) {
							pre += ", ";
						}
					}
					writebcctext.setText(pre + buffer + post);
				}
			} else if (ReplyToisFocused()) {
				if (ReplyToisShowed()) {
					org  = writereplytotext.getText();
					pre  = org.substring(0, writereplytotext.getCaretPosition());
					if (writereplytotext.getCaretPosition() < org.length()) {
						post = org.substring(writereplytotext.getCaretPosition() + 1, org.length());
					} else {
						if (!pre.trim().endsWith(",") && !pre.trim().equals("")) {
							pre += ", ";
						}
					}
					writereplytotext.setText(pre + buffer + post);
				}
			} else if (TextareaisFocused()) {
				writetextarea.insert(buffer, writetextarea.getCaretPosition());
			}
		}
	}

	public void setOptPanel() {
		if (mail.isMessage()) {
			if (!getreadMessage()) removeAll();
			menu_edit_copy.setEnabled(true);
			setMessageView();
		} else if (mail.isHTMLMessage()) {
			if (!getreadHTML()) removeAll();
			menu_edit_copy.setEnabled(true);
			setHTMLView();
		} else if (mail.isString()) {
			if (!getreadString()) removeAll();
			menu_edit_copy.setEnabled(true);
			setStringView();
		} else if (mail.isImage()) {
			if (!getreadImage()) removeAll();
			menu_edit_copy.setEnabled(false);
			setImageView();
		} else if (mail.isInputStream()) {
			if (!getreadAttach()) removeAll();
			menu_edit_copy.setEnabled(false);
			setAttachView();
		} else if (mail.isMultipart()) {
			if (!getreadMultipart()) removeAll();
			menu_edit_copy.setEnabled(false);
			setMultipartView();
		} else {
		}
	}

	public void setreadOptObject() {
		if (getreadMessage()) {
			setMessageContent();
		} else if (getreadHTML()) {
			setHTMLContent();
		} else if (getreadImage()) {
			setImageContent();
		} else if (getreadString()) {
			setStringContent();
		} else if (getreadAttach()) {
			setAttachContent();
		} else if (getreadMultipart()) {
			setMultipartContent();
		}
		pane.setVisible(false);
		pane.setVisible(true);
	}

	public void setWritePanel() {
		setWriteView();
		pane.setVisible(false);
		pane.setVisible(true);
	}

	public void setMessageContent() {
		String message = null;
		try {
			pane.remove(readscroll);
			pane.add(readbasepane, BorderLayout.CENTER);
			readdocument.remove(0, readdocument.getLength());
			readsubjecttext.setText(mail.getMessageSubject());

			setread_frombool(false); 
			readfromtext.setText(mail.getMessageFrom());
			if (mail.getHeaderBool()) setread_frombool(true); 

			setread_tobool(false); 
			readtotext.setText(mail.getMessageTo());
			if (mail.getHeaderBool()) setread_tobool(true); 
			
			setread_ccbool(false); 
			readcctext.setText(mail.getMessageCc());
			if (mail.getHeaderBool()) setread_ccbool(true);

			setread_datebool(false); 
			readdatetext.setText(
				 DateFormat.getDateInstance(getDateStyle(), 
				 getCurrentLocale()).format(mail.getMessageDateObject())
			);
			if (mail.getHeaderBool()) setread_datebool(true);
			buildMessageReadHeader();
			
			message = mail.getMailMessage();

			File tempFile = util.getTempFile();
			BufferedWriter output = new BufferedWriter(new FileWriter(tempFile));
			output.write(message);
			output.close();

			BufferedReader input  = new BufferedReader(new FileReader(tempFile));
			String line = input.readLine();
			while (line != null) {
				if (line.trim().startsWith(">")) {
					readdocument.insertString(readdocument.getLength(), line, readstyle1);
				} else if (line.trim().startsWith("#") || 
						   line.trim().startsWith("_") || 
						   line.trim().startsWith("|") ) {
					readdocument.insertString(readdocument.getLength(), line, readstyle2);
				} else if (line.trim().startsWith("yuzu error: ")) {
					readdocument.insertString(readdocument.getLength(), line, readstyle4);
				} else {
					readdocument.insertString(readdocument.getLength(),
											  line, readstyle3);
				}
				readdocument.insertString(readdocument.getLength(), separator, null);
				line = input.readLine();
			}
			readTimer.start();
			tempFile.delete();
		} catch (Exception exception) {
			trace(exception);
			tempFile.delete();
		}
	}
	public void setHTMLContent() {
		try {
			htmlsubjecttext.setText(getString("HTML"));
			tempFile = util.getTempFile();
			FileStore.addElement(tempFile);
			out = new BufferedWriter(new FileWriter(tempFile));
			out.write(mail.getHTMLMessage());
			out.flush();
			htmltext.setPage("file:" + tempFile.getPath());
			out.close();
		} catch (Exception exception) {
			trace(exception);
		}
	}

	public void setImageContent() {
		imagesubjecttext.setText(getString("IMAGE"));
		imagenametext.setText(mail.getMailBodypartFileName());
		imagetypetext.setText(mail.getMailBodypartContentType());
		tempFile = util.getTempFile();
		FileStore.addElement(tempFile);
		mail.writeImagetoFile(tempFile);
		attachimage.setIcon(new ImageIcon(tempFile.getPath()));
	}

	public void setStringContent() {
		stringsubjecttext.setText(getString("STRING"));
		stringnametext.setText(mail.getMailBodypartFileName());
		stringtypetext.setText(mail.getMailBodypartContentType());
		pane.remove(stringscroll);
		pane.add(stringbasepane, BorderLayout.CENTER);
		stringarea.setText(mail.getTextString());
		stringTimer.start();
	}

	public void setAttachContent() {
		attachsubjecttext.setText(getString("ATTACH"));
		attachnametext.setText(mail.getMailBodypartFileName());
		attachtypetext.setText(mail.getMailBodypartContentType());
	}

	public void setMultipartContent() {
		multipartsubjecttext.setText(getString("MULTIPART"));
	}

	public void setNone() {
		removeAll();
		pane.setVisible(false);
		pane.setVisible(true);
	}

	class readTick implements ActionListener {
		public void actionPerformed(ActionEvent event) {
			read_y_scroll = readverbar.getValue();

			if (read_y_scroll == pre_read_y_scroll) {
				++same_count;
			} else {
				same_count = 0;
			}

			if (same_count > 2) {
				readTimer.stop();
				same_count = 0;
				readverbar.setValue(0);
				pane.remove(readbasepane);
				readscroll.setViewportView(readbasepane);
				pane.add(readscroll, BorderLayout.CENTER);
				pane.setVisible(false);
				pane.setVisible(true);
			} else {
				pre_read_y_scroll = read_y_scroll;
			}
		}
	}

	class stringTick implements ActionListener {
		public void actionPerformed(ActionEvent event) {
			string_y_scroll = stringverbar.getValue();
			if (string_y_scroll == pre_string_y_scroll) {
				stringTimer.stop();
				stringverbar.setValue(0);
				pane.remove(stringbasepane);
				stringscroll.setViewportView(stringbasepane);
				pane.add(stringscroll, BorderLayout.CENTER);
				pane.setVisible(false);
				pane.setVisible(true);
			} else {
				pre_string_y_scroll = string_y_scroll;
			}
		}
	}

	class filezapTick implements ActionListener {
		public void actionPerformed(ActionEvent event) {
			int limit = FileStore.size();
			if (limit != 0) {
				((File)(FileStore.elementAt(0))).delete();
				FileStore.removeElementAt(0);
			}
		}
	}

	public void mailFinish() {
		String subject = writesubjecttext.getText();
		String to = writetotext.getText();
		String cc = writecctext.getText();
		String bcc = writebcctext.getText();
		String replyto = writereplytotext.getText();
		String text = writetextarea.getText();
		if (subject.equals("")) subject = getString("NoSubject");
		if (!to.equals("") || !cc.equals("") || !bcc.equals("")) {
			UserInfoObject userinfo = util.getUserInfoData();
			mail = new DMail();
			mail.setSendMessage();
			mail.setSendMailSubject(subject);
			if (!to.equals(""))  mail.setSendMailTo(to);
			if (!cc.equals(""))  mail.setSendMailCc(cc);
			if (!bcc.equals("")) mail.setSendMailBcc(cc);
			if (!replyto.equals("")) {
				mail.setSendMailReplyTo(replyto);
			} else {
				// mail.setSendMailReplyTo(userinfo.getUsername() + " " +
				//						"<" + userinfo.getFromaddress() + ">");
			}
			mail.setSendMailFrom(userinfo.getUsername() + " " +
								 "<" + userinfo.getFromaddress() + ">");
			if (userinfo.getOrganization() != null) {
				mail.setSendMailOrganization(userinfo.getOrganization());
			}
			if (!MailMessageID.equals("")) {
				mail.setSendMailInReplyto(MailMessageID);
			}
			
			if (getwriteAttach()) {
				int filenum = 0;
				int typenum = 1;
				if (attach_left_is_file) {
					filenum = 0;
					typenum = 1;
				} else {
					filenum = 1;
					typenum = 0;
				}
				int limit = model.getRowCount();
				File[] attachfiles = new File[limit];
				String[] contenttype = new String[limit];
				for (int count=0; count<limit; count++) {
					attachfiles[count] = (File)(((CellObject)(
							attachtable.getValueAt(count, filenum))).getFile());
					contenttype[count] = util.getOptContentType(attachfiles[count]);
				}
				mail.setSendMailAttachmentText(text);
				mail.setSendMailAttachment(attachfiles, contenttype);
			} else {
				mail.setSendMailText(text);
			}
			
			File targetFile = util.getNextFile(util.getDraftDir());
			mail.writeMessage(new File(util.getDraftDir(), targetFile.getName()));
			util.addtoCache(util.getDraftDir(),targetFile);
			table.addFields(util.getDraftDir());
			
			writesubjecttext.setText("");
			writetotext.setText("");
			writecctext.setText("");
			writebcctext.setText("");
			writereplytotext.setText("");
			writetextarea.setText("");
			MailMessageID = "";
			
			removeAllAttach();
		} else {
			// $B08$F@h$,$J$$$H$$$&%@%$%"%m%0$NI=<((B
		}
	}

	public void buildReturnMail(File[] target) {
		writesubjecttext.setText("");
		writetotext.setText("");
		writecctext.setText("");
		writebcctext.setText("");
		writereplytotext.setText("");
		writetextarea.setText("");
		MailMessageID = "";

		setNone();
		setWritePanel();

		SignatureObject signatrure = util.getSignatureData();
		writetextarea.append(signatrure.getDefaultHeader());

		setwirte_ccShowable(false);
		writem_disp_header_cc.setSelected(false);

		setwirte_replytoShowable(false);
		writem_disp_header_replyto.setSelected(false);

		mail = new DMail();
		int limit = target.length;
		for (int count=0; count<limit; count++) {
			mail.readMessage(target[count]);
			MailMessageID = mail.getMessageMessageID();
			if (!mail.getHeaderBool()) {
				MailMessageID = "";
			}
			
			String subject = mail.getMessageSubject();
			String returnsubject = null;
			if (subject.length() > 3) {
				String subjectstart = subject.substring(0, 3);
				if (subjectstart.equalsIgnoreCase("Re:")) {
					returnsubject = subject;
				} else if (subjectstart.equalsIgnoreCase("Re[")) {
					try {
						StringTokenizer analy = new StringTokenizer(subject, "[]");
						analy.nextToken();
						String number = analy.nextToken();
						int mailnumber = Integer.parseInt(number); 
						++mailnumber;
						number = Integer.toString(mailnumber); 
						returnsubject = "Re[" + number + "]"+ 
							subject.substring(subject.indexOf("]")+1, subject.length());
					} catch (Exception exception) {
						returnsubject = subject;
					}
				} else if (subjectstart.startsWith("[")) {
					try {
						subject = subject.substring(subject.indexOf("]")+1, subject.length()).trim();
						if (subject.length() > 3) {
							subjectstart = subject.substring(0, 3);
							if (subjectstart.equalsIgnoreCase("Re:")) {
								returnsubject = subject;
							} else if (subjectstart.equalsIgnoreCase("Re[")) {
								try {
									StringTokenizer analy = new StringTokenizer(subject, "[]");
									analy.nextToken();
									String number = analy.nextToken();
									int mailnumber = Integer.parseInt(number); 
									++mailnumber;
									number = Integer.toString(mailnumber); 
									returnsubject = "Re[" + number + "]"+ 
										subject.substring(subject.indexOf("]")+1, subject.length());
								} catch (Exception exception) {
									returnsubject = subject;
								}
							} else {
								returnsubject = "Re: " + subject;
							}
						} else {
							returnsubject = "Re: " + subject;
						}
					} catch (Exception exception) {
						returnsubject = "Re: " + subject;
					}
				} else {
					returnsubject = "Re: " + subject;
				}
			} else {
				returnsubject = "Re: " + subject;
			}
			if (writesubjecttext.getText().length() > 0) {
				if (writesubjecttext.getText().indexOf(returnsubject) == -1) {
					writesubjecttext.setText(writesubjecttext.getText() + " & " + 
											 returnsubject);
				}
			} else {
				writesubjecttext.setText(returnsubject);
			}
			setwirte_subjectShowable(true);
			writem_disp_header_subject.setSelected(true);
			
			String replyto = mail.getMessageReplyTo();
			if (writetotext.getText().length() > 0) {
				if (mail.getHeaderBool()) {
					if (writetotext.getText().indexOf(replyto) == -1) {
						writetotext.setText(writetotext.getText() + ", " + 
											replyto);
					}
				} else {
					if (writetotext.getText().indexOf(replyto) == -1) {
						writetotext.setText(writetotext.getText() + ", " + 
											mail.getMessageFrom());
					}
				}
			} else {
				if (mail.getHeaderBool()) {
					writetotext.setText(replyto);
				} else {
					writetotext.setText(mail.getMessageFrom());
				}
			}
			setwirte_toShowable(true);
			writem_disp_header_to.setSelected(true);
			
			String cc = mail.getMessageCc();
			if (mail.getHeaderBool()) {
				if (writecctext.getText().indexOf(cc) == -1) {
					if (writecctext.getText().length() == 0) {
						writecctext.setText(cc);
					} else {
						writecctext.setText(writecctext.getText() + ", " + 
											cc);
					}
				} 
				setwirte_ccShowable(true);
				writem_disp_header_cc.setSelected(true);
			}
			
			String to = mail.getMessageTo();
			StringTokenizer analy = null;
			String buffer = null;
			UserInfoObject userinfo = util.getUserInfoData();
			String usermailaddress = userinfo.getFromaddress();
			if (mail.getHeaderBool()) {
				analy = new StringTokenizer(to, ",");
				if (analy.hasMoreTokens()) {
					boolean bool = true;
					buffer = analy.nextToken();
					if (analy.countTokens() == 0) {
						if (buffer.indexOf(replyto) != -1) {
							bool = false;
						}
					}
					if (bool) {
						if (buffer.indexOf(usermailaddress) == -1) {
							if (writecctext.getText().equals("")) {
								writecctext.setText(buffer);
							} else {
								writecctext.setText(writecctext.getText() + ", " + buffer);
							}
							setwirte_ccShowable(true);
							writem_disp_header_cc.setSelected(true);
						}
						while (analy.hasMoreTokens()) {
							buffer = analy.nextToken();
							writecctext.setText(writecctext.getText() + ", " + buffer);
						}
					}
				}
			}
			
			writetextarea.append(separator);
			
			String mailtext = mail.getMailMessage();
			analy = new StringTokenizer(mailtext, separator);
			while (analy.hasMoreTokens()) {
				writetextarea.append("> " + analy.nextToken());
				writetextarea.append(separator);
			}
		}
		writetextarea.append(signatrure.getDefaultFooter());

		buildWriteHeader();
		tree.changeNodeToDraft();
		refresh();
	}
}
