/*
 * @(#)Build.java	0.002 99/11/20
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.mail;

import java.io.*;
import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;


public class Build extends Components {

	Build() {
	}

	public void setSmtp(String host) {
		setSmtphost(host);
	}

	public void closeSmtp() {
		multipart = null;
		message = null;
	}

	public void setSendMessage() {
		multipart = new MimeMultipart();
		properties = System.getProperties();
		if (smtphost == null) smtphost = "localhost";
		properties.put("mail.smtp.host", smtphost);
		session = Session.getDefaultInstance(properties, null);
		message = new MimeMessage(session);
		try {
			message.setSentDate(new Date());
			String mailer = getString("MailHeaderXMail");
			mailer = getCodedString(mailer);
			if (mailer == null) mailer = getString("MailHeaderXMail");
			message.setHeader("X-Mailer", mailer);
		}
		catch (MessagingException exception) {
			trace(exception);
		}
	}

	public boolean sendMessage() {
		boolean returncode = false;
		try {
			message.setSentDate(new Date());
		} catch (MessagingException exception) {trace(exception);}

		try {
			Transport.send(message);
			returncode = true;
		}
		catch (SendFailedException exception) {
			trace(exception);
		}
		catch (MessagingException exception) {
			trace(exception);
		}
		return (returncode);
	}

	public void setPop3(String host, String user, String passwd) {
		setPop3host(host);
		setPop3user(user);
		setPop3passwd(passwd);
	}

	public void connectPop3() {
		properties = System.getProperties();
		session = Session.getDefaultInstance(properties, null);
		try {
			store = session.getStore("pop3");
			store.connect(pop3host, pop3port, pop3user, pop3passwd);
			folder = store.getDefaultFolder();
			folder = folder.getFolder(pop3folder);
			folder.open(Folder.READ_WRITE);
		}
		catch (NoSuchProviderException excaption) {
			trace(excaption);
		}
		catch (MessagingException excaption) {
			trace(excaption);
		}
	}

	public Message getPop3Message() {
		message = null;
		try {
			message = folder.getMessage(1);
			message.setFlag(Flags.Flag.DELETED, true);
		}
		catch (MessagingException exception) {
			trace(exception);
		}
		return(message);
	}

	public Message getPop3Message(int number) {
		message = null;
		try {
			message = folder.getMessage(number);
			message.setFlag(Flags.Flag.DELETED, true);
		}
		catch (MessagingException exception) {
		}
		return(message);
	}

	public int getTotalMessage() {
		totalMessages = -1;
		try {
			totalMessages = folder.getMessageCount();
		}
		catch (MessagingException exception) {
			trace(exception);
		}
		return (totalMessages);
	}

	public int getLastReadMessageNumber() {
		int newmessages = 0;
		closePop3(false);
		newmessages = POP3EnhanceUtil.getLastMessageNumber(getPop3host(), getPop3user(),
														   getPop3passwd(), getPop3port());
		// connectPop3();
		return (newmessages);
	}

	public void closePop3(boolean bool) {
		try {
			folder.close(bool);
			store.close();
		} catch (MessagingException exception) {
			trace(exception);
		}
	}

	public void setSendMailTo(String[] to) {
		try {
			InternetAddress[] address = new InternetAddress[to.length];
			for (int count=0; count<to.length; count++) {
				address[count] = new InternetAddress(to[count]);
			}
			message.setRecipients(Message.RecipientType.TO, address);
		}
		catch (AddressException exception) {
			trace(exception);
		}
		catch(MessagingException exception) {
			trace(exception);
		}
	}
	
	public void setSendMailTo(String to) {
		setSendMailTo(getStringsfromLine(getCodedStringasAddressForm(to)));
	}

	public void setSendMailCc(String[] cc) {
		try {
			InternetAddress[] address = new InternetAddress[cc.length];
			for (int count=0; count<cc.length; count++) {
				address[count] = new InternetAddress(cc[count]);
			}
			message.setRecipients(Message.RecipientType.CC, address);
		}
		catch (AddressException exception) {
			trace(exception);
		}
		catch(MessagingException exception) {
			trace(exception);
		}
	}

	public void setSendMailCc(String cc) {
		setSendMailCc(getStringsfromLine(getCodedStringasAddressForm(cc)));
	}

	public void setSendMailBcc(String[] bcc) {
		try {
			InternetAddress[] address = new InternetAddress[bcc.length];
			for (int count=0; count<bcc.length; count++) {
				address[count] = new InternetAddress(bcc[count]);
			}
			message.setRecipients(Message.RecipientType.BCC, address);
		}
		catch (AddressException exception) {
			trace(exception);
		}
		catch(MessagingException exception) {
			trace(exception);
		}
	}

	public void setSendMailBcc(String bcc) {
		setSendMailBcc(getStringsfromLine(getCodedStringasAddressForm(bcc)));
	}

	public void setSendMailFrom(String[] from) {
		try {
			Address[] froms = new InternetAddress[from.length];
			for (int count=0; count<from.length; count++) {
				froms[count] = new InternetAddress(from[count]);
			}
			message.setFrom(froms[0]);
		} catch(Exception exception) {
			trace(exception);
		}
	}

	public void setSendMailFrom(String from) {
		setSendMailFrom(getStringsfromLine(getCodedStringasAddressForm(from)));
	}

	public void setSendMailReplyTo(String[] replyto) {
		try {
			Address[] replytos = new InternetAddress[replyto.length];
			for (int count=0; count<replyto.length; count++) {
				replytos[count] = new InternetAddress(replyto[count]);
			}
			message.setReplyTo(replytos);
		} catch(Exception exception) {
			trace(exception);
		}
	}

	public void setSendMailReplyTo(String replyto) {
		try {
			String[] line = getStringsfromLine(getCodedStringasAddressForm(replyto));
			String mail = "";
			for (int count=0; count<line.length - 1; count++) {
				mail = mail + line[count] + ", ";
			}
			mail = mail + line[line.length - 1];
			message.setHeader("Reply-To", mail);
			//setSendMailFrom(getStringsfromLine(getCodedStringasAddressForm(replyto)));
		} catch(Exception exception) {
			trace(exception);
		}
	}

	public void setSendMailInReplyto(String inreplyto) {
		try {
			message.setHeader("In-Reply-to", inreplyto);
		} catch(Exception exception) {
			trace(exception);
		}
	}

	public void setSendMailSubject(String subject) {
		try {
			message.setSubject(getCodedString(subject));
		}
		catch(Exception exception) {
			try {
				message.setSubject(subject);
			} catch(Exception exceptionin) {
				trace(exception);
			}
			trace(exception);
		}
	}

	public void setSendMailOrganization(String arg) {
		try {
			message.setHeader("Organization", getCodedString(arg));
		}
		catch(Exception exception) {
			trace(exception);
			try {
				message.setHeader("Organization", arg);
			} catch(Exception exceptionin) {			
				trace(exception);
			}
		}
	}

	public void setSendMailText(String text) {
		try {
			if (System.getProperty("user.region").startsWith("JP")) {
				((MimeMessage)(message)).setText(text, "iso-2022-jp");
				message.setHeader("Content-Type", "text/plain; charset=\"iso-2022-jp\"");
				message.setHeader("Content-Transfer-Encoding", "7bit");
			} else {
				message.setText(text);
			}
		}
		catch(Exception exception) {
			trace(exception);
		}
	}

	public void setSendMailAttachmentText(String text) {
		try {
			MimeBodyPart bodypart = new MimeBodyPart();
			if (System.getProperty("user.region").startsWith("JP")) {
				bodypart.setText(text, "iso-2022-jp");
				bodypart.setHeader("Content-Type", "text/plain; charset=\"iso-2022-jp\"");
				bodypart.setHeader("Content-Transfer-Encoding", "7bit");
			} else {
				bodypart.setText(text);
			}
			multipart.addBodyPart(bodypart);
		} catch(Exception exception) {
			trace(exception);
		}
	}

	public void setSendMailAttachment(File[] attachment, String[] type) {
		MimeBodyPart bodypart = null;
		FileDataSource filedata = null;
		String filename = null;
		for (int count=0; count<attachment.length; count++) {
			try {
				bodypart = new MimeBodyPart();
				filedata = new FileDataSource(attachment[count]);
				bodypart.setDataHandler(new DataHandler(filedata));
				filename = attachment[count].getName();
				try {
					bodypart.setFileName(getCodedString(filename));
				} catch (Exception exception) {
					bodypart.setFileName(filename);
				}
				bodypart.setHeader("Content-Type",type[count]);
				bodypart.setHeader("Content-Transfer-Encoding", "base64");
				multipart.addBodyPart(bodypart);
			}
			catch (MessagingException exception) {
				trace(exception);
			}
		}
		try {
			message.setContent(multipart);
			message.setHeader("Content-Type", multipart.getContentType());
			message.setHeader("Content-Transfer-Encoding", "7bit");
		}
		catch(MessagingException exception) {
			trace(exception);
		}
	}

	public String toBase64(File file) {
		String returncode = null;
		try {
			ByteArrayOutputStream output = new ByteArrayOutputStream();
			FileInputStream input = new FileInputStream(file);

			FilterOutputStream stream = new FilterOutputStream(MimeUtility.encode(output, "base64"));
			ByteArrayOutputStream transfer = new ByteArrayOutputStream();
			
			byte[] buffer = new byte[102400];
			int length = input.read(buffer);
			while (length > 0) {
				transfer.write(buffer, 0, length);
				length = input.read(buffer);
			}
			transfer.writeTo(stream);
			returncode = output.toString();
		} catch (Exception exception) {
			exception.printStackTrace();
			returncode = "";
		}
		return (returncode);
	}

	public void setSendMailAttachment(File attachment, String type) {
		setSendMailAttachment(new File[] {attachment}, new String[] {type});
	}

	public void buildFinish() {
		try {
			message.setContent(multipart);
			message.saveChanges();
		} catch(MessagingException exception) {
			trace(exception);
		}
	}

	public String[] getStringsfromLine(String line) {
		StringTokenizer kenizer = new StringTokenizer(line, ",;");
		int limit = kenizer.countTokens();
		String[] strings = new String[limit];
		String buffer = null;
		int count = 0;
		while (kenizer.hasMoreTokens()) {
			buffer = kenizer.nextToken().trim();
			if (buffer.startsWith("\"") && !buffer.endsWith("\"")) {
				if (kenizer.hasMoreTokens()) {
					buffer = buffer + ", " + kenizer.nextToken().trim();
				}
			}
			strings[count] = buffer;
			++count;
		}
		String[] returncode = new String[count];
		for (int last=0; last<count; last++) {
			if (strings[last].startsWith("<") && strings[last].endsWith(">")) {
				returncode[last] = strings[last].substring(1, strings[last].length()-1);
			} else {
				returncode[last] = strings[last];
			}
		}
		return(returncode);
	}

	public String getMessageSubject() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getSubject());
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageFrom() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromAddress(message.getFrom());
		} catch(MessagingException exception) {
			try {
				line = getStringfromStrings(message.getHeader("From"));
			} catch (Exception inexception) {
				trace(inexception);
			}
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageTo() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getHeader("To"));
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageCc() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getHeader("Cc"));
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageDate() {
		String line = null;
		setHeaderBool(true);
		try {
			line = (message.getSentDate() == null ? 
					null : message.getSentDate().toString());
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public Date getMessageDateObject() {
		Date date = null;
		setHeaderBool(true);
		try {
			date = message.getSentDate();
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		return(date);
	}

	public long getMessageDateLong() {
		long date = 0;
		setHeaderBool(true);
		try {
			date = message.getSentDate().getTime();
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		return(date);
	}

	public String getMessageReplyTo() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromAddress(message.getReplyTo());
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageOrganization() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getHeader("Organization"));
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageReceived() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getHeader("Received"));
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageMessageID() {
		String line = null;
		setHeaderBool(true);
		try {
			line = ((MimeMessage)message).getMessageID();
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageMimeVersion() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getHeader("Mime-Version"));
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageContentType() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getContentType());
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageContentTransferEncoding() {
		String line = null;
		setHeaderBool(true);
		try {
			line = ((MimeMessage)message).getEncoding();
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageReferences() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getHeader("References"));
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageXMailer() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getHeader("X-Mailer"));
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getMessageXUIDL() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(message.getHeader("X-UIDL"));
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
				line = getString("MailHeaderUnknown");
				setHeaderBool(false);
		}
		return(line);
	}

	public String getStringfromStrings(String[] strings) {
		String line = "";
		StringTokenizer analy = null;
		if (strings == null) {
			line = null;
		} else {
			if (!strings[0].trim().equals("")) {
				line = strings[0].trim();
				analy = new StringTokenizer(line, "\r\n");
				line = analy.nextToken().trim();
				while (analy.hasMoreElements()) {
					line = line + analy.nextToken().trim();
				}
				for (int count=1; count<strings.length; count++) {
					analy = new StringTokenizer(strings[count], "\r\n");
					strings[count] = analy.nextToken().trim();
					while (analy.hasMoreElements()) {
						strings[count] = strings[count] + analy.nextToken().trim();
					}
					line = line + ", " + strings[count].trim();
				}
			}
		}
		return(getCorrectTextfromBuggingText(line));
	}

	public String getStringfromStrings(String strings) {
		if (strings == null) return (null);
		if (strings.indexOf("=?") == -1 && strings.indexOf("?=") == -1) {
			if (strings.indexOf("\r") != -1 || strings.indexOf("\n") != -1) {
				strings = getStringfromStrings(new String[] {strings});
			}
			if (strings.length() > getOptString(strings).length()) {
				return (getOptString(strings));
			} else {
				return (strings);
			}
		} else {
			return(getStringfromStrings(new String[] {strings}));
		}
	}
    
    public String getCorrectTextfromBuggingText(String text) {
	if (text == null) return (null);
	
	String buffer = text;
	String analy  = "";
	String result = "";
	String temp = "";
	int first_point = buffer.indexOf("=?");
	int end_poing   = buffer.indexOf("?=");
	if (first_point > -1 && end_poing > -1) {
	    if (first_point > 0) {
		result += buffer.substring(0, first_point);
	    }
	    while (first_point > -1 && end_poing > -1) {
		analy = buffer.substring(first_point, end_poing + 2);
		if (end_poing + 2 < buffer.length()) {
		    buffer = buffer.substring(end_poing + 2, buffer.length());
		} else {
		    buffer = "";
		}
		try {
		    analy = MimeUtility.decodeText(analy);
		} catch (UnsupportedEncodingException exception) {
		    trace(exception);
		}
		result += analy;
		first_point = buffer.indexOf("=?");
		end_poing   = buffer.indexOf("?=");
		if (first_point > 0) {
		    result += buffer.substring(0, first_point);
		}
	    }
	    result += buffer;
	} else {
	    result = buffer;
	}
	return (result);
    }

	
	public String getStringfromAddress(Address[] address) {
		String line = "";
		if (address == null) {
			line = null;
		} else {
			line = address[0].toString();
			for (int count=1; count<address.length; count++) {
				line = line + ", " + address[count].toString();
			}
		}
		return(getCorrectTextfromBuggingText(line));
	}

	public void readSendMessage(File readfile) {
		properties = System.getProperties();
		if (smtphost == null) smtphost = "localhost";
		properties.put("mail.smtp.host", smtphost);
		session = Session.getDefaultInstance(properties, null);
		try {
			message = new MimeMessage(session, new FileInputStream(readfile));
		} catch (Exception exception) {
			trace(exception);
		}
	}

	public void readMessage(File readfile) {
		properties = System.getProperties();
		session = Session.getDefaultInstance(properties, null);
		try {
			message = new MimeMessage(session, new FileInputStream(readfile));
			Object obj = message.getContent();
			if (obj instanceof Multipart) {
				multipart = (Multipart)obj;
			} 
		}
		catch(MessagingException exception) {
			trace(exception);
			message = null;
		}
		catch (FileNotFoundException exception) {
			trace(exception);
			message = null;
		}
		catch (Exception exception) {
			System.out.println("File " + readfile.getPath() + " has some problems.");
			System.out.println(message);
			// trace(exception);
		}
	}

	public void readMessage(String readfile) {
		readMessage(new File(readfile));
	}


	public boolean writeMessage(File writefile) {
		boolean returncode = false;
		try {
			message.writeTo(new FileOutputStream(writefile));
			returncode = true;
		}
		catch (IOException exception) {
			trace(exception);
		}
		catch (MessagingException exception) {
			trace(exception);
		}
		return (returncode);
	}

	public void writeMessage(String writefile) {
		writeMessage(new File(writefile));
	}

	public int getMIMECount() {
		int count=0;
		try {
			count = multipart.getCount();
		} catch (MessagingException exception) {
			trace(exception);
		}
		return (count);
	}

	public boolean isInputStream(int number) {
		try {
			Object obj = multipart.getBodyPart(number).getContent();
			if (obj instanceof InputStream) return (true);
		} catch (Exception exception) {
			trace(exception);
		}
		return (false);
	}

	public boolean isInputStream() {
		if (MailObject instanceof InputStream) return (true);
		return (false);
	}

	public boolean isHTMLMessage() {
		boolean returncode = false;
		try {
			if (MailObject instanceof InputStream) {
				if (MailBodypart != null) {
					if (MailBodypart.getContentType().trim().substring(0,9).equalsIgnoreCase("text/html")) {
						returncode = true;
					}
				}
			} else if (MailObject instanceof String) {
				try {
					if (getMailBodypartContentType().substring(0,9).equalsIgnoreCase("text/html")) {
						returncode = true;
					}
				} catch (Exception exception) {}
			} else if (MailObject instanceof Message) {
				try {
					if ((((MimeMessage)MailObject).getContentType()).trim().substring(0,9).equalsIgnoreCase("text/html")) {
						returncode = true;
					}
				} catch (Exception exception) {}
			}
		} catch (Exception exception) {
			trace(exception);
		}
		return (returncode);
	}

	public boolean isImage() {
		try {
			if (MailObject instanceof InputStream) {
				if (MailBodypart != null) {
				if (MailBodypart.getContentType().trim().substring(0,10).equalsIgnoreCase("image/jpeg") ||
					MailBodypart.getContentType().trim().substring(0,9).equalsIgnoreCase("image/gif")
					) {
					return (true);
				}
			    }
			}
		} catch (Exception exception) {
			trace(exception);
		}
		return (false);
	}


	public boolean isString(int number) {
		try {
			MailBodypart = (MimeBodyPart)(multipart.getBodyPart(number));
			Object obj = MailBodypart.getContent();
			if (obj instanceof String) return (true);
		} catch (Exception exception) {
			trace(exception);
		}
		return (false);
	}

	public boolean isString() {
		if (MailObject instanceof String) return (true);
		return (false);
	}

	public boolean isMessage(int number) {
		try {
			Object obj = multipart.getBodyPart(number).getContent();
			if (obj instanceof Message) {
				try {
					if (!(((MimeMessage)obj).getContentType()).trim().substring(0,9).equalsIgnoreCase("text/html"))
						return (true);
				} catch (Exception exception) {
					trace(exception);
					return (true);
				}
			}
		} catch (Exception exception) {
			trace(exception);
		}
		return (false);
	}

	public boolean isMessage() {
		if (MailObject instanceof Message) {
			try {
				if (!(((MimeMessage)MailObject).getContentType()).trim().substring(0,9).equalsIgnoreCase("text/html"))
					return (true);
			} catch (Exception exception) {
				try {
					if ((((MimeMessage)MailObject).getContentType()).trim().substring(0,4).equalsIgnoreCase("text")) {
						return (true);
					}
				} catch (Exception inexception) {
					trace(inexception);
				}
				return (true);
			}
		}
		return (false);
	}
	
	public boolean isMultipart(int number) {
		try {
			Object obj = multipart.getBodyPart(number).getContent();
			if (obj instanceof Multipart) return (true);
		} catch (Exception exception) {
			trace(exception);
		}
		return (false);
	}
	
	public boolean isMultipart() {
		if (MailObject instanceof Multipart) return (true);
		return (false);
	}

	public MimeMessage getMessage(int number) {
		try {
			return ((MimeMessage)(multipart.getBodyPart(number).getContent()));
		} catch (Exception exception) {
			trace(exception);
		}
		return (null);
	}

	public void setMessage(MimeMessage msg) {
		message = msg;
	}

	public MimeBodyPart getBodyPart(int number) {
		try {
			return ((MimeBodyPart)multipart.getBodyPart(number));
		} catch (Exception exception) {
			trace(exception);
		}
		return (null);
	}

	public void setBodyPart(MimeBodyPart mbp) {
		mimebodypart = mbp;
	}

	public String getBodyContentType() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(mimebodypart.getContentType());
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public String getBodyFileName() {
		String line = null;
		setHeaderBool(true);
		try {
			line = getStringfromStrings(mimebodypart.getFileName());
		}
		catch(MessagingException exception) {
			trace(exception);
		}
		if (line == null) {
			line = getString("MailHeaderUnknown");
			setHeaderBool(false);
		}
		return(line);
	}

	public void movetoAttach(int[] IDs) {
		Object obj = null;;
		int limit = 0;
		if (IDs != null) {
			limit = IDs.length;
			MailObject = multipart;
		} else {
			MailObject = message;
		}
		try {
			for (int count=0; count<limit; count++) {
				MailBodypart = (MimeBodyPart)getBodyPart(IDs[count]);
				MailObject = MailBodypart.getContent();
				if (MailObject instanceof Multipart) {
					multipart = (Multipart)MailObject;
				} else if (MailObject instanceof Message) {
					obj = ((MimeMessage)MailObject).getContent();
					if (obj instanceof Multipart) {
						multipart = (Multipart)obj;
						if (System.getProperty("user.region").startsWith("JP")) {
							MailString = new String(MailString.getBytes("8859_1"), "JISAutoDetect");
						}
					} else if (obj instanceof String) {						
						MailString = (String)obj;

					}
				}
			}
			if (MailObject instanceof Message) {
				message = (MimeMessage)MailObject;
			} else if (MailObject instanceof String) {				
				MailString = (String)MailObject;
				if (System.getProperty("user.region").startsWith("JP")) {
					MailString = new String(MailString.getBytes("8859_1"), "JISAutoDetect");
				}
			} else if (MailObject instanceof InputStream) {
			} else {
			}
		} catch (Exception exception) {
			trace(exception);
		}
	}

	public void savetoFile(File saveFile, File fromFile, int[] targetPath) {
		readMessage(fromFile);
		if (targetPath == null) {
			writeMessage(saveFile);
		} else {
			int number = targetPath[targetPath.length-1];
			movetoAttach(targetPath);
			if (isInputStream(number)) {
				writeInputStream(number, saveFile);
			} else if (isString(number)) {
				writeString(number, saveFile);
			} else if (isMessage(number)) {
				writeMessage(number, saveFile);
			} else if (isMultipart(number)) {
				writeMultipart(saveFile);
			} else {
				writeMultipart(saveFile);

			}
		}
	}

	public void writeInputStream(int number, File saveFile) {
		try {
			BufferedInputStream in = 
				new BufferedInputStream((InputStream)(multipart.getBodyPart(number).getContent()));
			BufferedOutputStream out =
				new BufferedOutputStream(new FileOutputStream(saveFile));
			int length = 8192;
			byte[] buffer = new byte[length];
			length = in.read(buffer);
			while (length > -1) {
				out.write(buffer, 0, length);
				length = in.read(buffer);
			}
			out.close();
			in.close();
		} catch(Exception exception) {
			trace(exception);
		}
	}

	public void writeString(int number, File saveFile) {
		try {
			BufferedWriter out = 
				new BufferedWriter(new FileWriter(saveFile));
			out.write((String)(multipart.getBodyPart(number).getContent()));
			out.flush();
			out.close();
		} catch (Exception exception) {
			trace(exception);
		}
	}

	public void writeMessage(int number, File writefile) {
		try {
			message = (MimeMessage)(multipart.getBodyPart(number).getContent());
			message.writeTo(new FileOutputStream(writefile));
		}
		catch (Exception exception) {
			trace(exception);
		}
	}

	public void writeMultipart(File saveFile) {
		try {
			multipart.writeTo(new FileOutputStream(saveFile));
		} catch (Exception exception) {
			trace(exception);
		}
	}

	public String getFileName(File file, int[] path) {
		String filename = null;
		readMessage(file);
		if (path == null) {
			filename = "mail.txt";
		} else {
			int number = path[path.length-1];
			movetoAttach(path);
			if (isInputStream(number)) {
				setBodyPart(getBodyPart(number));
				filename = getBodyFileName();
				if (!getHeaderBool()) {
					try {
						String type = getBodyContentType().trim();
						if (type.substring(0,9).equalsIgnoreCase("text/html")) {
							filename = "mail.html";
						} else {
							filename = "attachementfile";
						}
					} catch (Exception exception) {
						filename = "attachementfile";
					}
				}
			} else if (isString(number)) {
				filename = "message.txt";
			} else if (isMessage(number)) {
				filename = "mail.txt";
			} else if (isMultipart(number)) {
				filename = "multipart.txt";
			} else {
				filename = "multipart.txt";
			}
		}
		return (filename);
	}

	public String getHeaders() {
		String data = "";
		try {
			String separator = System.getProperty("line.separator");
 			Enumeration list = ((MimeMessage)message).getAllHeaderLines();
			if (list.hasMoreElements()) {
				data = (String)(list.nextElement());
			}
			while(list.hasMoreElements()) {
				data = data + separator + list.nextElement();
			}
		} catch(Exception exception) {
			trace(exception);
			data = null;
		}
		return (data);
	}

	public String getHTMLMessage() {
		StringBuffer buffer = new StringBuffer();
		String separator = System.getProperty("line.separator");
		try {
			if (MailObject instanceof InputStream) {
				BufferedReader fr = 
					new BufferedReader(new InputStreamReader(((InputStream)MailObject)));
				String line = fr.readLine();
				buffer.append(line);
				while (line != null) {
					buffer.append(separator + line);
					line = fr.readLine();
				}
			} else if (MailObject instanceof String) {
				buffer.append((String)MailObject);
			} else if (MailObject instanceof Message) {
				buffer.append((String)(((MimeMessage)MailObject).getContent()));
			} else {
				buffer.append("yuzu error: some problem with this HTML Message.");
			}
		} catch(Exception exception) {
			trace(exception);
		}
		return (buffer.toString());
	}

	public String getMailMessage() {
		String PlainMail = null;
		try {
			PlainMail = (String)(message.getContent());
		} catch (ClassCastException exception) {
			try {
				PlainMail = 
					(String)(((Multipart)(message.getContent())
							  ).getBodyPart(0).getContent());
			} catch (Exception inexception) {
				try {
					PlainMail = 
						(String)(((Multipart)(((Multipart)(message.getContent())
											   ).getBodyPart(0).getContent())).getBodyPart(0).getContent());
				} catch (Exception ininexception) {
					try {
						if (message.getContent() instanceof InputStream) {
							File targetFile = util.getTempFile();
							BufferedOutputStream out 
								= new BufferedOutputStream(new FileOutputStream(targetFile));
							BufferedInputStream in = new BufferedInputStream((InputStream)(message.getContent()));
							int length = 102400;
							byte[] buffer = new byte[length];
							length = in.read(buffer);
							while (length > -1) {
								out.write(buffer, 0, length);
								length = in.read(buffer);
							}
							out.flush();
							out.close();
							in.close();
							BufferedReader reader = new BufferedReader(new FileReader(targetFile));
							StringBuffer stringbuffer = new StringBuffer();
							String line = reader.readLine();
							while (line != null) {
								stringbuffer.append(line + separator);
								line = reader.readLine();
							}
							reader.close();
							PlainMail = stringbuffer.toString();
							if (PlainMail == null) PlainMail = "yuzu error: " + getString("UnsupportText");
						} else {
							System.out.println("This mail may be the code system which is not supported");
							PlainMail = "yuzu error: " + getString("UnsupportText");
							trace(ininexception);
						}
					} catch (Exception lastcheck) {}
				}
			}
		} catch (Exception exception) {
			System.out.println("This mail may be the code system which is not supported");
			PlainMail = "yuzu error: " + getString("UnsupportText");
		}
		return (getOptString(PlainMail));
	}

	public String getMailMessageAsHTML() {
		String PlainMail = null;
		try {
			PlainMail = (String)(message.getContent());
		} catch (ClassCastException exception) {
			try {
				PlainMail = 
					(String)(((Multipart)(message.getContent())
                         ).getBodyPart(0).getContent());
			} catch (Exception inexception) {
				try {
					PlainMail = 
						(String)(((Multipart)(((Multipart)(message.getContent())
											   ).getBodyPart(0).getContent())).getBodyPart(0).getContent());
				} catch (Exception ininexception) {}
			}
		} catch (Exception exception) {}
		try {
			
			String chartype = getMessageContentType();
			StringTokenizer analy = new StringTokenizer(chartype, ";");
			while (analy.hasMoreTokens()) {
				chartype = analy.nextToken().trim();
			}
			String separator = System.getProperty("line.separator");
			String buffer;
			analy = new StringTokenizer(PlainMail, "\n\r");

			buffer = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">" + separator;
			buffer += "<html>" + separator + "\t<head>" + separator;
			buffer 
				+= "\t<meta content=\"text/html; charset="
				+ System.getProperty("file.encoding")
				+ "\" http-equiv=Content-Type>" + separator;
			buffer += "\t<meta content=\"YuzuHTML\" name=YuzuHTMLMaker>" + separator;
			buffer += "\t</head>" + separator + "<body>" + separator;
			String line;
			while (analy.hasMoreTokens()) {
				line = analy.nextToken();
				if (line.startsWith(">")) {
					line = "<font color=\"blue\"><cite>" + line + "</cite></font>";
				} else if (line.startsWith("#")) {
					line = "<font color=\"blue\">" + line + "</font>";
				}
				buffer += line + "<br>" + separator;
			}
			buffer = buffer + "</body>" + separator + "</html>" + separator;
			return (buffer);
		} catch(Exception exception) {
			trace(exception);
		}
		return (null);
	}

	public byte[] getImageBytes() {
		try {
			BufferedInputStream in = new BufferedInputStream((InputStream)MailObject);
			byte[] temp = new byte[1048576];
			byte[] data = new byte[in.read(temp)];
			in = new BufferedInputStream((InputStream)MailObject);
			in.read(data);
			return (data);
		} catch (Exception exception) {
			trace(exception);
		}
		return (null);
	}

	public void writeImagetoFile(File targetFile) {
		try {
			BufferedOutputStream out 
				= new BufferedOutputStream(new FileOutputStream(targetFile));
			BufferedInputStream in = new BufferedInputStream((InputStream)MailObject);
			int length = 102400;
			byte[] buffer = new byte[length];
			length = in.read(buffer);
			while (length > -1) {
				out.write(buffer, 0, length);
				length = in.read(buffer);
			}
			out.flush();
			out.close();
			in.close();
		} catch (Exception exception) {
			trace(exception);
		}
	}

	public String getTextString() {
		return (getOptString(MailString));
	}

	public String getMailBodypartFileName() {
		try {
			return (getStringfromStrings(MailBodypart.getFileName()));
		} catch (Exception exception) {
			trace(exception);
		}
		return(getString("MailHeaderUnknown"));
	}

	public String getMailBodypartContentType() {
		try {
			return (getStringfromStrings(MailBodypart.getContentType()));
		} catch (Exception exception) {
			trace(exception);
		}
		return(getString("MailHeaderUnknown"));
	}

	public String getCodedString(String target) {
		String codedstring = null;
		try {
			if (System.getProperty("user.region").startsWith("JP")) {
				codedstring = MimeUtility.encodeText(target, "iso-2022-jp", null);
			} else {
				codedstring = MimeUtility.encodeText(target);
			}
		} catch (Exception exception) {
			trace(exception);
		}
		return (codedstring);
	}

	public String getCodedStringasAddressForm(String target) {
		String codedstring = null;
		try {
			StringTokenizer analy = new StringTokenizer(target, "<>,");
			String buffer = null;
			String pre = "";
			String post = "";
			if (analy.hasMoreTokens()) {
				buffer = analy.nextToken().trim();
				if (buffer.indexOf("@") == -1) {
					if (buffer.startsWith("\"") && !buffer.endsWith("\"")) {
						if (analy.hasMoreTokens()) {
							buffer = buffer + ", " + analy.nextToken().trim();
						}
					}
					if (buffer.indexOf(" ") != -1) {
						if (buffer.startsWith("\"")) pre = ""; else pre = "\"";
						if (buffer.endsWith("\"")) post = ""; else post = "\"";
					} else {
						pre = "";
						post = "";
					}
					if (System.getProperty("user.region").startsWith("JP")) {
						codedstring = MimeUtility.encodeText(pre + buffer + post, "iso-2022-jp", null);
					} else {
						codedstring = MimeUtility.encodeText(pre + buffer + post);
					}
				} else {
					codedstring = "<" + buffer + ">";
				}
			}
			while (analy.hasMoreTokens()) {
				buffer = analy.nextToken().trim();
				if (buffer.indexOf("@") == -1) {
					if (buffer.indexOf(" ") != -1) {
						if (buffer.startsWith("\"") && !buffer.endsWith("\"")) {
							if (analy.hasMoreTokens()) {
								buffer = buffer + ", " + analy.nextToken().trim();
							}
						}
						if (buffer.startsWith("\"")) pre = ""; else pre = "\"";
						if (buffer.endsWith("\"")) post = ""; else post = "\"";
					} else {
						pre = "";
						post = "";
					}
					if (System.getProperty("user.region").startsWith("JP")) {
						codedstring = codedstring + ", " +  
							MimeUtility.encodeText(pre + buffer + post, "iso-2022-jp", null);
					} else {
						codedstring = codedstring + ", " + MimeUtility.encodeText(pre + buffer + post);
					}
				} else {
					if (codedstring.endsWith(">")) {
						codedstring = codedstring + ", <" + buffer + ">";
					} else {
						codedstring = codedstring + " <" + buffer + ">";
					}
				}
			}
		} catch (Exception exception) {
			exception.printStackTrace();
		}
		return (codedstring);
	}

	public String getOptString(String target) {
		try {
			if (System.getProperty("user.region").startsWith("JP")) {
				return (new String(target.getBytes(), "JISAutoDetect"));
			} 
		} catch (NullPointerException exception) {
			target = "";
		} catch (Exception exception) {
			trace(exception);
		}
		return (new String(target));
	}
}
