/*
 * @(#)Components.java	0.002 99/11/20
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.mail;

import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;

import yuzu.util.*;

public class Components {
	
	protected Properties properties = System.getProperties();
	protected Session session     = null;
	protected Message message     = null;
	protected Multipart multipart = null;
	protected Store store         = null;
	protected Folder folder       = null;
	protected String protocol     = "pop3";
	protected String pop3folder   = "INBOX";
	protected String pop3host     = null;
	protected String pop3user     = null;
	protected String pop3passwd   = null;
	protected String smtphost     = null;
	protected int pop3port        = 110;
	protected int totalMessages;
	protected static MimeBodyPart mimebodypart = null;

	protected static Object MailObject = null;
	protected static String MailString = null;
	protected static MimeBodyPart MailBodypart = null;

	protected static final String sp = System.getProperty("file.separator");
	protected static final String separator = System.getProperty("line.separator");
	private static ResourceBundle resource = 
		ResourceBundle.getBundle("mail"+sp+"lib"+sp+"resource", Locale.getDefault());

	private static boolean HeaderBool = true;


	Components() {
	}

	public void setHeaderBool(boolean bool) {HeaderBool = bool;}
	public boolean getHeaderBool() {return (HeaderBool);}

	public void setSmtphost(String arg) {smtphost = arg;}
	public void setProtocol(String arg) {protocol = arg;}
	public void setPop3folder(String arg) {pop3folder = arg;}
	public void setPop3host(String arg) {pop3host = arg;}
	public void setPop3user(String arg) {pop3user = arg;}
	public void setPop3passwd(String arg) {pop3passwd = arg;}
	public void setPop3port(int arg) {pop3port = arg;}
	public void setMessage(Message arg) {message = arg;}
	public void trace(Exception exception) {exception.printStackTrace();}

	public String getPop3host() {return (pop3host);}
	public String getPop3user() {return (pop3user);}
	public String getPop3passwd() {return (pop3passwd);}
	public int getPop3port() {return (pop3port);}

	protected Utilities util = new Utilities();

	public void print(String string) {
		System.out.println(string);
	}

	public void print(Object obj) {
		System.out.println(obj);
	}

	public void setLocale(Locale locale) {
		resource = ResourceBundle.getBundle("mail"+sp+"lib"+sp+"resource", locale);
	}
	
	protected String getString(String key) {
		return (resource.getString(key));
	}
}
