/*
 * @(#)Listeners.java	0.001 1999/12/09
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.mail.get;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import yuzu.util.*;


public class Listeners extends Build {
	public Listeners() {
		stopbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				do_bool = false;
				dothread.stop();
				stateLabel.setText(getString("stateStop"));
				hideDialog();
				allmailsStat.setText("");
				getedmailsStat.setText("");
				mailserberStat.setText("");
				stateLabel.setText("");
				bar.setValue(0);
				frame.removeNotify();
			}
		});
	}

	public void startDownload() {
		frame.pack();
		do_bool = true;
		bar.setValue(0);
		showDialog();
		dothread = new Thread(new MailDownload());
		dothread.start();
		while (do_bool) {
			try {Thread.sleep(500);} catch(Exception exception) {}
		}
		dothread.stop();
		hideDialog();
		bar.setValue(0);
		allmailsStat.setText("");
		getedmailsStat.setText("");
		mailserberStat.setText("");
		stateLabel.setText("");
	}

	public void showDialog() {
		frame.setVisible(true);
	}

	public void hideDialog() {
		frame.setVisible(false);
		frame.removeNotify();
	}

	protected void Terminator() {
		do_bool = false;
		dothread.stop();
		hideDialog();
		bar.setValue(0);
		allmailsStat.setText("");
		getedmailsStat.setText("");
		mailserberStat.setText("");
		stateLabel.setText("");
	}

	private class MailDownload implements Runnable {
		MailDownload() {}
		
		public void run() {
			Vector pop3data = util.getPOP3Data();
			POP3Object pop3obj = null;
			int allmails = 0;
			int limit = pop3data.size();
			stateLabel.setText(getString("stateChechMails"));
			allmailsStat.setText("0");
			int tempcount = 0;
			for (int count=0; count<limit; count++) {
				pop3obj = (POP3Object)(pop3data.elementAt(count));
				mail.setPop3host(pop3obj.getServer());
				mail.setPop3user(pop3obj.getUser());
				mail.setPop3passwd(pop3obj.getPassword());
				mailserberStat.setText(pop3obj.getServer());
				mail.connectPop3();
				if (pop3obj.isNoDelete()) {
					tempcount = mail.getTotalMessage() - mail.getLastReadMessageNumber();
					if (tempcount > 0) allmails += tempcount;
				} else {
					tempcount = mail.getTotalMessage();
					if (tempcount > 0) allmails += tempcount;
					mail.closePop3(false);
				}
				allmailsStat.setText(Integer.toString(allmails));
			}
			int getedmailcount = 0;
			File targetFile = null;
			if (allmails != 0) {
				stateLabel.setText(getString("stateDownloading"));
				for (int count=0; count<limit; count++) {
					if (allmails != getedmailcount) {
						pop3obj = (POP3Object)(pop3data.elementAt(count));
						mail.setPop3host(pop3obj.getServer());
						mail.setPop3user(pop3obj.getUser());
						mail.setPop3passwd(pop3obj.getPassword());
						mailserberStat.setText(pop3obj.getServer());
						mail.connectPop3();
						int start = 1;
						int mails = mail.getTotalMessage();
						if (pop3obj.isNoDelete()) {
							start = mail.getLastReadMessageNumber() + 1;
							mail.connectPop3();
						}
						for (int count2=start; count2 <= mails; count2++) {
							mail.getPop3Message(count2);
							targetFile = util.getNextFile(util.getInboxDir());
							if (mail.writeMessage(targetFile)) {
								util.addtoCache(util.getInboxDir(), targetFile);
							}
							try {
								if (tree.getCurrentDir().getCanonicalPath().equals(
											  util.getInboxDir().getCanonicalPath())) {
									table.addFields(util.getInboxDir());
								}
							} catch (Exception exception) {}
							++getedmailcount;
							getedmailsStat.setText(Integer.toString(getedmailcount));
							bar.setValue(new Double((double)getedmailcount/allmails*100).intValue());
						}
						if (pop3obj.isNoDelete()) {
							mail.closePop3(false);
						} else {
							mail.closePop3(true);
						}
					}
				}
				bar.setValue(100);
				stateLabel.setText(getString("stateFinish"));
			}
			do_bool = false;
			dothread.stop();
		}
	}
}
