/*
 * @(#)Components.java	0.001 1999/12/21
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.mail.send;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import yuzu.util.*;
import yuzu.tree.*;
import yuzu.table.*;
import yuzu.mail.*;


public class Components extends JFrame {

	protected static Container container = null;
	protected static JFrame frame = null;

	protected static final String sp = System.getProperty("file.separator");
	private static ResourceBundle resource = 
		ResourceBundle.getBundle("mail"+sp+"send"+sp+"lib"+sp+"resource", Locale.getDefault());

	protected static GridBagLayout      statLayout = new GridBagLayout();
	protected static GridBagConstraints statConstraints = new GridBagConstraints();

	protected static JPanel pane       = new JPanel(new BorderLayout());
	protected static JPanel dummpane   = new JPanel();
	protected static JPanel verpane    = new JPanel();
	protected static JPanel progpane   = new JPanel(new FlowLayout(FlowLayout.CENTER));
	protected static JPanel statpane   = new JPanel(statLayout);
	protected static JPanel dummpane2  = new JPanel();
	protected static JPanel buttonpane = new JPanel(new FlowLayout(FlowLayout.CENTER));

	protected static JProgressBar bar = new JProgressBar(0, 100); 
	protected static JButton stopbutton = new JButton();

	protected static Thread dothread = null;
	protected static boolean do_bool = false;

	protected static JPanel allmailsLabelPane = new JPanel(new FlowLayout(FlowLayout.RIGHT));
	protected static JPanel sendedmailsLabelPane = new JPanel(new FlowLayout(FlowLayout.RIGHT));
	protected static JPanel mailserberLabelPane = new JPanel(new FlowLayout(FlowLayout.RIGHT));

	protected static JPanel allmailsStatPane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel sendedmailsStatPane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel mailserberStatPane = new JPanel(new FlowLayout(FlowLayout.LEFT));
	protected static JPanel statePane = new JPanel(new FlowLayout(FlowLayout.CENTER));

	protected static JLabel allmailsLabel = new JLabel();
	protected static JLabel sendedmailsLabel = new JLabel();
	protected static JLabel mailserberLabel = new JLabel();

	protected static JLabel allmailsStat = new JLabel();
	protected static JLabel sendedmailsStat = new JLabel();
	protected static JLabel mailserberStat = new JLabel();
	protected static JLabel stateLabel = new JLabel();

	protected static Utilities util = new Utilities();
	protected static DMail mail = new DMail();

	protected static DTree  tree  = null;
	protected static DTable table = null;

	protected static boolean success_bool = false;
	protected static JOptionPane dialog = new JOptionPane();

	protected static ImageIcon Icon = new ImageIcon("mail"+sp+"send"+sp+"images"+sp+"icon.gif");


	public Components() {
		this.addWindowListener(new Closing());
		try {
			UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);
		}
		catch(UnsupportedLookAndFeelException even) {}
		catch(ClassNotFoundException even) {}
		catch(InstantiationException even) {}
		catch(IllegalAccessException even) {}
		container = super.getContentPane();
		container.setLayout(new BorderLayout());
		frame = this;
	}

	protected class Closing extends WindowAdapter implements ActionListener {
		public void windowClosing(WindowEvent even) {
			Terminator();
		}
		public void actionPerformed(ActionEvent even) {
			Terminator();
		}
	}

	protected void Terminator() {
	}

	public boolean isClosed() {
		return (!do_bool);
	}

	public boolean isOpened() {
		return (do_bool);
	}

	public void setDTree(DTree arg) {
		tree = arg;
	}

	public void setTable(DTable arg) {
		table = arg;
	}

	public void print(String string) {
		System.out.println(string);
	}

	public void trace(Exception exception) {
		exception.printStackTrace();
	}
	
	public void setLocale(Locale locale) {
		resource = ResourceBundle.getBundle("mail"+sp+"send"+sp+"lib"+sp+"resource", locale);
		super.setLocale(locale);
	}
	
	protected String getString(String key) {
		return (resource.getString(key));
	}
}
