/*
 * @(#)Listeners.java	0.001 1999/12/21
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.mail.send;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import yuzu.util.*;


public class Listeners extends Build {
	public Listeners() {
		stopbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				stateLabel.setText(getString("stateStop"));
				Terminator();
			}
		});
	}

	public void startSend() {
		success_bool = true;
		frame.pack();
		do_bool = true;
		bar.setValue(0);
		showDialog();
		dothread = new Thread(new MailSend());
		dothread.start();
		while (do_bool) {
			try {Thread.sleep(500);} catch(Exception exception) {}
		}
		Terminator();
	}

	public void showDialog() {
		frame.setVisible(true);
	}

	public void hideDialog() {
		frame.setVisible(false);
		if (!success_bool) {
			dialog.showMessageDialog(container, getString("DialogNotedMessage"),
									 getString("DialogNotedTitle"),
									 dialog.WARNING_MESSAGE);
		}
		success_bool = true;
	}

	protected void Terminator() {
		do_bool = false;
		dothread.stop();
		hideDialog();
		bar.setValue(0);
		allmailsStat.setText("");
		sendedmailsStat.setText("");
		mailserberStat.setText("");
		stateLabel.setText("");
		frame.removeNotify();
	}

	private class MailSend implements Runnable {
		MailSend() {}
		
		public void run() {
			Vector SMTPdata = util.getSMTPData();
			int data_num = SMTPdata.size();
			int server_num = 0;
			String smtpserver = ((SMTPObject)(SMTPdata.elementAt(server_num))).getServer();
			stateLabel.setText(getString("stateChechMails"));
			Vector willsendmails = util.getWillSendMails();
			File willsendMail = null;
			int limit = willsendmails.size();
			allmailsStat.setText(Integer.toString(limit));
			stateLabel.setText(getString("stateSending"));
			int sentmailcount = 0;
			boolean send_bool;
			for (int count=0; count<limit; count++) {
				willsendMail = (File)(willsendmails.elementAt(count));
				mailserberStat.setText(smtpserver);
				mail.setSmtp(smtpserver);
				mail.readSendMessage(willsendMail);
				send_bool = mail.sendMessage();
				if (!send_bool) {
					++server_num;
					while (server_num < data_num && !send_bool) {
						smtpserver = ((SMTPObject)(SMTPdata.elementAt(server_num))).getServer();
						mailserberStat.setText(smtpserver);
						mail.setSmtp(smtpserver);
						mail.readSendMessage(willsendMail);
						send_bool = mail.sendMessage();
						++server_num;
					}
					server_num = 0;
					smtpserver = ((SMTPObject)(SMTPdata.elementAt(server_num))).getServer();
					success_bool = false;
				}
				if (send_bool) {
					util.removefromCache(util.getDraftDir(), willsendMail);
					table.removeField(willsendMail);
					willsendMail.delete();
					try {
						if (tree.getCurrentDir().getCanonicalPath().equals(
								util.getDraftDir().getCanonicalPath())) {
							table.addFields(util.getDraftDir());
						}
					} catch (Exception exception) {}
				}
				++sentmailcount;
				sendedmailsStat.setText(Integer.toString(sentmailcount));
				bar.setValue(new Double((double)sentmailcount/limit*100).intValue());
			}
			stateLabel.setText(getString("stateFinish"));
			do_bool = false;
		}
	}
}
