// Yuzu.cpp : AvP[Vp̃Gg |Cg̒`
// Copyright (C) 2000 Masanori OZAWA
// All Rights Reserved.
// Last Modified: 00/03/04 Masanori OZAWA
////

#include "stdafx.h"

#include <stdlib.h>
#include <string.h>
#include <tchar.h>
#include <winreg.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "SearchFile.h"

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
// 샂[h̎w
#define	MODE_NORMAL		0	// W
#define	MODE_LOG		1	// Oo

#define	RUN_MODE		MODE_LOG

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
// 擾惌WXgpX
#define	REG_ROOT	HKEY_LOCAL_MACHINE
#define	REG_POS		_T("Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\java.exe")
#define	REG_KEY		_T("Path")

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
// G[bZ[W
#define	ERR_MSG1		_T("Can't get \"app path\" for \"java\".\nSo, can't create process for \"yuzu\".\nbye.")
#define	ERR_MSG2		_T("Can't create new process!")
#define	ERR_CAPTION		_T("Yuzu run error")

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
//ftHgR}hC
#define	DEF_CMDLINE		_T("-classpath \"%s\";\"%s\";\"%s\\activation.jar\";\"%s\\mail.jar\";\"%s\\pop3.jar\" yuzu.Yuzu")

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
// ̑`
#if	(RUN_MODE == MODE_LOG)
	#define	TARGET_COMMAND	_T("java.exe")		// sR}h(JVM)
#else
	#define	TARGET_COMMAND	_T("javaw.exe")		// sR}h(JVM)
#endif

#define	LOG_FILE_NAME	_T("yuzu_log.txt")	// Oo̓t@C

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
// 
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	HKEY	hKey;
	DWORD	nType = 0;
	DWORD	nSize = MAX_PATH;
	TCHAR	szTargetDir[MAX_PATH];	// jdk̃CXg[
	TCHAR	szTargetPath[MAX_PATH];	// java.exeւ̃tpX
	CString	cmdLine;				// yuzuspR}hC

	TCHAR	szOwnName[MAX_PATH];
	TCHAR	szDrive[MAX_PATH];
	TCHAR	szDir[MAX_PATH];
	CString	szCurDir;
	CString szParentDir;

	STARTUPINFO	srtInfo;
	PROCESS_INFORMATION	prcInfo;

	memset(szTargetDir, '\0', MAX_PATH);
	memset(szTargetPath, '\0', MAX_PATH);
	memset(szOwnName, '\0', MAX_PATH);
	memset(szDrive, '\0', MAX_PATH);
	memset(szDir, '\0', MAX_PATH);
	memset(&srtInfo, 0, sizeof(srtInfo));
	memset(&prcInfo, 0, sizeof(prcInfo));

	GetModuleFileName(NULL, szOwnName, MAX_PATH);
	_splitpath(szOwnName, szDrive, szDir, NULL, NULL);
	szCurDir = szDrive;
	szCurDir += szDir;
	if (szCurDir.Right(1) == '\\')
		szCurDir = szCurDir.Left(szCurDir.GetLength() -1);
	szParentDir = szCurDir.Left(szCurDir.ReverseFind('\\'));

	if (
		// WXgANZXJn
		RegOpenKeyEx(REG_ROOT, REG_POS, 0, KEY_READ, &hKey) == ERROR_SUCCESS &&
		// jdkCXg[tH_̎擾
		RegQueryValueEx(hKey, REG_KEY, 0, &nType, (unsigned char *)szTargetDir, &nSize) == ERROR_SUCCESS &&
		// java.exe ̌
		SearchFile(szTargetDir, TARGET_COMMAND, szTargetPath)
		)
	{
		// R}hC̍쐬
		if (_tcslen(lpCmdLine) <= 0) {
			cmdLine.Format(DEF_CMDLINE, szCurDir, szParentDir, szCurDir, szCurDir, szCurDir);
		}
		else cmdLine = lpCmdLine;
		cmdLine = CString(_T("\"")) + szTargetPath + _T("\" ") + cmdLine;

#if	(RUN_MODE == MODE_LOG)
		// java log o͐t@C̍쐬
		CString logFile;
		GetTempPath(MAX_PATH, logFile.GetBuffer(MAX_PATH));
		logFile.ReleaseBuffer();

		if (logFile.Right(1) != _T("\\"))
			logFile += _T("\\");
		logFile += LOG_FILE_NAME;

		// o͐t@C̍쐬
		HANDLE hOutFile = CreateFile(logFile, GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS,
			FILE_ATTRIBUTE_ARCHIVE | FILE_FLAG_SEQUENTIAL_SCAN, NULL);

		// javȁo͐nh̐ݒ
		srtInfo.dwFlags = STARTF_USESTDHANDLES;
		srtInfo.hStdInput = INVALID_HANDLE_VALUE;
		srtInfo.hStdError = hOutFile;
		srtInfo.hStdOutput = hOutFile;
#endif

		// yuzu(java) ̋N
		srtInfo.cb = sizeof(srtInfo);
		if (CreateProcess(NULL, (LPSTR)(LPCSTR)cmdLine, NULL, NULL, FALSE,
			NORMAL_PRIORITY_CLASS, NULL, szCurDir, &srtInfo, &prcInfo))
		{
#if	(RUN_MODE == MODE_LOG)
			// ҂
			WaitForSingleObject(prcInfo.hProcess, INFINITE);

			// IɃvZX(java͈xNƕȂ)
			HANDLE hProc = OpenProcess(PROCESS_TERMINATE, FALSE, prcInfo.dwProcessId);
			TerminateProcess(hProc, 0);
			CloseHandle(hProc);
			CloseHandle(prcInfo.hProcess);

			// Ot@C
			CloseHandle(hOutFile);

			// Ot@CɓeȂ烁J
			struct _stati64 stat;
			memset(&stat, 0, sizeof(stat));
			_stati64(logFile, &stat);
			if (stat.st_size > 0) {
				memset(&srtInfo, 0, sizeof(srtInfo));
				memset(&prcInfo, 0, sizeof(prcInfo));
				cmdLine.Format(_T("notepad.exe %s"), logFile);
				srtInfo.cb = sizeof(srtInfo);
				CreateProcess(NULL, (LPSTR)(LPCSTR)cmdLine, NULL, NULL, FALSE,
					NORMAL_PRIORITY_CLASS, NULL, szCurDir, &srtInfo, &prcInfo);

				WaitForSingleObject(prcInfo.hProcess, INFINITE);
			}
#endif
		}
		else {
#if	(RUN_MODE == MODE_LOG)
			// Ot@C
			CloseHandle(hOutFile);
#endif
			// Ns
			MessageBox(NULL, ERR_MSG2, ERR_CAPTION, MB_OK | MB_ICONSTOP);
		}
#if	(RUN_MODE == MODE_LOG)
		// Ot@C폜
		DeleteFile(logFile);
#endif
	}
	else {
		// G[
		MessageBox(NULL, ERR_MSG1, ERR_CAPTION, MB_OK | MB_ICONSTOP);
	}

	return 0;
}

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
