/*
 * @(#)Build.java	0.001 1999/11/17
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.table;

import java.awt.*;
import java.util.*;
import java.text.*;
import javax.swing.table.*;


public class Build extends Components {
    Build() {
		infoPane.setResource(resource);
		infoPane.setMail(mail);

		table.setColumnModel(columnmodel);
		table.setModel(model);

		setTableIndexFalses();
		setBoolImage(true);
		setBoolSubject(true);
		setBoolTo(true);
		setBoolFrom(true);
		setBoolDate(true);

		buildTable();
		setLabels();
		
		menu_set_tableindex.setIcon(headersIcon);
		menu_set_datestyle.setIcon(datesIcon);
		menu_set_tableline.setIcon(linesIcon);

		if (getBoolImage()) menu_set_tableindex_image.setSelected(true);
		if (getBoolSubject()) menu_set_tableindex_subject.setSelected(true);
		if (getBoolTo()) menu_set_tableindex_to.setSelected(true);
		if (getBoolFrom()) menu_set_tableindex_from.setSelected(true);
		if (getBoolDate()) menu_set_tableindex_date.setSelected(true);
		if (getBoolCc()) menu_set_tableindex_cc.setSelected(true);
		if (getBoolReplyto()) menu_set_tableindex_replyto.setSelected(true);
		if (getBoolOrganization()) menu_set_tableindex_organization.setSelected(true);
		if (getBoolMessageid()) menu_set_tableindex_messageid.setSelected(true);
		if (getBoolContenttype()) menu_set_tableindex_contenttype.setSelected(true);
		if (getBoolMailer()) menu_set_tableindex_mailer.setSelected(true);

		menu_ctr_return.setIcon(returnIcon);
		menu_ctr_save.setIcon(saveIcon);
		menu_ctr_move.setIcon(moveIcon);
		menu_ctr_info.setIcon(infoIcon);
		menu_ctr_del.setIcon(delIcon);
		
		menu_ctr.add(menu_ctr_return);
		menu_ctr.addSeparator();
		menu_ctr.add(menu_ctr_save);
		menu_ctr.add(menu_ctr_move);
		menu_ctr.addSeparator();
		menu_ctr.add(menu_ctr_info);
		menu_ctr.addSeparator();
		menu_ctr.add(menu_ctr_del);
		menubar.add(menu_ctr);

		menu_set_tableindex.add(menu_set_tableindex_image);
		menu_set_tableindex.add(menu_set_tableindex_subject);
		menu_set_tableindex.add(menu_set_tableindex_to);
		menu_set_tableindex.add(menu_set_tableindex_from);
		menu_set_tableindex.add(menu_set_tableindex_date);
		menu_set_tableindex.add(menu_set_tableindex_cc);
		menu_set_tableindex.add(menu_set_tableindex_replyto);
		menu_set_tableindex.add(menu_set_tableindex_organization);
		menu_set_tableindex.add(menu_set_tableindex_messageid);
		menu_set_tableindex.add(menu_set_tableindex_contenttype);
		menu_set_tableindex.add(menu_set_tableindex_mailer);
		menu_set.add(menu_set_tableindex);

		groupe_datestyle.add(menu_set_datestyle_full);
		groupe_datestyle.add(menu_set_datestyle_long);
		groupe_datestyle.add(menu_set_datestyle_medium);
		groupe_datestyle.add(menu_set_datestyle_short);
		menu_set_datestyle_short.setSelected(true);
		menu_set_datestyle.add(menu_set_datestyle_full);
		menu_set_datestyle.add(menu_set_datestyle_long);
		menu_set_datestyle.add(menu_set_datestyle_medium);
		menu_set_datestyle.add(menu_set_datestyle_short);
		menu_set.add(menu_set_datestyle);

		groupe_tableline.add(menu_set_tableline_both);
		groupe_tableline.add(menu_set_tableline_ver);
		groupe_tableline.add(menu_set_tableline_hol);
		groupe_tableline.add(menu_set_tableline_none);
		table.setShowVerticalLines(false);
		table.setShowHorizontalLines(true);
		menu_set_tableline_hol.setSelected(true);
		menu_set_tableline.add(menu_set_tableline_both);
		menu_set_tableline.add(menu_set_tableline_ver);
		menu_set_tableline.add(menu_set_tableline_hol);
		menu_set_tableline.add(menu_set_tableline_none);
		menu_set.add(menu_set_tableline);

		menubar.add(menu_set);
		pane.add(menubar, BorderLayout.NORTH);

		scroll.setViewportView(table);
		pane.add(scroll, BorderLayout.CENTER);
		pane.setBackground(Color.white);

		tableInitial();
	}

	public void buildTable() {
		int columnlimit = model.getColumnCount();
		for (int count=0; count<columnlimit; count++) {
			columnmodel.removeColumn(columnmodel.getColumn(0));
		}
		
		columnlimit = getTableIndexes();

		model = null;
		model = new CustomTableModel();
		table.setModel(model);

		for (int count=0; count<columnlimit; count++) {
			model.addColumn(getTableIndex(count));
		}
		
		for (int count=0; count<columnlimit; count++) {
			(columnmodel.getColumn(count)).setIdentifier(getTableIndex(count));
		}
	}

	private void tableInitial() {
		String ID = null;
		TableColumn column = null;
		
		int limit = model.getColumnCount();
		for (int count=0; count<limit; count++) {
			columnmodel = (DefaultTableColumnModel)(table.getColumnModel());
			column = columnmodel.getColumn(count);
			ID = (String)(column.getIdentifier());
			ID = getTableIndex(getCurrentNumberofIndex(getTableIndex(getNumberofIndex(ID))));
			if (ID.equals("image")) {
				column.setMaxWidth(50);
				column.setMinWidth(50);
				column.setPreferredWidth(50);
			} else if (ID.equals("subject")) {
			} else if (ID.equals("to")) {
			} else if (ID.equals("from")) {
			} else if (ID.equals("date")) { 
				if (getDateStyle() == DateFormat.SHORT) {
					column.setMaxWidth(70);
					column.setMinWidth(70);
					column.setPreferredWidth(70);
				} else if (getDateStyle() == DateFormat.MEDIUM) {
					column.setMaxWidth(90);
					column.setMinWidth(90);
					column.setPreferredWidth(90);
				} else if (getDateStyle() == DateFormat.LONG) {
					column.setMaxWidth(90);
					column.setMinWidth(90);
					column.setPreferredWidth(90);
				} else if (getDateStyle() == DateFormat.FULL) {
					column.setMaxWidth(110);
					column.setMinWidth(110);
					column.setPreferredWidth(110);
				}
			} else if (ID.equals("cc")) { 
			} else if (ID.equals("replyto")) { 
			} else if (ID.equals("organization")) { 
			} else if (ID.equals("messageid")) { 
			} else if (ID.equals("contenttype")) { 
			} else if (ID.equals("mailer")) { 
			} 
		}
	}

	public void setLabels() {
		menu_ctr.setLabel(getString("menu_ctr"));
		menu_ctr_return.setLabel(getString("menu_ctr_return"));
		menu_ctr_save.setLabel(getString("menu_ctr_save"));
		menu_ctr_move.setLabel(getString("menu_ctr_move"));
		menu_ctr_info.setLabel(getString("menu_ctr_info"));
		menu_ctr_del.setLabel(getString("menu_ctr_del"));

		menu_set_datestyle.setLabel(getString("menu_set_datestyle"));
		menu_set_datestyle_full.setLabel(getString("menu_set_datestyle_full"));
		menu_set_datestyle_long.setLabel(getString("menu_set_datestyle_long"));
		menu_set_datestyle_medium.setLabel(getString("menu_set_datestyle_medium"));
		menu_set_datestyle_short.setLabel(getString("menu_set_datestyle_short"));
		menu_set.setLabel(getString("menu_set"));
		menu_set_tableindex.setLabel(getString("menu_set_tableindex"));
		menu_set_tableindex_image.setLabel(getString("menu_set_tableindex_image"));
		menu_set_tableindex_subject.setLabel(getString("menu_set_tableindex_subject"));
		menu_set_tableindex_to.setLabel(getString("menu_set_tableindex_to"));
		menu_set_tableindex_from.setLabel(getString("menu_set_tableindex_from"));
		menu_set_tableindex_date.setLabel(getString("menu_set_tableindex_date"));
		menu_set_tableindex_cc.setLabel(getString("menu_set_tableindex_cc"));
		menu_set_tableindex_replyto.setLabel(getString("menu_set_tableindex_replyto"));
		menu_set_tableindex_organization.setLabel(getString("menu_set_tableindex_organization"));
		menu_set_tableindex_messageid.setLabel(getString("menu_set_tableindex_messageid"));
		menu_set_tableindex_contenttype.setLabel(getString("menu_set_tableindex_contenttype"));
		menu_set_tableindex_mailer.setLabel(getString("menu_set_tableindex_mailer"));

		menu_set_tableline.setLabel(getString("menu_set_tableline"));
		menu_set_tableline_both.setLabel(getString("menu_set_tableline_both"));
		menu_set_tableline_ver.setLabel(getString("menu_set_tableline_ver"));
		menu_set_tableline_hol.setLabel(getString("menu_set_tableline_hol"));
		menu_set_tableline_none.setLabel(getString("menu_set_tableline_none"));

		try {
			model = (CustomTableModel)(table.getModel());
			int limit = model.getColumnCount();
			String ID = null;
			TableColumn column = null;
			for (int count=0; count<limit; count++) {
				columnmodel = (DefaultTableColumnModel)(table.getColumnModel());
				column = columnmodel.getColumn(count);
				ID = (String)(column.getIdentifier());
				if (ID.equals("image")) {
					column.setHeaderValue("");
				} else if (ID.equals("subject")) {
					column.setHeaderValue(getString("Subject"));
				} else if (ID.equals("to")) {
					column.setHeaderValue(getString("To"));
				} else if (ID.equals("from")) {
					column.setHeaderValue(getString("From"));
				} else if (ID.equals("date")) { 
					column.setHeaderValue(getString("Date"));
				} else if (ID.equals("cc")) { 
					column.setHeaderValue(getString("Cc"));
				} else if (ID.equals("replyto")) { 
					column.setHeaderValue(getString("Replyto"));
				} else if (ID.equals("organization")) { 
					column.setHeaderValue(getString("Organization"));
				} else if (ID.equals("messageid")) { 
					column.setHeaderValue(getString("Messageid"));
				} else if (ID.equals("contenttype")) { 
					column.setHeaderValue(getString("Contenttype"));
				} else if (ID.equals("mailer")) { 
					column.setHeaderValue(getString("Mailer"));
				} 
			}
		} catch(Exception exception) {
			trace(exception);
		}
	}
}
