/*
 * @(#)Components.java	0.001 1999/11/17
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.table;

import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

import yuzu.util.*;
import yuzu.tree.*;
import yuzu.mail.*;
import yuzu.disp.*;


public class Components extends JPanel {

	protected static JPanel pane = null;
	protected static Container container = null;
	protected static Utilities util = new Utilities();

	protected static final String sp = System.getProperty("file.separator");
	protected static ResourceBundle resource = 
		ResourceBundle.getBundle("table"+sp+"lib"+sp+"resource", Locale.getDefault());
	private static Locale currentLocale = null;
	
	protected static CustomTable table = new CustomTable();
	protected static JScrollPane scroll = new JScrollPane();
	protected static JScrollBar scrollbar = null;

	protected CustomTableModel model = new CustomTableModel();
	protected DefaultTableColumnModel columnmodel 
		= new DefaultTableColumnModel();

	private static boolean bool_image = false;
	private static boolean bool_subject = false;
	private static boolean bool_to = false;
	private static boolean bool_from = false;
	private static boolean bool_date = false;
	private static boolean bool_cc = false;
	private static boolean bool_replyto = false;
	private static boolean bool_organization = false;
	private static boolean bool_messageid = false;
	private static boolean bool_contenttype = false;
	private static boolean bool_mailer = false;

	protected static JMenuBar menubar = new JMenuBar();
	protected static JMenu menu_ctr  = new JMenu();
	protected static JMenu menu_set  = new JMenu();

	protected static JMenuItem menu_ctr_return = new JMenuItem();
	protected static JMenuItem menu_ctr_save = new JMenuItem();
	protected static JMenuItem menu_ctr_move = new JMenuItem();
	protected static JMenuItem menu_ctr_info = new JMenuItem();
	protected static JMenuItem menu_ctr_del  = new JMenuItem();

	protected static JMenu menu_set_tableindex  = new JMenu();
	protected static JMenu menu_set_datestyle   = new JMenu();
	protected static JMenu menu_set_tableline   = new JMenu();

	protected static JCheckBoxMenuItem menu_set_tableindex_image
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_subject 
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_to
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_from
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_date
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_cc
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_replyto
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_organization
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_messageid
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_contenttype
		= new JCheckBoxMenuItem();
	protected static JCheckBoxMenuItem menu_set_tableindex_mailer
		= new JCheckBoxMenuItem();

	protected static JRadioButtonMenuItem menu_set_datestyle_full
		= new JRadioButtonMenuItem();
	protected static JRadioButtonMenuItem menu_set_datestyle_long
		= new JRadioButtonMenuItem();
	protected static JRadioButtonMenuItem menu_set_datestyle_medium
		= new JRadioButtonMenuItem();
	protected static JRadioButtonMenuItem menu_set_datestyle_short
		= new JRadioButtonMenuItem();
	protected static ButtonGroup groupe_datestyle = new ButtonGroup();

	protected static JRadioButtonMenuItem menu_set_tableline_both
		= new JRadioButtonMenuItem();
	protected static JRadioButtonMenuItem menu_set_tableline_ver
		= new JRadioButtonMenuItem();
	protected static JRadioButtonMenuItem menu_set_tableline_hol
		= new JRadioButtonMenuItem();
	protected static JRadioButtonMenuItem menu_set_tableline_none
		= new JRadioButtonMenuItem();
	protected static ButtonGroup groupe_tableline = new ButtonGroup();

	private static int DateStyle = DateFormat.SHORT;

	protected static JFrame frame = null;
	protected static DTree tree = null;

	protected static JOptionPane dialog = new JOptionPane();
	protected static DMail mail = new DMail();

	protected static ImageIcon returnIcon = new ImageIcon("table"+sp+"images"+sp+"returnmail.gif");
	protected static ImageIcon saveIcon = new ImageIcon("table"+sp+"images"+sp+"save.gif");
	protected static ImageIcon moveIcon = new ImageIcon("table"+sp+"images"+sp+"move.gif");
	protected static ImageIcon infoIcon = new ImageIcon("table"+sp+"images"+sp+"info.gif");
	protected static ImageIcon delIcon = new ImageIcon("table"+sp+"images"+sp+"delete.gif");

	protected static InfoPane infoPane = new InfoPane();

	protected static ImageIcon mailIcon = new ImageIcon("table"+sp+"images"+sp+"mail.gif");
	protected static ImageIcon mailsIcon = new ImageIcon("table"+sp+"images"+sp+"mails.gif");
	protected static ImageIcon attachIcon = new ImageIcon("table"+sp+"images"+sp+"attach.gif");

	protected static ImageIcon headersIcon = new ImageIcon("table"+sp+"images"+sp+"headers.gif");
	protected static ImageIcon datesIcon   = new ImageIcon("table"+sp+"images"+sp+"dates.gif");
	protected static ImageIcon linesIcon   = new ImageIcon("table"+sp+"images"+sp+"lines.gif");

	protected static Disp disp = null;


	Components() {
		pane = this;
		pane.setLayout(new BorderLayout());
	}
	
	public void setContainer(Container cnt) {
		container = cnt;
	}

	public void setJFrame(JFrame frm) {
		frame = frm;
	}
	
	public void setDTree(DTree tre) {
		tree = tre;
	}
	
	public void setDisp(Disp dsp) {
		disp = dsp;
		table.setDisp(disp);
	}

	public void setDateStyle(int sty) {
		DateStyle = sty;
		table.setDateStyle(sty);
	}
	
	public int getDateStyle() {
		return (DateStyle);
	}
	
	public void setBoolImage (boolean bool) {bool_image = bool;}
	public void setBoolSubject (boolean bool) {bool_subject = bool;}
	public void setBoolTo (boolean bool) {bool_to = bool;}
	public void setBoolFrom (boolean bool) {bool_from = bool;}
	public void setBoolDate (boolean bool) {bool_date = bool;}
	public void setBoolCc (boolean bool) {bool_cc = bool;}
	public void setBoolReplyto (boolean bool) {bool_replyto = bool;}
	public void setBoolOrganization (boolean bool) {bool_organization = bool;}
	public void setBoolMessageid (boolean bool) {bool_messageid = bool;}
	public void setBoolContenttype (boolean bool) {bool_contenttype = bool;}
	public void setBoolMailer (boolean bool) {bool_mailer = bool;}

	public boolean getBoolImage () {return(bool_image);}
	public boolean getBoolSubject () {return(bool_subject);}
	public boolean getBoolTo () {return(bool_to);}
	public boolean getBoolFrom () {return(bool_from);}
	public boolean getBoolDate () {return(bool_date);}
	public boolean getBoolCc () {return(bool_cc);}
	public boolean getBoolReplyto () {return(bool_replyto);}
	public boolean getBoolOrganization () {return(bool_organization);}
	public boolean getBoolMessageid () {return(bool_messageid);}
	public boolean getBoolContenttype () {return(bool_contenttype);}
	public boolean getBoolMailer () {return(bool_mailer);}

	public void setTableIndexFalses() {
		bool_image        = false;
		bool_subject      = false;
		bool_to           = false;
		bool_from         = false;
		bool_date         = false;
		bool_cc           = false;
		bool_replyto      = false;
		bool_organization = false;
		bool_messageid    = false;
		bool_contenttype  = false;
		bool_mailer       = false;
	}

	public int getTableIndexes() {
		int count=0;
		if (bool_image)        ++count;
		if (bool_subject)      ++count;
		if (bool_to)           ++count;
		if (bool_from)         ++count;
		if (bool_date)         ++count;
		if (bool_cc)           ++count;
		if (bool_replyto)      ++count;
		if (bool_organization) ++count;
		if (bool_messageid)    ++count;
		if (bool_contenttype)  ++count;
		if (bool_mailer)       ++count;
		return (count);
	}

	public String getTableIndex(int index) {
		int count=-1;
		if (bool_image)        ++count;
		if (count == index) return "image";
		if (bool_subject)      ++count;
		if (count == index) return "subject";
		if (bool_to)           ++count;
		if (count == index) return "to";
		if (bool_from)         ++count;
		if (count == index) return "from";
		if (bool_date)         ++count;
		if (count == index) return "date";
		if (bool_cc)           ++count;
		if (count == index) return "cc";
		if (bool_replyto)      ++count;
		if (count == index) return "replyto";
		if (bool_organization) ++count;
		if (count == index) return "organization";
		if (bool_messageid)    ++count;
		if (count == index) return "messageid";
		if (bool_contenttype)  ++count;
		if (count == index) return "contenttype";
		if (bool_mailer)       ++count;
		if (count == index) return "mailer";
		return ("none");
	}

	public int getNumberofIndex(String index) {
		int count=-1;
		if (bool_image)                   ++count;
		if (index.equals("image"))        return (count);
		if (bool_subject)                 ++count;
		if (index.equals("subject"))      return (count);
		if (bool_to)                      ++count;
		if (index.equals("to"))           return (count);
		if (bool_from)                    ++count;
		if (index.equals("from"))         return (count);
		if (bool_date)                    ++count;
		if (index.equals("date"))         return (count);
		if (bool_cc)                      ++count;
		if (index.equals("cc"))           return (count);
		if (bool_replyto)                 ++count;
		if (index.equals("replyto"))      return (count);
		if (bool_organization)            ++count;
		if (index.equals("organization")) return (count);
		if (bool_messageid)               ++count;
		if (index.equals("messageid"))    return (count);
		if (bool_contenttype)             ++count;
		if (index.equals("contenttype"))  return (count);
		if (bool_mailer)                  ++count;
		if (index.equals("mailer"))       return (count);
		return -1;
	}

	public int getCurrentNumberofIndex(String index) {
		int count = -1;
		int limit = getTableIndexes()-1;
		String key = null;
		while (count < limit) {
			key = (String)(((TableColumn)(columnmodel.getColumn(count+1))).getIdentifier());
			if (key.equals("image")) {
				if (bool_image) ++count;
			} else if (key.equals("subject")) {
				if (bool_subject) ++count;
			} else if (key.equals("to")) {
				if (bool_to) ++count;
			} else if (key.equals("from")) {
				if (bool_from) ++count;
			} else if (key.equals("date")) {
				if (bool_date) ++count;
			} else if (key.equals("cc")) {
				if (bool_cc) ++count;
			} else if (key.equals("replyto")) {
				if (bool_replyto) ++count;
			} else if (key.equals("organization")) {
				if (bool_organization) ++count;
			} else if (key.equals("messageid")) {
				if (bool_messageid) ++count;
			} else if (key.equals("contenttype")) {
				if (bool_contenttype) ++count;
			} else if (key.equals("mailer")) {
				if (bool_mailer) ++count;
			}
			if (index.equals(key)) {
				break;
			}
		}
		return (count);
    }

	protected void refresh() {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				table.setVisible(false);
				table.setSize(new Dimension(table.getWidth()+1, table.getHeight()+1));
				table.setSize(new Dimension(table.getWidth()-1, table.getHeight()-1));
				table.setVisible(true);
				pane.setVisible(false);
				pane.setVisible(true);
		  }
		});
	}

	public void print(String string) {
		System.out.println(string);
	}

	public void trace(Exception exception) {
		exception.printStackTrace();
	}
	
	public void setLocale(Locale locale) {
		currentLocale = locale;
		resource = ResourceBundle.getBundle("table"+sp+"lib"+sp+"resource", locale);
		infoPane.setResource(resource);
		util.setLocale(locale);
		table.setLocale(locale);
		super.setLocale(locale);
	}

	public static Locale getCurrentLocale() {
		return (currentLocale);
	}
	
	protected String getString(String key) {
		return (resource.getString(key));
	}
}
