/*
 * @(#)CustomTable.java	0.001 1999/11/24
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.table;

import java.io.*;
import java.util.*;
import java.text.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

import yuzu.mail.*;
import yuzu.disp.*;


class CustomTable extends JTable {
	private static CustomTableModel model = null;
	private static DefaultTableColumnModel columnmodel = null;

	private static int DateStyle = DateFormat.SHORT;
	private static Locale currentLocale = null;
	protected static final String sp = System.getProperty("file.separator");
	private static ResourceBundle resource = 
		ResourceBundle.getBundle("table"+sp+"lib"+sp+"resource", Locale.getDefault());
	
	private static DMail mail  = new DMail();
	private static DMail analy = new DMail();

	private static int selectedRow = 0;

	protected static ImageIcon attachIcon = new ImageIcon("table"+sp+"images"+sp+"attach.gif");

	private static String subject      = null;
	private static String from         = null;
	private static String to           = null;
	private static String cc           = null;
	private static Date   date         = null;
	private static String sdate        = null;
	private static String replyto      = null;
	private static String organization = null;
	private static String messageid    = null;
	private static String contenttype  = null;
	private static String mailer       = null;
	
	private static CellObject Osubject      = null;
	private static CellObject Ofrom         = null;
	private static CellObject Oto           = null;
	private static CellObject Occ           = null;
	private static CellObject Odate         = null;
	private static CellObject Oreplyto      = null;
	private static CellObject Oorganization = null;
	private static CellObject Omessageid    = null;
	private static CellObject Ocontenttype  = null;
	private static CellObject Omailer       = null;
	
	private static File targetMail = null;
	private static int[] AID = null;
	private static int[] ids = null;

	protected static Disp disp = null;


	CustomTable() {
		super();
	}

	public void valueChanged(ListSelectionEvent event) {
		super.valueChanged(event);
		if (getSelectedRow() == -1) return;

		selectedRow = getSelectedRow();
		if (event.getValueIsAdjusting()) {
		} else {
			if (((int [])(getSelectedRows())).length == 1) {
				model = (CustomTableModel)getModel();
				columnmodel = (DefaultTableColumnModel)getColumnModel();
				int optColumn = model.getColumnCount() - 1;
				
				boolean mime = ((CellObject)(getValueAt(selectedRow, optColumn))).isMIME();
				boolean attach = ((CellObject)(getValueAt(selectedRow, optColumn))).isAttachments();
				
				targetMail = ((CellObject)(getValueAt(selectedRow, optColumn))).getID();
				mail.readMessage(targetMail);
				closeAttach(((CellObject)(getValueAt(selectedRow, optColumn))).getAttachID());
				AID = ((CellObject)(getValueAt(selectedRow, optColumn))).getAttachID();
				mail.movetoAttach(AID);
				disp.setMail(mail);
				disp.setOptPanel();
				disp.setreadOptObject();
				if (mime) {
					int limit = mail.getMIMECount();
					int start = 0;
					if (mail.isString(0)) start = 1;
					int insertRow = selectedRow + 1;
					boolean insertbool;
					for (int count=start; count<limit; count++) {
						insertbool = true;
						if (mail.isInputStream(count))    {setInputStreamMIME(count);}
						else if (mail.isString(count))    {setStringMIME(count);}
						else if (mail.isMessage(count))   {setMessageMIME(count);}
						else if (mail.isMultipart(count)) {setMultipartMIME(count);}
						else {insertbool = false;}
						if (insertbool) model.insertRow(insertRow, getRowData());
						++insertRow;
					}
				}
			} else {
				disp.setNone();
			}
		}
	}
	
	private void closeAttach(int[] IDs) {
		int optColumn = getOptColumn();
		try {
			int limit = model.getRowCount();
			if (IDs == null) {
				for (int count=0; count<limit; count++) {
					if (((CellObject)(getValueAt(count, optColumn))).isAttachments()) {
						model.removeRow(count);
						--limit;
						--count;
					}
				}
			} else {
				int depth = IDs.length;
				int[] check = null;
				for (int count=0; count<limit; count++) {
					if (((CellObject)(getValueAt(count, optColumn))).isAttachments()) {
						check = ((CellObject)(getValueAt(count, optColumn))).getAttachID();
						if (check.length > depth) {
							model.removeRow(count);
							--limit;
							--count;
						}
					}
				}
			}
		} catch (Exception exception) {
			exception.printStackTrace();			
		}
		selectedRow = getSelectedRow();
	}
	
    public void setDateStyle(int sty) {
		DateStyle = sty;
		disp.setDateStyle(sty);
	}

    private int getDateStyle() {
		return (DateStyle);
	}

    public void setLocale(Locale locale) {
		mail.setLocale(locale);
		analy.setLocale(locale);
		currentLocale = locale;
		resource = ResourceBundle.getBundle("table"+sp+"lib"+sp+"resource", locale);
	}
	
    private static Locale getCurrentLocale() {
		return (currentLocale);
	}
	
    private String getString(String key) {
		return (resource.getString(key));
	}

	private void setInputStreamMIME(int count) {
		analy.setBodyPart(mail.getBodyPart(count));
		subject = analy.getBodyFileName();
		from = "";
		to = "";
		cc = "";
		sdate = "";
		replyto = "";
		organization = "";
		messageid = "";
		contenttype = analy.getBodyContentType();
		mailer = "";
		sdate = "";
		try {
			if (contenttype.trim().substring(0,9).equalsIgnoreCase("text/html")) {
				subject = getString("HTMLMail");
			}
		} catch (Exception exception) {}
		
		ids = buildIDs(count);
		Osubject      = new CellObject(subject,      targetMail, false, true, ids, false); 
		Oto           = new CellObject(to,           targetMail, false, true, ids, false);
		Ofrom         = new CellObject(from,         targetMail, false, true, ids, false);
		Odate         = new CellObject(sdate,        targetMail, false, true, ids, false);
		Occ           = new CellObject(cc,           targetMail, false, true, ids, false);
		Oreplyto      = new CellObject(replyto,      targetMail, false, true, ids, false);
		Oorganization = new CellObject(organization, targetMail, false, true, ids, false);
		Omessageid    = new CellObject(messageid,    targetMail, false, true, ids, false);
		Ocontenttype  = new CellObject(contenttype,  targetMail, false, true, ids, false);
		Omailer       = new CellObject(mailer,       targetMail, false, true, ids, false);
	}

	private void setStringMIME(int count) {
		subject = analy.getMailBodypartFileName();
		from = "";
		to = "";
		cc = "";
		sdate = "";
		replyto = "";
		organization = "";
		messageid = "";
		contenttype = analy.getMailBodypartContentType();
		mailer = "";
		try {
			if (contenttype.trim().substring(0,9).equalsIgnoreCase("text/html")) {
				subject = getString("HTMLMail");
			}
		} catch (Exception exception) {}
		ids = buildIDs(count);
		Osubject      = new CellObject(subject,      targetMail, false, true, ids, false);
		Oto           = new CellObject(to,           targetMail, false, true, ids, false);
		Ofrom         = new CellObject(from,         targetMail, false, true, ids, false);
		Odate         = new CellObject(sdate,        targetMail, false, true, ids, false);
		Occ           = new CellObject(cc,           targetMail, false, true, ids, false);
		Oreplyto      = new CellObject(replyto,      targetMail, false, true, ids, false);
		Oorganization = new CellObject(organization, targetMail, false, true, ids, false);
		Omessageid    = new CellObject(messageid,    targetMail, false, true, ids, false);
		Ocontenttype  = new CellObject(contenttype,  targetMail, false, true, ids, false);
		Omailer       = new CellObject(mailer,       targetMail, false, true, ids, false);
	}

	private void setMessageMIME(int count) {
		analy.setMessage(mail.getMessage(count));
		subject = analy.getMessageSubject();
		from = analy.getMessageFrom();
		to = analy.getMessageTo();
		cc = analy.getMessageCc();
		date = analy.getMessageDateObject();
		replyto = analy.getMessageReplyTo();
		organization = analy.getMessageOrganization();
		messageid = analy.getMessageMessageID();
		contenttype = analy.getMessageContentType();
		mailer = analy.getMessageXMailer();
		sdate = DateFormat.getDateInstance(getDateStyle(), 
										   getCurrentLocale() ).format(date);
		ids = buildIDs(count);
		try {
			if ((contenttype.substring(0, 9)).equalsIgnoreCase("Multipart")) {
				Osubject      = new CellObject(subject,      targetMail, true, true, ids);
				Oto           = new CellObject(to,           targetMail, true, true, ids);
				Ofrom         = new CellObject(from,         targetMail, true, true, ids);
				Odate         = new CellObject(sdate,        targetMail, true, true, ids);
				Occ           = new CellObject(cc,           targetMail, true, true, ids);
				Oreplyto      = new CellObject(replyto,      targetMail, true, true, ids);
				Oorganization = new CellObject(organization, targetMail, true, true, ids);
				Omessageid    = new CellObject(messageid,    targetMail, true, true, ids);
				Ocontenttype  = new CellObject(contenttype,  targetMail, true, true, ids);
				Omailer       = new CellObject(mailer,       targetMail, true, true, ids);
			} else {
				Osubject      = new CellObject(subject,      targetMail, false, true, ids);
				Oto           = new CellObject(to,           targetMail, false, true, ids);
				Ofrom         = new CellObject(from,         targetMail, false, true, ids);
				Odate         = new CellObject(sdate,        targetMail, false, true, ids);
				Occ           = new CellObject(cc,           targetMail, false, true, ids);
				Oreplyto      = new CellObject(replyto,      targetMail, false, true, ids);
				Oorganization = new CellObject(organization, targetMail, false, true, ids);
				Omessageid    = new CellObject(messageid,    targetMail, false, true, ids);
				Ocontenttype  = new CellObject(contenttype,  targetMail, false, true, ids);
				Omailer       = new CellObject(mailer,       targetMail, false, true, ids);
			}
		} catch (Exception exception) {
			Osubject      = new CellObject(subject,      targetMail, false, true, ids);
			Oto           = new CellObject(to,           targetMail, false, true, ids);
			Ofrom         = new CellObject(from,         targetMail, false, true, ids);
			Odate         = new CellObject(sdate,        targetMail, false, true, ids);
			Occ           = new CellObject(cc,           targetMail, false, true, ids);
			Oreplyto      = new CellObject(replyto,      targetMail, false, true, ids);
			Oorganization = new CellObject(organization, targetMail, false, true, ids);
			Omessageid    = new CellObject(messageid,    targetMail, false, true, ids);
			Ocontenttype  = new CellObject(contenttype,  targetMail, false, true, ids);
			Omailer       = new CellObject(mailer,       targetMail, false, true, ids);
		}
	}

	private void setMultipartMIME(int count) {
		analy.setBodyPart(mail.getBodyPart(count));
		subject = getString("Multipart");
		from = "";
		to = "";
		cc = "";
		sdate = "";
		replyto = "";
		organization = "";
		messageid = "";
		contenttype = analy.getBodyContentType();
		mailer = "";
		sdate = "";							
		ids = buildIDs(count);
		Osubject      = new CellObject(subject,      targetMail, true, true, ids, false);
		Oto           = new CellObject(to,           targetMail, true, true, ids, false);
		Ofrom         = new CellObject(from,         targetMail, true, true, ids, false);
		Odate         = new CellObject(sdate,        targetMail, true, true, ids, false);
		Occ           = new CellObject(cc,           targetMail, true, true, ids, false);
		Oreplyto      = new CellObject(replyto,      targetMail, true, true, ids, false);
		Oorganization = new CellObject(organization, targetMail, true, true, ids, false);
		Omessageid    = new CellObject(messageid,    targetMail, true, true, ids, false);
		Ocontenttype  = new CellObject(contenttype,  targetMail, true, true, ids, false);
		Omailer       = new CellObject(mailer,       targetMail, true, true, ids, false);
	}

	private Vector getRowData() {
		int limited = model.getColumnCount();
		Vector additiondata = new Vector();
		String ID = null;
		TableColumn column = null;
		for (int count=0; count<limited; count++) {
			column = columnmodel.getColumn(count);
			ID = (String)(column.getIdentifier());
			if (ID.equals("image")) {
				additiondata.addElement(attachIcon);
			} else if (ID.equals("subject")) {
				additiondata.addElement(Osubject);
			} else if (ID.equals("to")) {
				additiondata.addElement(Oto);
			} else if (ID.equals("from")) {
				additiondata.addElement(Ofrom);
			} else if (ID.equals("date")) { 
				additiondata.addElement(Odate);
			} else if (ID.equals("cc")) { 
				additiondata.addElement(Occ);
			} else if (ID.equals("replyto")) { 
				additiondata.addElement(Oreplyto);
			} else if (ID.equals("organization")) { 
				additiondata.addElement(Oorganization);
			} else if (ID.equals("messageid")) { 
				additiondata.addElement(Omessageid);
			} else if (ID.equals("contenttype")) { 
				additiondata.addElement(Ocontenttype);
			} else if (ID.equals("mailer")) { 
				additiondata.addElement(Omailer);
			} 
		}
		return (additiondata);
	}

	private int[] buildIDs(int value) {
		if (AID == null) return (new int[] {value});
		int[] newids = new int[AID.length + 1];
		int limit = AID.length;
		for (int count=0; count<limit; count++) {
			newids[count] = AID[count];
		}
		newids[limit] = value;
		return (newids);
	}

	public void setDisp(Disp dsp) {
		disp = dsp;
	}

	private int getOptColumn() {
		model = (CustomTableModel)getModel();
		int limit = model.getColumnCount();
		int count=0;
		while (count < limit) {
			if (getValueAt(0, count) instanceof CellObject) break;
			++count;
		}
		if (count == limit) {
			return (-1);
		}
		return count;
	}
}
