/*
 * @(#)InfoPane.java	0.001 1999/11/28
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.table;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import javax.swing.border.*;

import yuzu.mail.*;


public class InfoPane extends JPanel {
	private static ResourceBundle resource = null;
	private static DMail mail = null;
	
	private static JPanel pane = null;
	private static JMenuBar menubar = new JMenuBar();
	private static JMenu menu_edit  = new JMenu();
	private static JMenuItem menu_edit_copy = new JMenuItem();

	protected static final String sp = System.getProperty("file.separator");
	protected static ImageIcon copyIcon = new ImageIcon("table"+sp+"images"+sp+"copy.gif");

	protected static JTextArea textarea = new JTextArea(25, 40);
 	protected static JScrollPane scroll = new JScrollPane(textarea);


	public InfoPane() {
		pane = this;
		pane.setLayout(new BorderLayout());

		textarea.setEditable(false);
		menu_edit_copy.setIcon(copyIcon);
		menu_edit.add(menu_edit_copy);
		menubar.add(menu_edit);
		pane.add(menubar, BorderLayout.NORTH);
		pane.add(scroll, BorderLayout.CENTER);

		menu_edit_copy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
				String data = textarea.getSelectedText();
				StringSelection contents = new StringSelection(data);
				clipboard.setContents(contents, null);
			}
		});

		pane.addComponentListener(new ComponentListener() {
			public void componentResized(ComponentEvent event)  {
				JPanel parent = (JPanel)pane.getParent();
				JPanel great  = (JPanel)parent.getParent();
				JPanel org = (JPanel)great.getParent();
				pane.setSize(parent.getWidth(), parent.getHeight());
			}

			public void componentMoved(ComponentEvent event) {}
			public void componentHidden(ComponentEvent event) {}
			public void componentShown(ComponentEvent event) {}
		});
	}

	public void setTarget(File targetFile) {
		menu_edit.setLabel(resource.getString("menu_edit"));
		menu_edit_copy.setLabel(resource.getString("menu_edit_copy"));
		scroll.setBorder(new TitledBorder(resource.getString("HeaderTitle")));
		mail.readMessage(targetFile);
		textarea.setText(mail.getHeaders());
	}

	public void setResource(ResourceBundle rsrc) {
		resource = rsrc;
	}

	public void setMail(DMail dm) {
		mail = dm;
	}
}
