/*
 * @(#)Listeners.java	0.001 1999/11/17
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.table;

import yuzu.util.*;
import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;


public class Listeners extends Build {
	private static String margine = "    ";
	private static Object[] label = null;
	private static boolean preiszero = false;
	private static boolean imageistrue = false;

	private static int[] selectedRowsMemory = null;

	Listeners() {
		menu_set_tableline_both.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				table.setShowVerticalLines(true);
				table.setShowHorizontalLines(true);
			}
		});

		menu_set_tableline_ver.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				table.setShowVerticalLines(true);
				table.setShowHorizontalLines(false);
			}
		});

		menu_set_tableline_hol.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				table.setShowVerticalLines(false);
				table.setShowHorizontalLines(true);
			}
		});

		menu_set_tableline_none.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				table.setShowVerticalLines(false);
				table.setShowHorizontalLines(false);
			}
		});

		menu_ctr_info.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				model = (CustomTableModel)(table.getModel());
				int[] selected = table.getSelectedRows();
				int[] temp = new int[selected.length];
				int optColumn = model.getColumnCount() - 1;
				boolean targetbool = false;
				int realcount = 0;
				for (int count=0; count<selected.length; count++) {
					if (((CellObject)(table.getValueAt(selected[0], optColumn))).isMail()) {
						targetbool = true;
						temp[realcount] = selected[count];
						++realcount;
					} 
				}
				if (realcount != 0) {
					selected = null;
					selected = new int[realcount];
					for (int count=0; count<realcount; count++) {
						selected[count] = temp[count];
					}
				}
				if (!targetbool) {
					dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
											 getString("DialogNotselectedTitle"),
											 dialog.WARNING_MESSAGE);
				} else if (selected.length > 1) {
					dialog.showMessageDialog(container, getString("DialogManyselectedInfoMessage"),
											 getString("DialogManyselectedTitle"),
											 dialog.WARNING_MESSAGE);
				} else {
					File fromFile = ((CellObject)(table.getValueAt(selected[0], optColumn))).getID();
					int[] path = ((CellObject)(table.getValueAt(selected[0], optColumn))).getAttachID();
					File targetFile = util.getTempFile();
					mail.savetoFile(targetFile, fromFile, path);
					infoPane.setTarget(targetFile);
					dialog.showMessageDialog(container, infoPane, 
											 getString("DialogInfoTitle"),
											 JOptionPane.INFORMATION_MESSAGE);
				}
			}
		});

		menu_ctr_return.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				model = (CustomTableModel)(table.getModel());
				int[] selected = table.getSelectedRows();
				int[] temp = new int[selected.length];
				int optColumn = model.getColumnCount() - 1;
				boolean targetbool = false;
				int realcount = 0;
				for (int count=0; count<selected.length; count++) {
					if (((CellObject)(table.getValueAt(selected[0], optColumn))).isMail()) {
						targetbool = true;
						temp[realcount] = selected[count];
						++realcount;
					} 
				}
				if (realcount != 0) {
					selected = null;
					selected = new int[realcount];
					for (int count=0; count<realcount; count++) {
						selected[count] = temp[count];
					}
				}
				if (!targetbool) {
					dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
											 getString("DialogNotselectedTitle"),
											 dialog.WARNING_MESSAGE);
				} else {
					File[] targetFile = new File[realcount];
					int[] path = null;
					File fromFile = null;
					for (int count=0; count<realcount; count++) {
						fromFile = ((CellObject)(table.getValueAt(selected[count], optColumn))).getID();
						path = ((CellObject)(table.getValueAt(selected[count], optColumn))).getAttachID();
						targetFile[count] = util.getTempFile();
						mail.savetoFile(targetFile[count], fromFile, path);
					}
					disp.buildReturnMail(targetFile);
				}
			}
		});

		menu_ctr_save.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				model = (CustomTableModel)(table.getModel());
				int[] selected = table.getSelectedRows();
				int optColumn = getOptColumn();
				if (selected.length == 0) {
					dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
											 getString("DialogNotselectedTitle"),
											 dialog.WARNING_MESSAGE);
				} else if (selected.length > 1) {
					dialog.showMessageDialog(container, getString("DialogManyselectedSaveMessage"),
											 getString("DialogManyselectedTitle"),
											 dialog.WARNING_MESSAGE);
				} else {
					JFileChooser chooser = new JFileChooser();
					chooser.setDialogTitle(getString("SaveDialogTitle"));
					chooser.setApproveButtonText(getString("SaveDialogButton"));
					File fromFile = ((CellObject)(table.getValueAt(selected[0], optColumn))).getID();
					int[] path = ((CellObject)(table.getValueAt(selected[0], optColumn))).getAttachID();
					chooser.setSelectedFile(new File(util.getHome(), mail.getFileName(fromFile, path)));
					int returnVal = chooser.showSaveDialog(container);
					File targetFile = chooser.getSelectedFile();
					if(returnVal == JFileChooser.APPROVE_OPTION) {
						mail.savetoFile(targetFile, fromFile, path);
					}
				}
			}
		});

		menu_ctr_move.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				model = (CustomTableModel)(table.getModel());
				int[] selected = table.getSelectedRows();
				int[] temp = new int[selected.length];
				int optColumn = getOptColumn();
				boolean targetbool = false;
				int realcount = 0;
				for (int count=0; count<selected.length; count++) {
					if (!((CellObject)(table.getValueAt(selected[0], optColumn))).isAttachments()) {
						targetbool = true;
						temp[realcount] = selected[count];
						++realcount;
					}
				}
				if (realcount != 0) {
					selected = null;
					selected = new int[realcount];
					for (int count=0; count<realcount; count++) {
						selected[count] = temp[count];
					}
				}
				if (!targetbool) {
					dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
											 getString("DialogNotselectedTitle"),
											 dialog.WARNING_MESSAGE);
				} else {
					try {
						JFileChooser chooser = new JFileChooser();
						chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
						chooser.setDialogTitle(getString("MoveDialogTitle"));
						chooser.setApproveButtonText(getString("MoveDialogButton"));
						chooser.setCurrentDirectory(util.getFromDir());
						int returnVal = chooser.showOpenDialog(container);
						if(returnVal == JFileChooser.APPROVE_OPTION) {
							File fromDir = 
								new File(((CellObject)(table.getValueAt(selected[0], optColumn))).getID().getParent());
							File targetDir = chooser.getSelectedFile();
							if (fromDir.getCanonicalPath().equals(targetDir.getCanonicalPath())) {
								dialog.showMessageDialog(container, getString("DialogSameDirMessage"),
														 getString("DialogSameDirTitle"),
														 dialog.WARNING_MESSAGE);
							} else {
								if (!(new File(targetDir, util.YUZU_CACHE)).exists()) {
									util.buildCache(targetDir);
								}
								int limit = selected.length;
								String[] deletes = new String[limit];
								File[] targets = new File[limit];
								int baseNumber = Integer.parseInt(util.getNextFile(targetDir).getName());	
								int currentNumber = baseNumber;
								File fromFile = null;
								File renameTo = null;
								for (int count=0; count<limit; count++) {
									fromFile = ((CellObject)(table.getValueAt(selected[count], optColumn))).getID();
									renameTo = new File(targetDir, Integer.toString(currentNumber));
									deletes[count] = fromFile.getName();
									targets[count] = renameTo;
									fromFile.renameTo(renameTo);
									++currentNumber;
								}
								for (int count=limit-1; count>=0; count--) {
									model.removeRow(selected[count]);
								}
								util.removefromCache(fromDir, deletes);
								util.addtoCache(targetDir, targets);
								closeAttach(null);
								disp.setNone();
							}
						}
					} catch(Exception exception) {
						trace(exception);
					}
				}
			}
		});
			
		menu_ctr_del.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				model = (CustomTableModel)(table.getModel());
				int[] selected = table.getSelectedRows();
				int[] temp = new int[selected.length];
				int optColumn = getOptColumn();
				boolean targetbool = false;
				int realcount = 0;
				for (int count=0; count<selected.length; count++) {
					if (!((CellObject)(table.getValueAt(selected[0], optColumn))).isAttachments()) {
						targetbool = true;
						temp[realcount] = selected[count];
						++realcount;
					}
				}
				if (realcount != 0) {
					selected = null;
					selected = new int[realcount];
					for (int count=0; count<realcount; count++) {
						selected[count] = temp[count];
					}
				}
				if (!targetbool) {
					dialog.showMessageDialog(container, getString("DialogNotselectedMessage"),
											 getString("DialogNotselectedTitle"),
											 dialog.WARNING_MESSAGE);
				} else if (selected.length == 1) {
					int ans = dialog.showConfirmDialog(container, getString("DialogDeleteMessage"),
							  getString("DialogDeleteTitle"),
							  dialog.OK_CANCEL_OPTION);
					if (ans == 0) {
						File target = ((CellObject)(table.getValueAt(selected[0], optColumn))).getID();
						util.removefromCache(new File(target.getParent()), target.getName());
						model.removeRow(selected[0]);
						target.delete();
						closeAttach(null);
						disp.setNone();
					}
				} else {
					int ans = dialog.showConfirmDialog(container, getString("DialogDeletesMessage"),
							  getString("DialogDeletesTitle"),
							  dialog.OK_CANCEL_OPTION);
					if (ans == 0) {
						scrollbar = scroll.getVerticalScrollBar();
						int scroll_position = (table.getRowHeight() + table.getRowMargin()) * selected[0];
						String[] targets = new String[selected.length];
						for (int count=0; count<selected.length; count++) {
							targets[count] = 
							  ((File)(((CellObject)(table.getValueAt(
                                     selected[count], optColumn))).getID())).getName();
						}
						File target = ((CellObject)(table.getValueAt(selected[0], optColumn))).getID();
						util.removefromCache(new File(target.getParent()), targets);
						for (int count=selected.length-1; count>=0; count--) {
							target = ((CellObject)(table.getValueAt(
												selected[count], optColumn))).getID();
							model.removeRow(selected[count]);
							target.delete();
						}
						closeAttach(null);
						if (scroll_position > 5) {
							scrollbar.setValue(scroll_position - table.getRowHeight() + table.getRowMargin());
						} else {
							scrollbar.setValue(0);
						}
						disp.setNone();
					}
				}
			}
		});

		menu_set_datestyle_full.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setDateStyle(DateFormat.FULL);
				int rowsnumber = ((int[])(table.getSelectedRows())).length;
				addFields(tree.getCurrentDir());
				disp.setDateStyle(DateFormat.FULL);
				resetSelectedRowfromMemory();
				if (rowsnumber == 1) disp.setMessageContent();
 				refresh();
			}
		});

		menu_set_datestyle_long.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setDateStyle(DateFormat.LONG);
				int rowsnumber = ((int[])(table.getSelectedRows())).length;
				addFields(tree.getCurrentDir());
				disp.setDateStyle(DateFormat.LONG);
				resetSelectedRowfromMemory();
				if (rowsnumber == 1) disp.setMessageContent();
 				refresh();
			}
		});

		menu_set_datestyle_medium.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setDateStyle(DateFormat.MEDIUM);
				int rowsnumber = ((int[])(table.getSelectedRows())).length;
				addFields(tree.getCurrentDir());
				disp.setDateStyle(DateFormat.MEDIUM);
				resetSelectedRowfromMemory();
				if (rowsnumber == 1) disp.setMessageContent();
 				refresh();
			}
		});

		menu_set_datestyle_short.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setDateStyle(DateFormat.SHORT);
				int rowsnumber = ((int[])(table.getSelectedRows())).length;
				addFields(tree.getCurrentDir());
				disp.setDateStyle(DateFormat.SHORT);
				resetSelectedRowfromMemory();
				if (rowsnumber == 1) disp.setMessageContent();
 				refresh();
			}
		});

		menu_set_tableindex_image.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolImage(!getBoolImage());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
 				refresh();
			}
		});

		menu_set_tableindex_subject.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolSubject(!getBoolSubject());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
 				refresh();
			}
		});

		menu_set_tableindex_to.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolTo(!getBoolTo());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
 				refresh();
			}
		});

		menu_set_tableindex_from.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolFrom(!getBoolFrom());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
 				refresh();
			}
		});

		menu_set_tableindex_date.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolDate(!getBoolDate());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
				refresh();
			}
		});

		menu_set_tableindex_cc.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolCc(!getBoolCc());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
				refresh();
			}
		});

		menu_set_tableindex_replyto.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolReplyto(!getBoolReplyto());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
				refresh();
			}
		});

		menu_set_tableindex_organization.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolOrganization(!getBoolOrganization());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
				refresh();
			}
		});

		menu_set_tableindex_messageid.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolMessageid(!getBoolMessageid());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
				refresh();
			}
		});

		menu_set_tableindex_contenttype.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolContenttype(!getBoolContenttype());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
				refresh();
			}

		});

		menu_set_tableindex_mailer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent even) {
				setSelectedRowToMemory();
				setBoolMailer(!getBoolMailer());
				checkImage();
				buildTable();
				addFields(tree.getCurrentDir());
				setLabels();
				resetSelectedRowfromMemory();
				refresh();
			}
		});
	}

	public void checkImage() {
		if (preiszero) {
			if (getBoolImage()) {
				setBoolImage(!getBoolImage());
				menu_set_tableindex_image.setSelected(false);
			} else {
				if (imageistrue) {
					setBoolImage(!getBoolImage());
					menu_set_tableindex_image.setSelected(true);
				}
				preiszero = false;
			}
		} else {
			if (getTableIndexes() == 1) {
				if (getBoolImage()) {
					setBoolImage(!getBoolImage());
					menu_set_tableindex_image.setSelected(false);
					preiszero = true;
					imageistrue = true;
				} else {
					imageistrue = false;
				}
			} else if (getTableIndexes() == 0) {
				preiszero = true;
			}
		}
	}

	public void addFields(File targetDir) {
		File cache = new File(targetDir, util.YUZU_CACHE);
		if (!cache.exists()) {
			util.buildCache(targetDir);
		}
		if (cache.exists() && util.getMails(targetDir) != null) {
			String line = null;
			String subject = null;
			String from = null;
			String to = null;
			String cc = null;
			Date   date = null;
			String replyto = null;
			String organization = null;
			String messageid = null;
			String contenttype = null;
			String mailer = null;
			File targetMail = null;

			CellObject Oimage = null;
			CellObject Osubject = null;
			CellObject Ofrom = null;
			CellObject Oto = null;
			CellObject Occ = null;
			CellObject Odate = null;
			CellObject Oreplyto = null;
			CellObject Oorganization = null;
			CellObject Omessageid = null;
			CellObject Ocontenttype = null;
			CellObject Omailer = null;
			boolean mimebool = false;

			int limit = 0;
			String orgID = null;
			String ID = null;
			TableColumn column = null;
			Vector additiondata = null;
			try {
				BufferedReader input 
					= new BufferedReader(new FileReader(cache));
				line = input.readLine();
				deleteRows();
				while (line != null) {
					if (!line.trim().equals("")) {
						targetMail = new File(targetDir, line.trim());
						line = input.readLine();
						while (!line.trim().equals("")) {
							line = line.trim();
							if (line.startsWith("subject:")) {
								subject = line.substring(8, line.length()).trim();
								if (subject.equals("")) subject = getString("NoHeader");
							} else if (line.startsWith("from:")) {
								from = line.substring(5, line.length()).trim();
								if (from.equals("")) from = getString("NoHeader");
							} else if (line.startsWith("to:")) {
								to = line.substring(3, line.length()).trim();
								if (to.equals("")) to = getString("NoHeader");
							} else if (line.startsWith("cc:")) {
								cc = line.substring(3, line.length()).trim();
								if (cc.equals("")) cc = getString("NoHeader");
							} else if (line.startsWith("date:")) {
								date = new Date(Long.parseLong(line.substring(5, line.length()).trim()));
							} else if (line.startsWith("replyto:")) {
								replyto = line.substring(8, line.length()).trim();
								if (replyto.equals("")) replyto = getString("NoHeader");
							} else if (line.startsWith("organization:")) {
								organization = line.substring(13, line.length()).trim();
								if (organization.equals("")) organization = getString("NoHeader");
							} else if (line.startsWith("messageid:")) {
								messageid = line.substring(10, line.length()).trim();
								if (messageid.equals("")) messageid = getString("NoHeader");
							} else if (line.startsWith("contenttype:")) {
								contenttype = line.substring(12, line.length()).trim();
								if (contenttype.equals("")) contenttype = getString("NoHeader");
							} else if (line.startsWith("mailer:")) {
								mailer = line.substring(7, line.length()).trim();
								if (mailer.equals("")) mailer = getString("NoHeader");
							} 
							line = input.readLine();
						}
					}
					String sdate = DateFormat.getDateInstance(getDateStyle(), 
											  getCurrentLocale() ).format(date);
					mimebool = false;
					try {
						if ((contenttype.substring(0, 9)).equalsIgnoreCase("Multipart")) {
							mimebool = true;
						} 
					} catch(Exception exception) {} 
					
					Osubject      = new CellObject(subject,      targetMail, mimebool);
					Oto           = new CellObject(to,           targetMail, mimebool);
					Ofrom         = new CellObject(from,         targetMail, mimebool);
					Odate         = new CellObject(sdate,        targetMail, mimebool);
					Occ           = new CellObject(cc,           targetMail, mimebool);
					Oreplyto      = new CellObject(replyto,      targetMail, mimebool);
					Oorganization = new CellObject(organization, targetMail, mimebool);
					Omessageid    = new CellObject(messageid,    targetMail, mimebool);
					Ocontenttype  = new CellObject(contenttype,  targetMail, mimebool);
					Omailer       = new CellObject(mailer,       targetMail, mimebool);

					model = (CustomTableModel)(table.getModel());
					limit = model.getColumnCount();
					additiondata = new Vector();
					
					model = (CustomTableModel)(table.getModel());
					table.setModel(model);
					int rowcount = model.getRowCount();
					model.addRow(additiondata);
					for (int count=0; count<limit; count++) {
						columnmodel = (DefaultTableColumnModel)(table.getColumnModel());
						column = columnmodel.getColumn(count);
						orgID = (String)(column.getIdentifier());
						ID = getTableIndex(getCurrentNumberofIndex(getTableIndex(getNumberofIndex(orgID))));
						if (orgID.equals("image")) {
							column.setMaxWidth(50);
							column.setMinWidth(50);
							column.setPreferredWidth(50);
						} else if (orgID.equals("date")) {
							if (getDateStyle() == DateFormat.SHORT) {
								column.setMaxWidth(70);
								column.setMinWidth(70);
								column.setPreferredWidth(70);
							} else if (getDateStyle() == DateFormat.MEDIUM) {
								column.setMaxWidth(90);
								column.setMinWidth(90);
								column.setPreferredWidth(90);
							} else if (getDateStyle() == DateFormat.LONG) {
								column.setMaxWidth(90);
								column.setMinWidth(90);
								column.setPreferredWidth(90);
							} else if (getDateStyle() == DateFormat.FULL) {
								column.setMaxWidth(110);
								column.setMinWidth(110);
								column.setPreferredWidth(110);
							}
						}
						if (ID.equals("image")) {
							if (mimebool) model.setValueAt(mailsIcon, rowcount, count);
							else          model.setValueAt(mailIcon,  rowcount, count);
						} else if (ID.equals("subject")) {
							model.setValueAt(Osubject, rowcount, count);
						} else if (ID.equals("to")) {
							model.setValueAt(Oto, rowcount, count);
						} else if (ID.equals("from")) {
							model.setValueAt(Ofrom, rowcount, count);
						} else if (ID.equals("date")) { 
							model.setValueAt(Odate, rowcount, count);
						} else if (ID.equals("cc")) { 
							model.setValueAt(Occ, rowcount, count);
						} else if (ID.equals("replyto")) { 
							model.setValueAt(Oreplyto, rowcount, count);
						} else if (ID.equals("organization")) { 
							model.setValueAt(Oorganization, rowcount, count);
						} else if (ID.equals("messageid")) { 
							model.setValueAt(Omessageid, rowcount, count);
						} else if (ID.equals("contenttype")) { 
							model.setValueAt(Ocontenttype, rowcount, count);
						} else if (ID.equals("mailer")) { 
							model.setValueAt(Omailer, rowcount, count);
						} 
					}
					line = input.readLine();
				}
				refresh();
			} catch (Exception exception) {
				trace(exception);
			}
		}
	}

	public void deleteRows() {
		try {
			model = (CustomTableModel)(table.getModel());
			int limit = model.getRowCount();
			for (int count=0; count<limit; count++) {
				model.removeRow(0);
			}
		} catch(Exception exception) {}
	}

	private void closeAttach(int[] IDs) {
		try {
			model = (CustomTableModel)(table.getModel());
			int optColumn = getOptColumn();
			int limit = model.getRowCount();
			if (IDs == null) {
				for (int count=0; count<limit; count++) {
					if (((CellObject)(table.getValueAt(count, optColumn))).isAttachments()) {
						model.removeRow(count);
						--limit;
						--count;
					}
				}
			} else {
				int depth = IDs.length;
				int[] check = null;
				for (int count=0; count<limit; count++) {
					if (((CellObject)(table.getValueAt(count, optColumn))).isAttachments()) {
						check = ((CellObject)(table.getValueAt(count, optColumn))).getAttachID();
						if (check.length > depth) {
							model.removeRow(count);
							--limit;
							--count;
						}
					}
				}
			}
		} catch (Exception exception) {
			exception.printStackTrace();			
		}
	}

	private int getOptColumn() {
		int limit = 0;
		int count=0;
		try {
			limit = model.getColumnCount();
			while (count < limit) {
				if (table.getValueAt(0, count) instanceof CellObject) break;
				++count;
			}
		} 
		catch (ArrayIndexOutOfBoundsException exception) {}
		catch (Exception exception) {
			trace(exception);
		}
		if (count == limit) {
			return (-1);
		}
		return count;
	}

	public void addField(File targetFile) {
	}

	public boolean isEmpty() {
		if (model.getRowCount() == 0) return (true);
		return false;
	}

	public boolean removeField(File file) {
		int limit = model.getRowCount();
		int column = 0;
		CellObject obj = null;
		for (int row=0; row<limit; row++) {
			column = getOptColumn();
			obj = (CellObject)(table.getValueAt(row, column));
			try {
				if (obj.getID().getCanonicalPath().equals(file.getCanonicalPath())) {
					model.removeRow(row);
					return (true);
				}
			} catch (Exception exception) {
				trace(exception);
			}
		}
		return (false);
	}

	public void setSelectedRowToMemory() {
		selectedRowsMemory = table.getSelectedRows();
	}

	public void resetSelectedRowfromMemory() {
		try {
			int limit = selectedRowsMemory.length;
			for (int count=0; count<limit; count++) {
				table.setRowSelectionInterval(selectedRowsMemory[count], selectedRowsMemory[count]);
			}
		} catch (Exception exception) {}
	}
}
