/*
 * @(#)Build.java	0.002 1999/11/16
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.tree;

import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;


class Build extends Components {
	Build() {
 		root.setUserObject( new NodeObject(rootdir,  getString("RootName")));
		inbox.setUserObject(new NodeObject(inboxdir, getString("InboxName")));
		from.setUserObject( new NodeObject(fromdir,  getString("FromName")));
		draft.setUserObject(new NodeObject(draftdir, getString("DraftName")));
		trash.setUserObject(new NodeObject(trashdir, getString("TrashName")));	

  		setLabels();

		menu_file_add.setIcon(addIcon);
		menu_file_delete.setIcon(deleteIcon);
		menu_file_rename.setIcon(renameIcon);
		menu_file_move.setIcon(moveIcon);

		menu_file.add(menu_file_add);
		menu_file.addSeparator();
		menu_file.add(menu_file_move);
		menu_file.add(menu_file_rename);
		menu_file.addSeparator();
		menu_file.add(menu_file_delete);
		menubar.add(menu_file);
		pane.add(menubar, BorderLayout.NORTH);

		root.add(inbox);
		root.add(draft);
		root.add(from);
		root_path = new TreePath(root.getPath());
		inbox_path = new TreePath(inbox.getPath());
		draft_path = new TreePath(draft.getPath());
		from_path = new TreePath(from.getPath());
		treeRenderer.setLeafIcon(nodeIcon);
		treeRenderer.setClosedIcon(hasNodeIcon);
		treeRenderer.setOpenIcon(openedNodeIcon);
		tree.setCellEditor(treeEditor);
		tree.setEditable(false);
		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		tree.setCellRenderer(treeRenderer);
		tree.putClientProperty("JTree.lineStyle", "Angled");
		tree.setRootVisible(true);
		tree.setShowsRootHandles(false);

		scroll.setViewportView(tree);

		this.add(scroll, BorderLayout.CENTER);
	}

	public void setLabels() {
		menu_file_add.setLabel(getString("menu_file_add"));
		menu_file_delete.setLabel(getString("menu_file_delete"));
		menu_file_rename.setLabel(getString("menu_file_rename"));
		menu_file_move.setLabel(getString("menu_file_move"));
		menu_file.setLabel(getString("menu_file"));

		((NodeObject)( root.getUserObject())).setName(getString("RootName"));
		((NodeObject)(inbox.getUserObject())).setName(getString("InboxName"));
		((NodeObject)( from.getUserObject())).setName(getString("FromName"));
		((NodeObject)(draft.getUserObject())).setName(getString("DraftName"));
		((NodeObject)(trash.getUserObject())).setName(getString("TrashName"));

 		addNodes(inbox);
 		addNodes(from);
 		addNodes(draft);
 		addNodes(trash);
	}

	protected static void addNodes(DefaultMutableTreeNode node) {
 		if (node.getChildCount() < 2) {
			node.removeAllChildren();
			try {
				File targetDir = ((NodeObject)node.getUserObject()).getFile();
				Vector Dirs = util.getDirsAsVector(targetDir);
				int limit = Dirs.size();
				for (int count=limit-1; count>=0; count--) {
					treemodel.insertNodeInto(new DefaultMutableTreeNode
							   (new NodeObject((File)(Dirs.elementAt(count)))), node, 0);
				}
			}
			catch(Exception exception) {}
 		}
	}

	protected static void addDummyNodes(DefaultMutableTreeNode node) {
		if (node.getChildCount() == 0) {
			try {
				treemodel.insertNodeInto(new DefaultMutableTreeNode
										 (new NodeObject(new File(sp+"DummuyFile"))), node, 0);		
			}
			catch(Exception exception) {}
		}
	}
}
