/*
 * @(#)POP3Object.java   0.001 2000/01/31
 *
 * Copyright (c) 1999- by Daichi T.GOTO. All Rights Reserved.
 *
 */
package yuzu.util;

import java.io.*;
import java.util.*;


public class StatusHoldObject {
	private static File statusholdFile = null;
	private static Hashtable hashtable = new Hashtable();

	private static final int defautl_window_size_x = 640;
	private static final int defautl_window_size_y = 480;
	
	public StatusHoldObject() {}

	public void read(File targetFile) {
		statusholdFile = targetFile;
		try {
			BufferedReader input = new BufferedReader(new FileReader(statusholdFile));
			String buffer = input.readLine();
			while (buffer != null) {
				buffer = buffer.trim();
				if (!buffer.startsWith("#") && buffer.indexOf(":") != -1) {
					hashtable.put(buffer.substring(0, buffer.indexOf(":")).trim(), 
								  buffer.substring(buffer.indexOf(":")+1, buffer.length()).trim());
				}
				buffer = input.readLine();
			}
		} catch (Exception exception) {
			exception.printStackTrace();
		}
	}

	public void save() {
		File newstatusholdFile = new File(statusholdFile.getPath());
		statusholdFile.renameTo(new File(statusholdFile.getParent(), 
										 "." + statusholdFile.getName() + ".old"));
		statusholdFile = newstatusholdFile;
		try {
			BufferedWriter output = new BufferedWriter(new FileWriter(statusholdFile));
			Enumeration enumeration = hashtable.keys();
			String key = null;
			while (enumeration.hasMoreElements()) {
				key = (String)enumeration.nextElement();
				output.write(key);
				output.write(": ");
				output.write((String)hashtable.get(key));
				output.newLine();
			}
			output.flush();
			output.close();
		} catch (Exception exception) {
			exception.printStackTrace();
		}
	}

	public int getWindowSizeX() {
		String value = (String)hashtable.get("window_size_x");
		int returnvalue = defautl_window_size_x;
		if (value != null) {
			try {
				returnvalue = Integer.parseInt(value.trim());
			} catch (Exception exception) {
				System.out.println("YUZU: WARNING: The value of window_size_x is wrong: " + value);
				returnvalue = defautl_window_size_x;
			}
		}
		return (returnvalue);
	}

	public int getWindowSizeY() {
		String value = (String)hashtable.get("window_size_y");
		int returnvalue = defautl_window_size_y;
		if (value != null) {
			try {
				returnvalue = Integer.parseInt(value.trim());
			} catch (Exception exception) {
				System.out.println("YUZU: WARNING: The value of window_size_x is wrong: " + value);
				returnvalue = defautl_window_size_y;
			}
		}
		return (returnvalue);
	}

	public void setWindowSizeX(int x) {
		hashtable.put("window_size_x",  Integer.toString(x));
	}

	public void setWindowSizeY(int y) {
		hashtable.put("window_size_y",  Integer.toString(y));
	}
}
