#!/bin/sh
#
## yuzu.sh -- nicer running program for Yuzu
#
## Author         Daichi T.GOTO daichi@ongs.gr.jp
## First Date     Tue Apr  4 13:59:45 2000
## Last Modified  Fri Jan 26 19:59:27 2001
#

# Symlink check
program=$0;
while [ -L "$program" ]; do
    ls=`/bin/ls -ld "$program"`
    program=`expr "$ls" : '.*-> \(.*\)$'`
done

# Change to work directory
workdir=`dirname "$program"`
cd $workdir

# Set default classes
yuzupath=`dirname "$workdir"`
activation="$workdir"/activation.jar
javamail="$workdir"/mail.jar
pop3="$workdir"/pop3.jar
baseclasses="$yuzupath":"$workdir":"$activation":"$javamail":"$pop3"

# Java version switch
if [ !CLASSPATH ]; then
    if [ -d /usr/local/jdk1.1.8 ]; then
	    baseclasses=/usr/local/jdk1.1.8/lib/classes.zip:"$baseclasses"
	elif [ -d /usr/local/jdk1.1.7 ]; then
	    baseclasses=/usr/local/jdk1.1.7/lib/classes.zip:"$baseclasses"
	elif [ -d /usr/local/jdk1.1.6 ]; then
	    baseclasses=/usr/local/jdk1.1.6/lib/classes.zip:"$baseclasses"
	elif [ -d /usr/local/jdk1.1.5 ]; then
	    baseclasses=/usr/local/jdk1.1.5/lib/classes.zip:"$baseclasses"
	elif [ -d /usr/local/jdk1.1 ]; then
	    baseclasses=/usr/local/jdk1.1/lib/classes.zip:"$baseclasses"
	else
	    baseclasses="$baseclasses"
	fi
    else
	baseclasses="$CLASSPATH":"$baseclasses"
    fi
    check=`echo "$baseclasses" | grep swing.jar`
    if [ "$check" = "" ]; then
	for file in `/bin/ls /usr/local/share/java/classes/jfc*/*.jar 2> /dev/null`
	do
	    baseclasses="$baseclasses":$file
	done
fi

unset JAVA_COMPILER

PATH=/usr/local/jdk1.1.8/bin/:$PATH
export PATH
JAVA_HOME=/usr/local/jdk1.1.8/
export JAVA_HOME

echo java -classpath "$baseclasses" yuzu.Yuzu
exec java -classpath "$baseclasses" yuzu.Yuzu 

